/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novells prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 1994 - 2007 Novell, Inc.  All rights reserved.

May 8, 2007
//+==========================================================================+
//| Source module name: cierror.h                                            |
//+==========================================================================+
//|$Author:   dtaylor $              $Locker$
//|$Revision:   1.16  $            $Name$ $State$
//|$Date:   27 Jul 2007 10:07:06  $
//+==========================================================================+
*/
/* Inclusion Control */
#if !defined( CIERROR_H )
   #define CIERROR_H

   #ifdef HAVE_CONFIG_H
      #include "IPRNT_config.h"
   #endif

/* Standard Library Header Includes */

/* Header Includes */

/* Manifest Constant Definitions */

   /*
   // Error codes that have translations to specific errors are commented
   // in the list below and defined separately for each of the platforms
   // below the main list.
   */
   #define CI_ERR_SUCCESS                             0  /* 0x00000000 */
   #define CI_ERR_WARNING                             1  /* 0x00000001 */
   #define CI_ERR_FAILURE                            -1  /* 0xFFFFFFFF */

   #define CI_ERR_BASE                 0x43690000L       /* "Ci\0\0"   */

   #define CI_ERR_INVALID_INTERNAL_OP  (CI_ERR_BASE+  1) /* 0x43690001 */
   #define CI_ERR_OUT_OF_MEMORY        (CI_ERR_BASE+  2) /* 0x43690002 */
   #define CI_ERR_TRANSLATE_FAILED     (CI_ERR_BASE+  3) /* 0x43690003 */
   #define CI_ERR_MUTEX_INVALID        (CI_ERR_BASE+  4) /* 0x43690004 */
   #define CI_ERR_MUTEX_DEADLOCK       (CI_ERR_BASE+  5) /* 0x43690005 */
   #define CI_ERR_MUTEX_NOT_OWNER      (CI_ERR_BASE+  6) /* 0x43690006 */
   #define CI_ERR_MUTEX_LOCKED         (CI_ERR_BASE+  7) /* 0x43690007 */
   #define CI_ERR_SEM4_INVALID         (CI_ERR_BASE+  8) /* 0x43690008 */
   #define CI_ERR_SEM4_WOULD_BLOCK     (CI_ERR_BASE+  9) /* 0x43690009 */
   #define CI_ERR_COMPARE_RESULT_NE    (CI_ERR_BASE+ 10) /* 0x4369000A */
   #define CI_ERR_COMPARE_RESULT_LT    (CI_ERR_BASE+ 11) /* 0x4369000B */
   #define CI_ERR_COMPARE_RESULT_GT    (CI_ERR_BASE+ 12) /* 0x4369000C */
   #define CI_ERR_UNKNOWN_CALLBACK_ERR (CI_ERR_BASE+ 13) /* 0x4369000D */
   #define CI_ERR_CANCEL_LIST          (CI_ERR_BASE+ 14) /* 0x4369000E */
   #define CI_ERR_NO_SUCH_FILE_OR_DIR  (CI_ERR_BASE+ 15) /* 0x4369000F */
   #define CI_ERR_FILE_ACCESS_DENIED   (CI_ERR_BASE+ 16) /* 0x43690010 */
   #define CI_ERR_FILE_OPEN_FAIL       (CI_ERR_BASE+ 18) /* 0x43690012 */
   #define CI_ERR_FILE_CLOSE_FAIL      (CI_ERR_BASE+ 19) /* 0x43690013 */
   #define CI_ERR_FILE_TRUNCATE_FAIL   (CI_ERR_BASE+ 20) /* 0x43690014 */
   #define CI_ERR_FILE_DELETE_FAIL     (CI_ERR_BASE+ 21) /* 0x43690015 */
   #define CI_ERR_FILE_READ_FAIL       (CI_ERR_BASE+ 22) /* 0x43690016 */
   #define CI_ERR_FILE_SEEK_FAIL       (CI_ERR_BASE+ 23) /* 0x43690017 */
   #define CI_ERR_FILE_WRITE_FAIL      (CI_ERR_BASE+ 24) /* 0x43690018 */
// #define CI_ERR_                     (CI_ERR_BASE+ 25) /* 0x43690019 */
// #define CI_ERR_                     (CI_ERR_BASE+ 26) /* 0x4369001A */

   #define CI_ERR_INVALID_OPERATOR_BASE  (CI_ERR_BASE+ 0xE000)

   #define CI_ERR_INVALID_OPERATOR_IN_POS1 (CI_ERR_INVALID_OPERATOR_BASE+ 1) /* 0x4369E001 */
   #define CI_ERR_INVALID_OPERATOR_IN_POS2 (CI_ERR_INVALID_OPERATOR_BASE+ 2) /* 0x4369E002 */
   #define CI_ERR_INVALID_OPERATOR_IN_POS3 (CI_ERR_INVALID_OPERATOR_BASE+ 3) /* 0x4369E003 */
   #define CI_ERR_INVALID_OPERATOR_IN_POS4 (CI_ERR_INVALID_OPERATOR_BASE+ 4) /* 0x4369E004 */
   #define CI_ERR_INVALID_OPERATOR_IN_POS5 (CI_ERR_INVALID_OPERATOR_BASE+ 5) /* 0x4369E005 */

   #define CI_ERR_PARM_VAL_UNRECOG_BASE  (CI_ERR_BASE+ 0xFFE0)

   #define CI_ERR_PARAM_X_VAL_UNRECOGNIZED (CI_ERR_PARM_VAL_UNRECOG_BASE+ 0) /* 0x4369FFE0 */
   #define CI_ERR_PARAM_1_VAL_UNRECOGNIZED (CI_ERR_PARM_VAL_UNRECOG_BASE+ 1) /* 0x4369FFE1 */
   #define CI_ERR_PARAM_2_VAL_UNRECOGNIZED (CI_ERR_PARM_VAL_UNRECOG_BASE+ 2) /* 0x4369FFE2 */
   #define CI_ERR_PARAM_3_VAL_UNRECOGNIZED (CI_ERR_PARM_VAL_UNRECOG_BASE+ 3) /* 0x4369FFE3 */
   #define CI_ERR_PARAM_4_VAL_UNRECOGNIZED (CI_ERR_PARM_VAL_UNRECOG_BASE+ 4) /* 0x4369FFE4 */
   #define CI_ERR_PARAM_5_VAL_UNRECOGNIZED (CI_ERR_PARM_VAL_UNRECOG_BASE+ 5) /* 0x4369FFE5 */
   #define CI_ERR_PARAM_6_VAL_UNRECOGNIZED (CI_ERR_PARM_VAL_UNRECOG_BASE+ 6) /* 0x4369FFE6 */

   #define CI_ERR_INVALID_PARM_BASE  (CI_ERR_BASE+ 0xFFF0)

   #define CI_ERR_INVALID_PARAM_X    (CI_ERR_INVALID_PARM_BASE+ 0) /* 0x4369FFF0 */
   #define CI_ERR_INVALID_PARAM_1    (CI_ERR_INVALID_PARM_BASE+ 1) /* 0x4369FFF1 */
   #define CI_ERR_INVALID_PARAM_2    (CI_ERR_INVALID_PARM_BASE+ 2) /* 0x4369FFF2 */
   #define CI_ERR_INVALID_PARAM_3    (CI_ERR_INVALID_PARM_BASE+ 3) /* 0x4369FFF3 */
   #define CI_ERR_INVALID_PARAM_4    (CI_ERR_INVALID_PARM_BASE+ 4) /* 0x4369FFF4 */
   #define CI_ERR_INVALID_PARAM_5    (CI_ERR_INVALID_PARM_BASE+ 5) /* 0x4369FFF5 */
   #define CI_ERR_INVALID_PARAM_6    (CI_ERR_INVALID_PARM_BASE+ 6) /* 0x4369FFF6 */
   #define CI_ERR_INVALID_PARAM_7    (CI_ERR_INVALID_PARM_BASE+ 7) /* 0x4369FFF7 */
   #define CI_ERR_INVALID_PARAM_8    (CI_ERR_INVALID_PARM_BASE+ 8) /* 0x4369FFF8 */
   #define CI_ERR_INVALID_PARAM_9    (CI_ERR_INVALID_PARM_BASE+ 9) /* 0x4369FFF9 */
   #define CI_ERR_INVALID_PARAM_10   (CI_ERR_INVALID_PARM_BASE+10) /* 0x4369FFFA */
   #define CI_ERR_INVALID_PARAM_11   (CI_ERR_INVALID_PARM_BASE+11) /* 0x4369FFFB */

   /*
   // Now we will redefine the errors that are platform specific.
   */
#if defined(N_PLAT_MSW4)
   #include <ciermsw.h>
#elif defined(N_PLAT_NLM)
   #include <ciernlm.h>
#elif defined(N_PLAT_UNIX)
   #include <cierunx.h>
#endif

   /*
   // AttrSetxxxx() calls return these errors that are unique to these
   // calls.
   */
   #define AS_ERR_BASE                    0x41730000L       /* "As\0\0"   */

   #define AS_ERR_NOT_IN_SET              (AS_ERR_BASE+ 1)  /* 0x41730001 */
   #define AS_ERR_VALUE_NOT_FOUND         (AS_ERR_BASE+ 2)  /* 0x41730002 */
   #define AS_ERR_BAD_NTFY_DELRY_ADDR     (AS_ERR_BASE+ 3)  /* 0x41730003 */
   #define AS_ERR_BAD_NAME_OR_OID         (AS_ERR_BASE+ 4)  /* 0x41730004 */
   #define AS_ERR_BAD_CARDORNAMEOROID     (AS_ERR_BASE+ 5)  /* 0x41730005 */
   #define AS_ERR_BAD_CARDINAL_OR_OID     (AS_ERR_BASE+ 6)  /* 0x41730006 */
   #define AS_ERR_BAD_COLORANT_SET        (AS_ERR_BASE+ 7)  /* 0x41730007 */
   #define AS_ERR_NOT_SUPPORTED           (AS_ERR_BASE+ 8)  /* 0x41730008 */
   #define AS_ERR_BAD_DELIVERY_ADDR       (AS_ERR_BASE+ 9)  /* 0x41730009 */
   #define AS_ERR_BAD_DIMENSION           (AS_ERR_BASE+ 10) /* 0x4173000A */
   #define AS_ERR_BAD_DOC_CONTENT         (AS_ERR_BASE+ 11) /* 0x4173000B */
   #define AS_ERR_BAD_IGNORED_ATTR        (AS_ERR_BASE+ 12) /* 0x4173000C */
   #define AS_ERR_BAD_LOCATIONS           (AS_ERR_BASE+ 13) /* 0x4173000D */
   #define AS_ERR_BAD_MEDIUM_SRC_SIZE     (AS_ERR_BASE+ 14) /* 0x4173000E */
   #define AS_ERR_BAD_PAGE_SELECT         (AS_ERR_BASE+ 15) /* 0x4173000F */
   #define AS_ERR_BAD_PAGE_MEDIA_SLCT     (AS_ERR_BASE+ 16) /* 0x41730010 */
   #define AS_ERR_BAD_PAGE_SIZE           (AS_ERR_BASE+ 17) /* 0x41730011 */
   #define AS_ERR_BAD_POS_INT_OR_OID      (AS_ERR_BASE+ 18) /* 0x41730012 */
   #define AS_ERR_BAD_QUALIFIED_NAME      (AS_ERR_BASE+ 19) /* 0x41730013 */
   #define AS_ERR_BAD_RESOURCE            (AS_ERR_BASE+ 20) /* 0x41730014 */
   #define AS_ERR_BAD_XY_DIMENSNS_VAL     (AS_ERR_BASE+ 21) /* 0x41730015 */
   #define AS_ERR_BAD_ADDRESS_ITEM        (AS_ERR_BASE+ 22) /* 0x41730016 */
   #define AS_ERR_BAD_DISTNAME_STRSEQ     (AS_ERR_BASE+ 23) /* 0x41730017 */
   #define AS_ERR_BAD_EVENT_OBJ_ITEM      (AS_ERR_BASE+ 24) /* 0x41730018 */
   #define AS_ERR_BAD_EVENT_OBJ_SET       (AS_ERR_BASE+ 25) /* 0x41730019 */
   #define AS_ERR_BAD_IDENTIFIER_SET      (AS_ERR_BASE+ 26) /* 0x4173001A */
   #define AS_ERR_BAD_NAME_OR_OID_SET     (AS_ERR_BASE+ 27) /* 0x4173001B */
   #define AS_ERR_BAD_PAGE_SELECT_SEQ     (AS_ERR_BASE+ 28) /* 0x4173001C */
   #define AS_ERR_BAD_PRT_CNT_OBJ_SET     (AS_ERR_BASE+ 29) /* 0x4173001D */
   #define AS_ERR_BAD_QUALIFIEDNMESET     (AS_ERR_BASE+ 30) /* 0x4173001E */
   #define AS_ERR_BAD_RDN_SEQUENCE        (AS_ERR_BASE+ 31) /* 0x4173001F */
   #define AS_ERR_BAD_RESRCE_CNTXTSEQ     (AS_ERR_BASE+ 32) /* 0x41730020 */
   #define AS_ERR_BAD_RESOURCE_PRT_ID     (AS_ERR_BASE+ 33) /* 0x41730021 */
   #define AS_ERR_BAD_NMBRS_UP_SPPRTD     (AS_ERR_BASE+ 34) /* 0x41730022 */
   #define AS_ERR_BAD_OBJECT_IDENT        (AS_ERR_BASE+ 35) /* 0x41730023 */
   #define AS_ERR_OID_INVALID_ASN1_TYPE   (AS_ERR_BASE+ 36) /* 0x41730024 */
   #define AS_ERR_OID_NOT_IN_SET          (AS_ERR_BASE+ 37) /* 0x41730025 */
   #define AS_ERR_OID_ALREADY_IN_SET      (AS_ERR_BASE+ 38) /* 0x41730026 */
   #define AS_ERR_OID_NOT_IN_DATABASE     (AS_ERR_BASE+ 39) /* 0x41730027 */
   #define AS_ERR_OID_IS_OBJECT_CLASS     (AS_ERR_BASE+ 40) /* 0x41730028 */
   #define AS_ERR_OID_IS_VALUE_CLASS      (AS_ERR_BASE+ 41) /* 0x41730029 */
   #define AS_ERR_OID_IS_VALUE            (AS_ERR_BASE+ 42) /* 0x4173002A */
   #define AS_ERR_INVALID_FILE_FORMAT     (AS_ERR_BASE+ 43) /* 0x4173002B */
   #define AS_ERR_OID_ENUM_XLAT_NOT_FOUND (AS_ERR_BASE+ 44) /* 0x4173002C */
   #define AS_ERR_OID_MSTR_IDX_NOT_FOUND  (AS_ERR_BASE+ 45) /* 0x4173002D */

   /********* Start PSM error codes ***************************************/

   #define PM_ERR_BASE                    0x506D0000        /* "Pm\0\0"   */

   #define NDPS_E_NO_MEMORY               (PM_ERR_BASE+  1) /* 0x506D0001 */
   #define NDPS_E_MEMORY_NOT_FOUND        (PM_ERR_BASE+  2) /* 0x506D0002 */
   #define NDPS_E_JOB_STORAGE_LIMIT       (PM_ERR_BASE+  3) /* 0x506D0003 */
   #define NDPS_E_JOB_RETENTION_LIMIT     (PM_ERR_BASE+  4) /* 0x506D0004 */
   #define NDPS_E_UNSUPPORTED_TYPE        (PM_ERR_BASE+  5) /* 0x506D0005 */
   #define NDPS_E_UNDEFINED_TYPE          (PM_ERR_BASE+  6) /* 0x506D0006 */
   #define NDPS_E_UNSUPPORTED_OP          (PM_ERR_BASE+  7) /* 0x506D0007 */
   #define NDPS_E_ACCESSING_DB            (PM_ERR_BASE+  8) /* 0x506D0008 */
   #define NDPS_E_NO_GW                   (PM_ERR_BASE+  9) /* 0x506D0009 */
   #define NDPS_E_INVALID_CLASS           (PM_ERR_BASE+ 10) /* 0x506D000A */
   #define NDPS_E_BAD_PARAMETER           (PM_ERR_BASE+ 11) /* 0x506D000B */
   #define NDPS_E_OBJECT_NOT_FOUND        (PM_ERR_BASE+ 12) /* 0x506D000C */
   #define NDPS_E_ATTRIBUTE_NOT_FOUND     (PM_ERR_BASE+ 13) /* 0x506D000D */
   #define NDPS_E_VALUE_NOT_FOUND         (PM_ERR_BASE+ 14) /* 0x506D000E */
   #define NDPS_E_VALUES_NOT_COMPARABLE   (PM_ERR_BASE+ 15) /* 0x506D000F */
   #define NDPS_E_INVALID_VALUE_SYNTAX    (PM_ERR_BASE+ 16) /* 0x506D0010 */
   #define NDPS_E_JOB_NOT_FOUND           (PM_ERR_BASE+ 17) /* 0x506D0011 */
   #define NDPS_E_COMMUNICATION           (PM_ERR_BASE+ 18) /* 0x506D0012 */
   #define NDPS_E_PA_INITIALIZING         (PM_ERR_BASE+ 19) /* 0x506D0013 */
   #define NDPS_E_PA_GOING_DOWN           (PM_ERR_BASE+ 20) /* 0x506D0014 */
   #define NDPS_E_PA_DISABLED             (PM_ERR_BASE+ 21) /* 0x506D0015 */
   #define NDPS_E_PA_PAUSED               (PM_ERR_BASE+ 22) /* 0x506D0016 */
   #define NDPS_E_BAD_PA_HANDLE           (PM_ERR_BASE+ 23) /* 0x506D0017 */
   #define NDPS_E_OBJECT_NOT_LOCKED       (PM_ERR_BASE+ 24) /* 0x506D0018 */
   #define NDPS_E_VERSION_INCOMPATIBLE    (PM_ERR_BASE+ 25) /* 0x506D0019 */
   #define NDPS_E_PSM_INITIALIZING        (PM_ERR_BASE+ 26) /* 0x506D001A */
   #define NDPS_E_PSM_GOING_DOWN          (PM_ERR_BASE+ 27) /* 0x506D001B */
   #define NDPS_E_NOTIF_SVC_ERROR         (PM_ERR_BASE+ 28) /* 0x506D001C */
   #define NDPS_E_MEDIUM_NEEDS_MOUNTED    (PM_ERR_BASE+ 29) /* 0x506D001D */
   #define NDPS_E_GW_NOT_RESPONDING       (PM_ERR_BASE+ 30) /* 0x506D001E */
   #define NDPS_E_SESSION_NOT_FOUND       (PM_ERR_BASE+ 31) /* 0x506D001F */
   #define NDPS_E_RPC_FAILURE             (PM_ERR_BASE+ 32) /* 0x506D0020 */
   #define NDPS_E_DUPLICATE_VALUE         (PM_ERR_BASE+ 33) /* 0x506D0021 */
   #define NDPS_E_NO_MANDATORY_ATTR       (PM_ERR_BASE+ 34) /* 0x506D0022 */
   #define NDPS_E_ALREADY_ATTACHED        (PM_ERR_BASE+ 35) /* 0x506D0023 */
   #define NDPS_E_CANT_ATTACH             (PM_ERR_BASE+ 36) /* 0x506D0024 */
   #define NDPS_E_TOO_MANY_NW_SERVERS     (PM_ERR_BASE+ 37) /* 0x506D0025 */
   #define NDPS_E_CANT_CREATE_DOC_FILE    (PM_ERR_BASE+ 38) /* 0x506D0026 */
   #define NDPS_E_CANT_DELETE_DOC_FILE    (PM_ERR_BASE+ 39) /* 0x506D0027 */
   #define NDPS_E_CANT_OPEN_DOC_FILE      (PM_ERR_BASE+ 40) /* 0x506D0028 */
   #define NDPS_E_CANT_WRITE_DOC_FILE     (PM_ERR_BASE+ 41) /* 0x506D0029 */
   #define NDPS_E_JOB_IS_ACTIVE           (PM_ERR_BASE+ 42) /* 0x506D002A */
   #define NDPS_E_NO_SCHEDULER            (PM_ERR_BASE+ 43) /* 0x506D002B */
   #define NDPS_E_CHANGING_CONNECTION     (PM_ERR_BASE+ 44) /* 0x506D002C */
   #define NDPS_E_ACCTG_SVC_ERROR         (PM_ERR_BASE+ 45) /* 0x506D002D */
   #define NDPS_E_RMS_SVC_ERROR           (PM_ERR_BASE+ 46) /* 0x506D002E */
   #define NDPS_E_FAILED_VALIDATION       (PM_ERR_BASE+ 47) /* 0x506D002F */
   #define NDPS_E_SECURITY_RIGHTS         (PM_ERR_BASE+ 48) /* 0x506D0030 */
   #define NDPS_E_CLIENT_NOT_FOUND        (PM_ERR_BASE+ 49) /* 0x506D0031 */
   #define NDPS_E_INVALID_IDENTIFIER      (PM_ERR_BASE+ 50) /* 0x506D0032 */
   #define NDPS_E_ID_CHANGED              (PM_ERR_BASE+ 51) /* 0x506D0033 */
   #define NDPS_E_SERVICE_ERROR           (PM_ERR_BASE+ 52) /* 0x506D0034 */
   #define NDPS_E_ILLEGAL_MODIFICATION    (PM_ERR_BASE+ 53) /* 0x506D0035 */
   #define NDPS_E_OBJECT_IN_USE           (PM_ERR_BASE+ 54) /* 0x506D0036 */
   #define NDPS_E_OBJECT_DELETED          (PM_ERR_BASE+ 55) /* 0x506D0037 */
   #define NDPS_E_ACCTG_REQUIRES_SSL      (PM_ERR_BASE+ 56) /* 0x506D0038 */
   #define NDPS_E_OBJECT_MOVED            (PM_ERR_BASE+ 57) /* 0x506D0039 */
   #define NDPS_E_CANT_CREATE_SPOOL_DIR   (PM_ERR_BASE+ 58) /* 0x506D003A */
   #define NDPS_E_GW_REFUSES_RENAME        (PM_ERR_BASE+ 59) /* 0x506D003B */


   #define JPM_ERR_BASE                       PM_ERR_BASE + 0x100

   #define JPM_E_FAILED_TO_OPEN_DOC          (JPM_ERR_BASE+  1)   /* 0x506D0101 */
   #define JPM_E_FAILED_READ_DOC_FILE        (JPM_ERR_BASE+  2)   /* 0x506D0102 */
   #define JPM_E_BAD_PA_HANDLE               (JPM_ERR_BASE+  3)   /* 0x506D0103 */
   #define JPM_E_BAD_JOB_HANDLE              (JPM_ERR_BASE+  4)   /* 0x506D0104 */
   #define JPM_E_BAD_DOC_HANDLE              (JPM_ERR_BASE+  5)   /* 0x506D0105 */
   #define JPM_E_UNSUPPORTED_OP              (JPM_ERR_BASE+  6)   /* 0x506D0106 */
   #define JPM_E_REQUEST_QUEUE_FULL          (JPM_ERR_BASE+  7)   /* 0x506D0107 */
   #define JPM_E_PA_NOT_FOUND                (JPM_ERR_BASE+  8)   /* 0x506D0108 */
   #define JPM_E_INVALID_REQUEST             (JPM_ERR_BASE+  9)   /* 0x506D0109 */
   #define JPM_E_NOT_ACCEPTING_REQ           (JPM_ERR_BASE+ 10)   /* 0x506D010A */
   #define JPM_E_NO_JOB                      (JPM_ERR_BASE+ 11)   /* 0x506D010B */
   #define JPM_E_JOB_NOT_FOUND               (JPM_ERR_BASE+ 12)   /* 0x506D010C */
   #define JPM_E_COULD_NOT_ACCESS_DATA_BASE  (JPM_ERR_BASE+ 13)   /* 0x506D010D */
   #define JPM_E_BAD_OBJ_TYPE                (JPM_ERR_BASE+ 14)   /* 0x506D010E */
   #define JPM_E_JOB_ALREADY_CLOSED          (JPM_ERR_BASE+ 15)   /* 0x506D010F */
   #define JPM_E_DOC_ALREADY_CLOSED          (JPM_ERR_BASE+ 16)   /* 0x506D0110 */
   #define JPM_E_PH_NOT_REGISTERED           (JPM_ERR_BASE+ 17)   /* 0x506D0111 */
   #define JPM_E_VERSION_INCOMPATIBLE        (JPM_ERR_BASE+ 18)   /* 0x506D0112 */
   #define JPM_E_PA_PAUSED                   (JPM_ERR_BASE+ 19)   /* 0x506D0113 */
   #define JPM_E_PA_SHUTDOWN                 (JPM_ERR_BASE+ 20)   /* 0x506D0114 */
   #define JPM_E_NO_CLIB_CONTEXT             (JPM_ERR_BASE+ 21)   /* 0x506D0115 */
   #define JPM_E_ACCOUNTING_ALREADY_SERVICE  (JPM_ERR_BASE+ 22)   /* 0x506D0116 */
   #define JPM_E_MULTI_DATA_REQ_FOR_JOB      (JPM_ERR_BASE+ 23)   /* 0x506D0117 */


   #define DB_E_AUDIT_CANT_OPEN_LOG          (JPM_ERR_BASE+ 50)   /* 0x506D0132 */
   #define DB_E_AUDIT_CANT_READ_LOG          (JPM_ERR_BASE+ 51)   /* 0x506D0133 */
   #define DB_E_AUDIT_CANT_WRITE_LOG         (JPM_ERR_BASE+ 52)   /* 0x506D0134 */
   #define DB_E_AUDIT_CANT_RENAME_LOG        (JPM_ERR_BASE+ 53)   /* 0x506D0135 */
   #define DB_E_AUDIT_CANT_OPEN_USER_LOG     (JPM_ERR_BASE+ 54)   /* 0x506D0136 */
   #define DB_E_AUDIT_CANT_READ_USER_LOG     (JPM_ERR_BASE+ 55)   /* 0x506D0137 */
   #define DB_E_AUDIT_CANT_WRITE_USER_LOG    (JPM_ERR_BASE+ 56)   /* 0x506D0138 */
   #define DB_E_AUDIT_CANT_RENAME_USER_LOG   (JPM_ERR_BASE+ 57)   /* 0x506D0139 */
   #define DB_E_AUDIT_CANT_OPEN_JOB_FILE     (JPM_ERR_BASE+ 58)   /* 0x506D013A */
   #define DB_E_AUDIT_CANT_READ_JOB_FILE     (JPM_ERR_BASE+ 59)   /* 0x506D013B */
   #define DB_E_AUDIT_CANT_PARSE_JOB_FILE    (JPM_ERR_BASE+ 60)   /* 0x506D013C */


   #define DB_STATUS_BASE                    PM_ERR_BASE + 0x200

   #define DB_E_CANT_CREATE_FILE             (DB_STATUS_BASE+  1) /* 0x506D0201 */
   #define DB_E_CANT_FIND_DATA_FILE          (DB_STATUS_BASE+  2) /* 0x506D0202 */
   #define DB_E_CANT_OPEN_DATA_FILE          (DB_STATUS_BASE+  3) /* 0x506D0203 */
   #define DB_E_CANT_OPEN_INDEX_FILE         (DB_STATUS_BASE+  4) /* 0x506D0204 */
   #define DB_E_INDEX_FILE_NOT_OPEN          (DB_STATUS_BASE+  5) /* 0x506D0205 */
   #define DB_E_CANT_RENAME_FILE             (DB_STATUS_BASE+  6) /* 0x506D0206 */
   #define DB_E_CANT_READ_DATA_FILE          (DB_STATUS_BASE+  7) /* 0x506D0207 */
   #define DB_E_CANT_READ_INDEX_FILE         (DB_STATUS_BASE+  8) /* 0x506D0208 */
   #define DB_E_CANT_WRITE_DATA_FILE         (DB_STATUS_BASE+  9) /* 0x506D0209 */
   #define DB_E_CANT_WRITE_INDEX_FILE        (DB_STATUS_BASE+ 10) /* 0x506D020A */
   #define DB_E_CANT_DELETE_PA_DIR           (DB_STATUS_BASE+ 11) /* 0x506D020B */
   #define DB_E_ALREADY_DELETED              (DB_STATUS_BASE+ 12) /* 0x506D020C */
   #define DB_E_OBJECT_EXISTS                (DB_STATUS_BASE+ 13) /* 0x506D020D */
   #define DB_E_DESCRIPTOR_IN_USE            (DB_STATUS_BASE+ 14) /* 0x506D020E */
   #define DB_E_DESCRIPTOR_BEING_DELETED     (DB_STATUS_BASE+ 15) /* 0x506D020F */
   #define DB_E_DATA_FILE_CORRUPT            (DB_STATUS_BASE+ 16) /* 0x506D0210 */
   #define DB_E_DESCRIPTOR_NOT_FOUND         (DB_STATUS_BASE+ 17) /* 0x506D0211 */

   /********* End PSM error codes *****************************************/

   /*
   // EdInfxxxx() calls return these errors that are unique to these
   // calls.
   */
   #define ED_INF_ERR_BASE                0x45640000L       /* "Ed\0\0"   */

   #define ED_INF_ERR_FILE_FORMAT_ERR     (ED_INF_ERR_BASE+ 1) /* 0x45640001 */
   #define ED_INF_ERR_END_OF_SECTION      (ED_INF_ERR_BASE+ 2) /* 0x45640002 */
   #define ED_INF_ERR_BUFFER_TOO_SMALL    (ED_INF_ERR_BASE+ 3) /* 0x45640003 */
   #define ED_INF_ERR_SECTION_NOT_FOUND   (ED_INF_ERR_BASE+ 4) /* 0x45640004 */
   #define ED_INF_ERR_KEY_NOT_FOUND       (ED_INF_ERR_BASE+ 5) /* 0x45640005 */
   #define ED_INF_ERR_NO_VERSION_MATCH    (ED_INF_ERR_BASE+ 6) /* 0x45640006 */

   /*
   // iDS functions return these errors that are unique to these
   // calls.
   */
   #define IDS_ERR_BASE                   0x69445300L          /* "iDS\0"    */
   #define IDS_ERR_INVALID_PATH           (IDS_ERR_BASE+ 1)    /* 0x69445301 */
   #define IDS_ERR_OPERATION_NOT_SUPP     (IDS_ERR_BASE+ 2)    /* 0x69445302 */
   #define IDS_ERR_INVALID_TARGET         (IDS_ERR_BASE+ 3)    /* 0x69445303 */
   #define IDS_ERR_INVALID_REQUEST        (IDS_ERR_BASE+ 4)    /* 0x69445304 */
   #define IDS_ERR_REPO_ALREADY_EXISTS    (IDS_ERR_BASE+ 5)    /* 0x69445305 */
   #define IDS_ERR_REPO_URI_NAME_NOT_SUPP (IDS_ERR_BASE+ 6)    /* 0x69445306 */

   #define GW_ERR_BASE                    0x47770000L          /* "Gw\0\0"   */

   #define GW_E_NO_MEMORY                 (GW_ERR_BASE+  1)    /* 0x47770001 */
   #define GW_E_INVALID_PARAM             (GW_ERR_BASE+  2)    /* 0x47770002 */
   #define GW_E_INVALID_GW_HANDLE         (GW_ERR_BASE+  3)    /* 0x47770003 */
   #define GW_E_GW_GOING_DOWN             (GW_ERR_BASE+  4)    /* 0x47770004 */
   #define GW_E_COMM_TIMEOUT              (GW_ERR_BASE+  5)    /* 0x47770005 */
   #define GW_E_NO_MANAGER_COMM           (GW_ERR_BASE+  6)    /* 0x47770006 */
   #define GW_E_JOB_CLOSING               (GW_ERR_BASE+  7)    /* 0x47770007 */
   #define GW_E_CONN_ALREADY_OPEN         (GW_ERR_BASE+  8)    /* 0x47770008 */
   #define GW_E_ALL_LPR_SOCKETS_USED      (GW_ERR_BASE+  9)    /* 0x47770009 */
   #define GW_E_INVALID_ADDRESS           (GW_ERR_BASE+ 10)    /* 0x4777000A */
   #define GW_E_INTERNAL_ERROR            (GW_ERR_BASE+ 11)    /* 0x4777000B */

/* Macro Definitions */

/* Type Definitions */

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */


#endif /* CIERROR_H */

