/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novell�s prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 1994 - 2007 Novell, Inc.  All rights reserved.

April 2, 2007
//+==========================================================================+
//| Source module name: ciipc.h
//+==========================================================================+
//|$Author: dtaylor $              $Locker:  $
//|$Revision: 1.6 $            $Name:  $ $State: Exp $
//|$Date: 2007/04/02 19:56:21 $
//+===========================================================================
*/
/* Inclusion Control */
#if !defined( __CIIPC_H__ )
   #define __CIIPC_H__

/* Standard Library Header Includes */

   #include <limits.h>  // For PATH_MAX
   // #include <ntypes.h>
   #include <cithread.h>

/* Header Includes */

/* Manifest Constant Definitions */
   enum CiIpcReqType
   {
      CI_IPC_CONN_NEW     =1,
      CI_IPC_CONN_LOST    =2,
      CI_IPC_DATA_READ    =3,
      CI_IPC_SERVICE_INIT =4
   };

   #define CI_IPC_VERS   1
   #define CI_IPC_SIGN   88808284

   #define CI_IPC_ERR_PACKET    -10001
   #define CI_IPC_ERR_VERS      -10002
   #define CI_IPC_ERR_MEM       -10003

   #define CI_IPC_UDS            1
   #define CI_IPC_INET           2

   #define CI_IPC_NO_CHOWN       0x00000001

   #define CI_IPC_IPRINT_USERNAME   "iprint"
   #define CI_IPC_APACHE_GROUPNAME  "www"

   #define CI_IPC_IDS_UDSNAME       "/var/opt/novell/run/iprint/idsd.uds"
   #define CI_IPC_PSM_GW_UDSNAME    "/var/opt/novell/run/iprint/ipsmd_gw.uds"
   #define CI_IPC_PSM_IPP_UDSNAME   "/var/opt/novell/run/iprint/ipsmd_ipp.uds"
   #define CI_IPC_PSM_ACCTG_UDSNAME   "/var/opt/novell/run/iprint/ipsmd_acctg.uds"

/* Macro Definitions */

/* Type Definitions */

   typedef struct CiIpcServerCtx_s
   {
      char name[PATH_MAX];
      CI_THREAD_HANDLE threadId;
      int listenSocket;
      int stop;
   } CiIpcServerCtx_t;


   typedef struct CiIpcHeader_s
   {
      uint32_t    signature;
      uint32_t    version;
      uint32_t    dataSize;
   }CiIpcHeader_t;

   typedef struct CiIpcBuffer_s
   {
      void  *nextPtr;
      void  *prevPtr;
      char  data[0];
   }CiIpcBuffer_t;

   typedef int (*CiIpcCallback)(
      enum CiIpcReqType   request,
      int                 socket,
      CiIpcBuffer_t      *buffer,
      int                 bufferLength);

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

/**
 * Create an IPC server object and return it in parameter serverCtx.
 * Creating an IPC server object consists of creating and binding to a
 * socket of type socketType to the host specified by namePtr/port.
 *
 * @note    When socketType is CI_IPC_UDS, CiIpcServerInit creates a Unix
 *          Domain Socket (UDS) and binds to the socket.  The act of binding
 *          actually creates the file associated with the socket.  After binding
 *          (creating the file) we change permissions on the file to 0660 so
 *          only the creating user and group have read/write access to the socket.
 *          If CI_IPC_NO_CHOWN is set in flags, no further action is taken and
 *          the bound socket is returned.  If flags is 0, CiIpcServerInit
 *          also changes the UDS file owner to "iprint" and group to "www".
 *          This routine will fail if permissions can not be set to 0660 or
 *          chown() fails when CI_IPC_NO_CHOWN is not specified.
 *
 * @param socketType Type of socket-based IPC to create.  Supported types are
 *                   CI_IPC_INET for traditional internet stream sockets and
 *                   CI_IPC_UDS for Unix Domain Sockets.
 * @param namePtr    Pointer to the name of the host when socketType is CI_IPC_INET.
 *                   Defaults to localhost if NULL.
 *                   Pointer to file name to be associated with the socket when
 *                   socketType is CI_IPC_UDS. namePtr must not be NULL when
 *                   socketType is CI_IPC_UDS.
 * @param port       Port number of the host.  Only valid if socketType is
 *                   CI_IPC_INET.
 * @param flags      Currently, the only flags supported are CI_IPC_NO_CHOWN.
 *                   This flag only applies when socketType is CI_IPC_UDS and
 *                   if set will not perform chown() on the underlying UDS
 *                   file.  Otherwise chown() is called to change file owner
 *                   to user "iprint" and file group to "www".
 * @param serverCtx  Pointer to location where a successfully created IPC
 *                   server will be stored.  Callers should not manipulate
 *                   the structure directly.
 *
 * @return  If successful, 0 is returned and the IPC server object is stored in
 *          serverCtx.  Otherwise a non-zero value is returned.
 *
 */
int CiIpcServerInit(int socketType, char *namePtr, int port,
                    int flags, CiIpcServerCtx_t **serverCtx);


/**
 * Run the IPC server on serverCtx that was previously initialized with
 * CiIpcServerInit.  This function must run on a joinable thread as it
 * blocks (only returning on critical error) and is terminated by and joined
 * in CiIpcServerTerm.
 *
 * @param serverCtx    IPC server object previously created with CiIpcServerInit.
 * @param callbackPtr  Function to call when activity occurs in the server.
 *
 * @return  If successful, this function does not return and listens for
 *          communication on the server's listening socket.  When activity on
 *          the socket occurs, callbackPtr is invoked to service the request.
 *
 */
int CiIpcServerRun(CiIpcServerCtx_t *serverCtx, CiIpcCallback callbackPtr);


/**
 * Create a socket of type socketType to the host specified by namePtr/port.
 * Connect to the socket and wait for data from the server-side of IPC.
 * When data is received, callbackPtr will be called to process the data.
 *
 * @param socketType  Type of socket-based IPC to create.  Supported types are
 *                    CI_IPC_INET for traditional internet stream sockets and
 *                    CI_IPC_UDS for Unix Domain Sockets.
 * @param namePtr     Pointer to the name of the host when socketType is CI_IPC_INET.
 *                    Defaults to localhost if NULL.
 *                    Pointer to file name to be associated with the socket when
 *                    socketType is CI_IPC_UDS. namePtr must not be NULL when
 *                    socketType is CI_IPC_UDS.
 * @param port        Port number of the host.  Only valid if socketType is
 *                    CI_IPC_INET.
 * @param callbackPtr Function to call when data is received on the IPC channel.
 *
 * @return  If successful, this function does not return and continually waits
 *          for incoming data on the IPC channel.  callbackPtr is invoked when
 *          data is received.  On failure a non-zero value is returned.
 *
 */
int CiIpcClientRun(int socketType, char *namePtr, int port, CiIpcCallback callbackPtr);


/**
 * Send numBytes of data contained in bufPtr to the communication channel
 * specified by commSocket.
 *
 * @param commSocket  Handle of open IPC channel to send data on.
 * @param bufPtr      Pointer to buffer containing the data to send.
 * @param numBytes    Number of bytes in bufPtr to send.
 *
 * @return  Returns 0 on success, non-zero on failure.
 *
 */
int CiIpcSend(int commSocket, char *bufPtr, int numBytes);

/**
 * Terminate the IPC server running on thread threadId.
 *
 * WARNING!
 * For now we are just going to "signal" the server to terminate by
 * setting the stop bit to true.  CiIpcServerRun checks the bit each
 * time through the select loop and bails out if it is set.  Before
 * bailing out however it will close sockets and unlink the IPC file
 * in the case of UDS.
 *
 * @param serverCtx   IPC server object to terminate.
 *
 * @return  Returns 0 on success, non-zero on failure.
 *
 */
int CiIpcServerTerm(CiIpcServerCtx_t *serverCtx);

int DetectPdf(char *jobFile);

#endif /* __CIIPC_H__ */

