/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novells prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 1994 - 2007 Novell, Inc.  All rights reserved.

April 2, 2007
//+==========================================================================+
//| Source module name: cimalloc.h                                           |
//+==========================================================================+
//|$Author:   dtaylor $              $Locker$
//|$Revision:   1.16  $            $Name$ $State$
//|$Date:   27 Jul 2007 10:07:06  $
//+===========================================================================
*/
/* Inclusion Control */
#if !defined( CIMALLOC_H )
   #define CIMALLOC_H

/* Standard Library Header Includes */
   #include <ci_all.h> // includes config.h

/* Header Includes */

/* Manifest Constant Definitions */
   // #if defined(N_DEBUG)
   //    #define CI_USE_SIGNATURES_IN_MALLOC
   // #endif

/* Macro Definitions */

   #define CiMallocMac(__szMem) \
      CiMallocFunc(__szMem)

   #define CiUnlimitedMallocMac(__szMem) \
      CiUnlimitedMallocFunc(__szMem)

   #define CiReallocMac(__sourceMemPtr,__szMem) \
      CiReallocFunc(__sourceMemPtr,__szMem)

   #define CiUnlimitedReallocMac(__sourceMemPtr,__szMem) \
      CiUnlimitedReallocFunc(__sourceMemPtr,__szMem)

   #define CiCallocMac(__numElements,__szMem) \
      CiCallocFunc(__numElements,__szMem)

   #define CiUnlimitedCallocMac(__numElements,__szMem) \
      CiUnlimitedCallocFunc(__numElements,__szMem)

   #define CiMemReplicateMac(__sourcePtr, __numElements,__szMem) \
      CiMemReplicateFunc(__sourcePtr, __numElements,__szMem)

   #define CiFreeMac(__memPtr) \
      CiFreeFunc(__memPtr)

   #if defined(N_DEBUG)
      #if defined(CI_USE_SIGNATURES_IN_MALLOC)
         #define CiCheckMemorySignatureMac(__memPtr) \
            CiCheckMemorySignatureFunc(__memPtr)
      #else
         #define CiCheckMemorySignatureMac(__memPtr) \
            (N_TRUE)
      #endif
      #define CiGetMemoryUsageStatsMac(__numAllocsPtr,__totalBytesPtr, \
               __histArrayValPtr,__histArrayMaxSizePtr,__numElementsPtr) \
         CiGetMemoryUsageStatsFunc(__numAllocsPtr,__totalBytesPtr, \
               __histArrayValPtr,__histArrayMaxSizePtr,__numElementsPtr)
   #else
      #define CiGetMemoryUsageStatsMac(__numAllocsPtr,__totalBytesPtr, \
               __histArrayValPtr,__histArrayMaxSizePtr,__numElementsPtr) \
         (*__numAllocsPtr=0,*__totalBytesPtr = 0,*__histArrayValPtr=NULL, \
            *__histArrayMaxSizePtr=NULL,*__numElementsPtr=0)
   #endif
   /*
   // The following macros exist for use in CIDEBUG.C so that
   // the CiMallocFunc routines can call the CIDEBUG routines.
   */
   #if defined(CI_INTERNAL_USE)
   #define CiMyMallocMac(__szMem) \
      malloc(__szMem)

   #define CiMyReallocMac(__sourceMemPtr,__szMem) \
      realloc(__sourceMemPtr,__szMem)

   #define CiMyCallocMac(__numElements,__szMem) \
      calloc(__numElements,__szMem)

   #define CiMyFreeMac(__memPtr) \
      free(__memPtr)
   #endif

/* Type Definitions */

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

   N_EXTERN_FUNC(void *)
 CiMallocFunc(
   int   szMem
   );

   N_EXTERN_FUNC(void *)
 CiUnlimitedMallocFunc(
   int   szMem
   );

   N_EXTERN_FUNC(void *)
 CiReallocFunc(
   void    *sourceMemPtr,
   int      szMem
   );

   N_EXTERN_FUNC(void *)
 CiUnlimitedReallocFunc(
   void    *sourceMemPtr,
   int      szMem
   );

   N_EXTERN_FUNC(void *)
 CiCallocFunc(
   int   numElements,
   int   szMem
   );

   N_EXTERN_FUNC(void *)
 CiUnlimitedCallocFunc(
   int   numElements,
   int   szMem
   );

   N_EXTERN_FUNC(void *)
 CiMemReplicateFunc(
   void    *sourcePtr,
   int      numElements,
   int      szMem
   );

   N_EXTERN_FUNC(void)
 CiFreeFunc(
   void    *memPtr
   );

   #if defined(N_DEBUG)
   N_EXTERN_FUNC(nint)
 CiGetMemoryUsageStats(
   uint             *numAllocsPtr,
   uint             *totalBytesPtr,
   uint            **histArrayValPtr,
   uint            **histArrayMaxSizePtr,
   uint             *numElementsPtr
   );

   N_EXTERN_FUNC(nint)
 CiGetMemoryUsageStatsFunc(
   uint             *numAllocsPtr,
   uint             *totalBytesPtr,
   uint            **histArrayValPtr,
   uint            **histArrayMaxSizePtr,
   uint             *numElementsPtr);
   #endif

   #if defined(N_DEBUG) && defined(CI_USE_SIGNATURES_IN_MALLOC)
   N_EXTERN_FUNC(nbool)
 CiCheckMemorySignatureFunc(
   void    *memPtr
   );
   #endif


#endif /* CIMALLOC_H */

