/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novell�s prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 1994 - 2011 Novell, Inc.  All rights reserved.

April 2, 2007
//+==========================================================================+
//| Source module name: cithread.h                                           |
//+==========================================================================+
//|$Author:   dtaylor $              $Locker$
//|$Revision:   1.16  $            $Name$ $State$
//|$Date:   27 Jul 2007 10:07:06  $
//+==========================================================================+
*/
/* Inclusion Control */
#if !defined( CITHREAD_H )
   #define CITHREAD_H

/* Standard Library Header Includes */

   #include <ci_all.h> // includes config.h

      #if defined(N_PLAT_NLM) && defined(USE_CLIB)
         #define IAPX386
         #ifdef HANDLE
            #undef HANDLE
         #endif
         #include "mpkapis.h"
         #include <nwlib.h>
         #if !defined(_NWTHREAD_H_)
            #include <nwthread.h>
         #endif
         #include <nwtime.h>
         #include <nwsemaph.h>
      #elif defined(N_PLAT_UNIX) || (defined(N_PLAT_NLM) && !defined(USE_CLIB))
   // #if defined(N_PLAT_UNIX) || defined(N_PLAT_NLM)
      // __USE_POSIX199309 in time.h gives us nanosleep()
      #define __USE_POSIX199309   1
      /*
      // This one appears to include the other two, but... just in case.
      */
      #if !defined(_PTHREAD_H)
         #include <pthread.h>
      #endif
      #if !defined(_TIME_H)
         #include <time.h>
      #endif
      #if !defined(_SCHED_H)
         #include <sched.h>
      #endif
      #if !defined(_SIGNAL_H)
         #include <signal.h>
      #endif

      #include <unistd.h>
      #include <semaphore.h>
      #include <sys/time.h>
   #endif

/* Header Includes */

/* Manifest Constant Definitions */

/* Macro Definitions */

   #if defined(N_PLAT_MSW4)
      #if defined(_WIN32_WINNT)
         #define CiAllowOthersToRunMac() \
            SwitchToThread() /* wont block if only one running */
      #else
         #define CiAllowOthersToRunMac() \
            Sleep(1) /* milliseconds (best fit in Windows 9x) */
      #endif

      #define CiSleepMillisecsMac(__milliseconds) \
         Sleep(__milliseconds) /* milliseconds */

      #define CiGetHiResTimerMac(__timerTenThousandthsPtr) \
         {\
            LARGE_INTEGER frequency;\
            LARGE_INTEGER performanceCount;\
           QueryPerformanceFrequency(&frequency);\
           QueryPerformanceCounter(&performanceCount);\
           *((pnuint32)(__timerTenThousandthsPtr)) =\
            (nuint32)(frequency * performanceCount / 10000L);\
         }

      #define CI_THREAD_HANDLE  HANDLE

      #define CiThreadCreateHandleMac(__func, __arg, __threadHandlePtr) \
             (*__threadHandlePtr=CreateThread(NULL, 0, (CiThreadStartFuncPtr)__func, __arg, 0, NULL),
              *__threadHandlePtr == NULL ? GetLastError() : 0)

      #define CiThreadCreateJoinableHandleMac(__func, __arg, __threadHandlePtr) \
         INeedImplemented

      #define CiThreadDestroyHandleMac(__threadHandlePtr) \
             CloseHandle(*__threadHandlePtr)

      #define CiThreadExitMac(__exitCode) \
             ExitThread(__exitCode)

      #define CiThreadJoinMac(__threadHandle, __exitCode) \
        INeedImplemented

      #define CiThreadIdsAreEqualMac(__threadHandle1,__threadHandle2)\
            (__threadHandle1 == __threadHandle2)

      #define CiThreadSigmaskMac(__how,__newSet,__oldSet) \
        INeedImplemented

      #define CI_THREAD_ID DWORD

      #define CiThreadGetCurrentId() \
               GetCurrentThreadId()

      #define CiThreadSigmaskMac(__how,__newSet,__oldSet) \
        INeedImplemented

      #define CiThreadCancelMac(__threadHandle) \
         INeedImplemented

      #define CiThreadTestCancelMac() \
         INeedImplemented

      #define CiThreadSetCancelStateMac(__state, __oldStatePtr) \
         INeedImplemented

      #define CiThreadSetCancelTypeMac(__type, __oldTypePtr) \
         INeedImplemented

      #define CI_THREAD_TLS_KEY DWORD

      #define CiThreadAllocLocalStorageKeyMac(__localStorageKeyPtr) \
               ((*__localStorageKeyPtr = TlsAlloc()) == NULL?GetLastError():0)

      #define CiThreadFreeLocalStorageKeyMac(__localStorageKey) \
               TlsFree(__localStorageKey)

      #define CI_THREAD_TLS_VALUE nptr

      #define CiThreadGetLocalStorageValueMac(__localStorageKey) \
               TlsGetValue(__localStorageKey)

      #define CiThreadSetLocalStorageValueMac(__localStorageKey,__value) \
               TlsSetValue(__localStorageKey,(nptr)__value)

      #define CI_MUTEX     HANDLE

      #define CiMutexCreateMac(__mutexPtr) \
         (*(__mutexPtr) = CreateMutex(NULL, FALSE, NULL), \
          *(__mutexPtr) == NULL ? GetLastError() : 0)

      #define CiMutexDestroyMac(__mutexPtr) \
         CloseHandle(*__mutexPtr)

      #define CiMutexTryMac(__mutexPtr) \
         CiMutexTryFunc(__mutexPtr)

      #define CiMutexLockMac(__mutexPtr) \
         WaitForSingleObject(*__mutexPtr, INFINITE)

      #define CiMutexUnlockMac(__mutexPtr) \
         (ReleaseMutex(*__mutexPtr) ? 0:GetLastError())

      #define CI_SEMAPHORE HANDLE

      #define CiSemaphoreCreateMac(__semaphorePtr,__initialValue) \
         (*(__semaphorePtr) = CreateSemaphore(NULL, __initialValue, 0x40000000L, NULL), \
          *(__semaphorePtr) == NULL ? GetLastError() : 0)

      #define CiSemaphoreDestroyMac(__semaphorePtr) \
         CloseHandle(*(__semaphorePtr))

      #define CiSemaphoreExamineMac(__semaphorePtr,__currentValuePtr) \
         (ReleaseSemaphore(*(__semaphorePtr),0x4FFFFFFFL,__currentValuePtr),0)

      #define CiSemaphoreTryMac(__semaphorePtr) \
         CiMutexTryFunc(__semaphorePtr) /* looks the same as mutex */

      #define CiSemaphoreWaitMac(__semaphorePtr) \
         WaitForSingleObject(*(__semaphorePtr), INFINITE)

      #define CiSemaphoreSignalMac(__semaphorePtr) \
         ReleaseSemaphore(*(__semaphorePtr),1,NULL)

      #define CI_COND HANDLE

      #define CiCondInitMac(__condPtr) \
         INeedImplemented

      #define CiCondDestroyMac(__condPtr) \
         INeedImplemented

      #define CiCondWaitMac(__condPtr, __mutexPtr) \
         INeedImplemented

      #define CiCondTimedWaitMac(__condPtr, __mutexPtr, __interval) \
         INeedImplemented

      #define CiCondSignalMac(__condPtr) \
         INeedImplemented

      #define CiCondBroadcastMac(__condPtr) \
         INeedImplemented

   #elif defined(N_PLAT_NLM) && defined(USE_CLIB)
      #define CiAllowOthersToRunMac() \
         ThreadSwitchWithDelay() /* wont block if only one running */

      #define CiSleepMillisecsMac(__milliseconds) \
         delay(__milliseconds)

      #define CiGetHiResTimerMac(__timerTenThousandthsPtr) \
         *(__timerTenThousandthsPtr) = GetHighResolutionTimer()

      #define CI_THREAD_HANDLE nint

      #define CiThreadCreateHandleMac(__func, __arg, __threadHandlePtr) \
         CiThreadCreateHandleFunc(__func, __arg, __threadHandlePtr)

      #define CiThreadDestroyHandleMac(__threadHandlePtr) \
         *__threadHandlePtr = (CI_THREAD_HANDLE)EFAILURE

      #define CiThreadExitMac(__exitCode) \
         ExitThread(-1,__exitCode)

      #define CI_THREAD_ID nint

      #define CiThreadGetCurrentIdMac() \
               GetThreadID()

      #define CiThreadCancelMac(__threadHandle) \
         SuspendThread(__threadHandle)

      #define CiThreadIdsAreEqualMac(__threadHandle1,__threadHandle2)\
                  (__threadHandle1 == __threadHandle2)

      #define CI_MUTEX     nint

      #define CiMutexCreateMac(__mutexPtr) \
         (*__mutexPtr = OpenLocalSemaphore(1),*__mutexPtr == 0 ? -1 : 0)

      #define CiMutexDestroyMac(__mutexPtr) \
         (CloseLocalSemaphore(*__mutexPtr),*__mutexPtr = 0)

      #define CiMutexTryMac(__mutexPtr) \
         (ExamineLocalSemaphore(*__mutexPtr) > 0 ? WaitOnLocalSemaphore(*__mutexPtr) : (errno = EBUSY,-1))

      #define CiMutexLockMac(__mutexPtr) \
         WaitOnLocalSemaphore(*__mutexPtr)

      #define CiMutexUnlockMac(__mutexPtr) \
         SignalLocalSemaphore(*__mutexPtr)

      #define CI_SEMAPHORE nint

      #define CiSemaphoreCreateMac(__semaphorePtr,__initialValue) \
         (*__semaphorePtr = OpenLocalSemaphore(__initialValue),*__semaphorePtr == 0 ? -1 : 0)

      #define CiSemaphoreDestroyMac(__semaphorePtr) \
         (CloseLocalSemaphore(*__semaphorePtr),*__semaphorePtr = 0)

      #define CiSemaphoreExamineMac(__semaphorePtr,__currentValuePtr) \
         *__currentValuePtr = ExamineLocalSemaphore(*__semaphorePtr)

      #define CiSemaphoreTryMac(__semaphorePtr) \
         (ExamineLocalSemaphore(*__semaphorePtr) > 0 ? WaitOnLocalSemaphore(*__semaphorePtr) : (errno = EBUSY,-1))

      #define CiSemaphoreWaitMac(__semaphorePtr) \
         WaitOnLocalSemaphore(*__semaphorePtr)

      #define CiSemaphoreSignalMac(__semaphorePtr) \
         SignalLocalSemaphore(*__semaphorePtr)

   #elif defined(N_PLAT_UNIX) || (defined(N_PLAT_NLM) && !defined(USE_CLIB))
      #define CiAllowOthersToRunMac() \
         sched_yield() /* wont block if only one running */

      #define CiSleepMillisecsMac(__milliseconds) \
         usleep((__milliseconds) * 1000L)

      #define CiGetHiResTimerMac(__timerTenThousandthsPtr) \
         {  /* properly handle 100 thousandths of nanoseconds */\
            struct timeval __tv;\
            struct timezone __tz;\
            gettimeofday(&__tv,&__tz);\
            *(__timerTenThousandthsPtr)  = __tv.tv_sec  *  10000L;\
            *(__timerTenThousandthsPtr) += __tv.tv_usec / 100L;\
         }

      #define CI_THREAD_HANDLE pthread_t

      #define CiThreadCreateHandleMac(__func, __arg, __threadHandlePtr) \
        CiThreadCreateHandleFunc(__func, __arg, __threadHandlePtr)

      #define CiThreadCreateJoinableHandleMac(__func, __arg, __threadHandlePtr) \
        CiThreadCreateJoinableHandleFunc(__func, __arg, __threadHandlePtr)

      #define CiThreadDestroyHandleMac(__threadHandlePtr) \
         memset(__threadHandlePtr,'\0',sizeof(CI_THREAD_HANDLE))

      #define CiThreadExitMac(__exitCode) \
         pthread_exit((void *)__exitCode)

      #define CiThreadJoinMac(__threadHandle, __exitCode) \
         pthread_join(__threadHandle, (void **)__exitCode)

      #define CI_THREAD_ID pthread_t

      #define CiThreadCancelMac(__threadHandle) \
         pthread_cancel(__threadHandle)

      #define CiThreadTestCancelMac() \
         pthread_testcancel()

      #define CiThreadSetCancelStateMac(__state, __oldStatePtr) \
         pthread_setcancelstate(__state, __oldStatePtr)

      #define CiThreadSetCancelTypeMac(__type, __oldTypePtr) \
         pthread_setcanceltype(__type, __oldTypePtr)

      #define CiThreadGetCurrentIdMac() \
               pthread_self()

      #define CiThreadIdsAreEqualMac(__threadHandle1,__threadHandle2)\
         pthread_equal(__threadHandle1,__threadHandle2)

     #define CiThreadSigmaskMac(__how,__newSet,__oldSet)\
        pthread_sigmask(__how,__newSet,__oldSet)

      #define CI_THREAD_TLS_KEY pthread_key_t

      #define CiThreadAllocLocalStorageKeyMac(__localStorageKeyPtr) \
               pthread_key_create((CI_THREAD_TLS_KEY *)__localStorageKeyPtr,NULL)

      #define CiThreadFreeLocalStorageKey(__localStorageKey) \
               pthread_key_delete(__localStorageKey)

      #define CI_THREAD_TLS_VALUE nptr

      #define CiThreadGetLocalStorageValue(__localStorageKey) \
               pthread_getspecific(__localStorageKey)

      #define CiThreadSetLocalStorageValue(__localStorageKey,__value) \
               pthread_getspecific(__localStorageKey,(nptr)__value)

      #if defined(N_DEBUG)
         typedef struct
         {
            pthread_mutex_t         mutex;
            char                    swBuf[1024];
            int                     aquireTime;
            int                     waitingCount;
         } DebugMutexStruct, *pDebugMutexStruct;

         #define CI_MUTEX     pDebugMutexStruct


         N_GLOBAL_FUNC(nint) CiMutexDestroyFunc(CI_MUTEX *mutexPtr);
         N_GLOBAL_FUNC(nint) CiMutexLockFunc(CI_MUTEX *mutexPtr);
         N_GLOBAL_FUNC(nint) CiMutexUnlockFunc(CI_MUTEX *mutexPtr);

         #define CiMutexCreateMac(__mutexPtr) \
            CiMutexCreateFunc(__mutexPtr)

         #define CiMutexNonRecursiveCreateMac(__mutexPtr) \
            CiMutexNonRecursiveCreateFunc(__mutexPtr)

         #define CiMutexDestroyMac(__mutexPtr) \
            CiMutexDestroyFunc(__mutexPtr)

         #define CiMutexTryMac(__mutexPtr) \
            pthread_mutex_trylock(&(*__mutexPtr)->mutex)

         #define CiMutexLockMac(__mutexPtr) \
            CiMutexLockFunc(__mutexPtr)

         #define CiMutexUnlockMac(__mutexPtr) \
            CiMutexUnlockFunc(__mutexPtr)
      #else
         #define CI_MUTEX     pthread_mutex_t

         #define CiMutexCreateMac(__mutexPtr) \
            CiMutexCreateFunc(__mutexPtr)

         #define CiMutexNonRecursiveCreateMac(__mutexPtr) \
            CiMutexNonRecursiveCreateFunc(__mutexPtr)

         #define CiMutexDestroyMac(__mutexPtr) \
            pthread_mutex_destroy(__mutexPtr)

         #define CiMutexTryMac(__mutexPtr) \
            pthread_mutex_trylock(__mutexPtr)

         #define CiMutexLockMac(__mutexPtr) \
            pthread_mutex_lock(__mutexPtr)

         #define CiMutexUnlockMac(__mutexPtr) \
            pthread_mutex_unlock(__mutexPtr)
      #endif

      N_GLOBAL_FUNC(nint) CiMutexCreateFunc(CI_MUTEX *mutexPtr);
      N_GLOBAL_FUNC(nint) CiMutexNonRecursiveCreateFunc(CI_MUTEX *mutexPtr);

      #define CI_SEMAPHORE sem_t

      #define CiSemaphoreCreateMac(__semaphorePtr,__initialValue) \
         sem_init(__semaphorePtr,0,__initialValue)

      #define CiSemaphoreDestroyMac(__semaphorePtr) \
         sem_destroy(__semaphorePtr)

      #define CiSemaphoreExamineMac(__semaphorePtr,__currentValuePtr) \
         sem_getvalue(__semaphorePtr,__currentValuePtr)

      #define CiSemaphoreTryMac(__semaphorePtr) \
         sem_trywait(__semaphorePtr)

      #define CiSemaphoreWaitMac(__semaphorePtr) \
         sem_wait(__semaphorePtr)

      #define CiSemaphoreSignalMac(__semaphorePtr) \
         sem_post(__semaphorePtr)

     #define CI_COND pthread_cond_t

     #define CiCondInitMac(__condPtr) \
       pthread_cond_init(__condPtr, NULL )

     #define CiCondDestroyMac(__condPtr) \
       pthread_cond_destroy(__condPtr)

     #if defined(N_DEBUG)
        #define CiCondWaitMac(__condPtr, __mutexPtr) \
           pthread_cond_wait(__condPtr, &(*__mutexPtr)->mutex)
     #else
        #define CiCondWaitMac(__condPtr, __mutexPtr) \
           pthread_cond_wait(__condPtr, __mutexPtr)
     #endif

      #define CiCondTimedWaitMac(__condPtr, __mutexPtr, __interval) \
       CiCondTimedWaitFunc(__condPtr, __mutexPtr, __interval)

     #define CiCondSignalMac(__condPtr) \
       pthread_cond_signal(__condPtr)

     #define CiCondBroadcastMac(__condPtr) \
       pthread_cond_broadcast(__condPtr)

      #define CI_RWLOCK pthread_rwlock_t

      #define CiRwLockInitMac(__rwLockPtr) \
         pthread_rwlock_init(__rwLockPtr, NULL);

      #define CiRwLockDestroyMac(__rwLockPtr) \
         pthread_rwlock_destroy(__rwLockPtr);

      #define CiRwLockUnlockMac(__rwLockPtr) \
         pthread_rwlock_unlock(__rwLockPtr);

      #define CiRwLockRdLockMac(__rwLockPtr) \
         pthread_rwlock_rdlock(__rwLockPtr);

      #define CiRwLockWrLockMac(__rwLockPtr) \
         pthread_rwlock_wrlock(__rwLockPtr);

      #define CiRwLockTimedRdLockMac(__rwLockPtr, timePtr) \
         pthread_rwlock_timedrdlock(__rwLockPtr, timePtr)

      #define CiRwLockTimedWrLockMac(__rwLockPtr, timePtr) \
         pthread_rwlock_timedwrlock(__rwLockPtr, timePtr)

   #endif

   #if defined(CI_PLAT_NON_PREEMPTIVE)
      /*
      // Sometimes you might want to relenquish control only when you
      // have to so this allows you to do that.
      */
      #define CiSelfPreemptMac() CiAllowOthersToRunMac()
   #else
      #define CiSelfPreemptMac()
   #endif

/* Type Definitions */

   #if defined(N_PLAT_MSW4)
      N_TYPEDEF_CALLBACK(nuint32,CiThreadStartFuncPtr)(void *parameterPtr);
   #elif defined(N_PLAT_NLM) && defined(USE_CLIB)
      N_TYPEDEF_CALLBACK(void,CiThreadStartFuncPtr)(void *parameterPtr);
   #elif defined(N_PLAT_UNIX) || (defined(N_PLAT_NLM) && !defined(USE_CLIB))
      N_TYPEDEF_CALLBACK(void *,CiThreadStartFuncPtr)(void *parameterPtr);
   #endif

/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

   #if defined(N_PLAT_UNIX) || defined(N_PLAT_NLM)
     N_EXTERN_FUNC(nint)
 CiThreadCreateHandleFunc(
   CiThreadStartFuncPtr func,
   void *arg,
   CI_THREAD_HANDLE *tidPtr
   );
   #endif

   #if defined(N_PLAT_UNIX) || (defined(N_PLAT_NLM) && defined(IPRNT_HAVE_PTHREAD_H))
     N_EXTERN_FUNC(nint)
 CiThreadCreateJoinableHandleFunc(
   void *(*func)(void *),
   void *arg,
   CI_THREAD_HANDLE *tidPtr
   );

   N_EXTERN_FUNC(nint)
 CiCondTimedWaitFunc(
   CI_COND *cond,
   CI_MUTEX *mtx,
   unsigned long interval
   );
   #endif

   #if !defined(N_PLAT_UNIX) && 0
   // These are commented in case I ever need one. jMK
   N_EXTERN_FUNC(nint)
 CiSemaphoreCreateFunc(
   CI_SEMAPHORE  *semaphorePtr,
   int            initialValue
   );
   N_EXTERN_FUNC(int)
 CiSemaphoreDestroyFunc(
   CI_SEMAPHORE  *semaphorePtr
   );
   N_EXTERN_FUNC(int)
 CiSemaphoreExamineFunc(
   CI_SEMAPHORE  *semaphorePtr
   int           *currentCountPtr
   );
   N_EXTERN_FUNC(int)
 CiSemaphoreTryFunc(
   CI_SEMAPHORE  *semaphorePtr
   );
   N_EXTERN_FUNC(int)
 CiSemaphoreWaitFunc(
   CI_SEMAPHORE  *semaphorePtr
   );
   N_EXTERN_FUNC(int)
 CiSemaphoreSignalFunc(
   CI_SEMAPHORE  *semaphorePtr
   );
   #endif


#endif /* CITHREAD_H */

