/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novell�s prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 1994 - 2007 Novell, Inc.  All rights reserved.

October 19, 2007
//+==========================================================================+
//| Source module name: citypes.h                                            |
//+==========================================================================+
//|$Author:   dtaylor $              $Locker$
//|$Revision:   1.16  $            $Name$ $State$
//|$Date:   27 Jul 2007 10:07:06  $
//+==========================================================================+
*/
/* Inclusion Control */
#ifndef CITYPES_H
#define CITYPES_H

   #include <stdint.h>

/*
 * This file is a combination of a subset of the NetWare NLM SDK ntypes.h
 * and the odi.h header file. Essentially, all code in switches *except*
 * what pertains to NEST has been removed for clarification.
 *
 * This file is in three parts. The first part contains defines that
 * aid in C code portability (N_FAR, etc). The second part contains
 * typedefs and defines for basic types. The third part contains macros
 * for data swapping, dependent on byte-order and alignment (see platoem.h).
 *
 * This file is included indirectly in all NEST sources via nest.h, which
 * must be the first include in all NEST sources.
 *
 *  The user of the defines & macros in this file must first make the
 *  following definitions before including this file.
 *
 *  N_INT_ENDIAN_HI_LO  Defined if machine is a hi-lo machine type
 *
 *  BIG_ENDIAN          Defined if machine is a hi-lo machine type
 *  LITTLE_ENDIAN       Defined if machine is a lo-hi machine type
 *  STRICT_ALIGNMENT    Defined if machine is strictly aligned
 *  UNSTRICT_ALIGNMENT  Defined if machine is not strictly aligned
 *
 *  N_INT_ENDIAN_HI_LO is used in current ntypes.h and related code, so
 *    BIG_ENDIAN is mapped to N_INT_ENDIAN_HI_LO below.
 */

/* PART ONE: C Code Portability */

// #define N_NEAR
// #define N_FAR
// #define N_PASCAL
// #ifdef __WATCOMC__
//    #define N_CDECL         cdecl
// #else /* __WATCOMC__ */
//    #define N_CDECL
// #endif /* __WATCOMC__ */


/*
  Some compilers support packing (no pad bytes between elements in a structure)
*/

/* If not supported, then resolve to nothing */
// #define PACKED_FIELD
/* Flag to indicate whether to reference packed field names */
// #define PACK_SUPPORTED (0)

// #ifdef __GNUC__ /* GNU supports packing */
// #undef PACKED_FIELD
// #define  PACKED_FIELD   __attribute__ ((packed))
// #undef PACK_SUPPORTED
// #define PACK_SUPPORTED (1)
// #endif  /*   __GNUC__   */



// #define N_API              N_PASCAL    /* Pascal calling convention */
// #define N_API_VARARGS      N_CDECL     /* C calling convention */

#define N_UNUSED_VAR( x )  x = x

#ifdef DEBUG
#define N_STATIC                        /* This symbol visible to debugger */
#else
#define N_STATIC           static       /* Local function or variable */
#endif

   #define N_STATIC_VAR        static
   #define N_INTERN_VAR        static
   #define N_GLOBAL_VAR
   #define N_EXTERN_VAR        extern

   #define N_GLOBAL_LIBRARY( retType )       retType // N_API
   #define N_EXTERN_LIBRARY( retType )       retType // N_API
   #define N_GLOBAL_LIBRARY_C( retType )     retType
   #define N_EXTERN_LIBRARY_C( retType )  _N_EXTERN          retType
#define N_EXTERN_FUNC( retType )          retType // N_API
#define N_INTERN_FUNC( retType )          N_STATIC retType // N_API
#define N_GLOBAL_FUNC( retType )  retType

/* PART TWO: Basic type definitons */

typedef int8_t          nint8;
typedef int16_t         nint16;
typedef int32_t         nint32;
typedef uint8_t         nuint8;
typedef uint16_t        nuint16;
typedef uint32_t        nuint32;
typedef float           nreal32;
typedef double          nreal64;
typedef struct  _NUINT64_ {
      nuint32 Low_UINT32;
      nuint32 High_UINT32;
      } nuint64;
typedef signed int      nint;
typedef unsigned int    uint;
typedef unsigned int    nuint;
typedef unsigned int    nbool;
typedef long double     nreal80;
typedef double          nreal;

/* pointer types */

typedef nuint32 nhdl;
typedef nuint32 nid;
typedef nuint8  nflag8;
typedef nuint16 nflag16;
typedef nuint32 nflag32;
typedef nuint8  nbool8;
typedef nuint16 nbool16;
typedef nuint32 nbool32;
typedef nint32  nfixed;

//20101222 Neeraj Malhotra Fate #310969
//Uncomment the following definition for nstr8 and remove the "char" definition, once we have incorporated
//new datatype nstring at all places where warnings were seen.
typedef nuint8  nstr8;
//typedef char  nstr8;
typedef nuint16 nstr16;
typedef nstr8   nstr;
typedef nstr    nchar;
typedef nstr8   nchar8;
typedef nstr16  nchar16;
typedef nchar16 nwchar;
typedef nuint32 nparam;
//20101222 Neeraj Malhotra Fate #310969
//Defining a new type for storing character data. We will use this at places where we are getting signedness related warnings
//e.g. warning: pointer targets in passing argument 1 of 'open' differ in signedness
typedef char    nstring;

#define NWRCODE  nint32

/*
   Pointers to scalars.
*/

typedef void      *  nptr;
typedef void      *  npproc;
typedef nint8     *  pnint8;
typedef nuint8    *  pnuint8;
typedef pnuint8   *  ppnuint8;
typedef nint16    *  pnint16;
typedef nuint16   *  pnuint16;
typedef nint32    *  pnint32;
typedef nuint32   *  pnuint32;
typedef nint      *  pnint;
typedef nuint     *  pnuint;
typedef nflag8    *  pnflag8;
typedef nflag16   *  pnflag16;
typedef nflag32   *  pnflag32;
typedef nbool     *  pnbool;
typedef nbool8    *  pnbool8;
typedef nbool16   *  pnbool16;
typedef nbool32   *  pnbool32;
typedef nfixed    *  pnfixed;
typedef nstr      *  pnstr;
typedef pnstr     *  ppnstr;
typedef nstring   *  pnstring;
typedef pnstring  *  ppnstring;
typedef nstr16    *  pnstr16;
typedef pnstr16   *  ppnstr16;
typedef nstr8     *  pnstr8;
typedef pnstr8    *  ppnstr8;
typedef nchar     *  pnchar;
typedef pnchar    *  ppnchar;
typedef nchar16   *  pnchar16;
typedef pnchar16  *  ppnchar16;
typedef nchar8    *  pnchar8;
typedef pnchar8   *  ppnchar8;
typedef nwchar    *  pnwchar;
typedef pnwchar   *  ppnwchar;
typedef nreal     *  pnreal;
typedef nreal32   *  pnreal32;
typedef nreal64   *  pnreal64;
typedef nid       *  pnid;
typedef nhdl      *  pnhdl;
typedef nparam    *  pnparam;
typedef nptr      *  pnptr;
typedef npproc    *  pnpproc;

/* PART THREE: Integer Construction Macros */
/* ========================================================================
 *
 *  The primary issues arising in portability are:
 *
 *  1) Integer Representation
 *      Big Endian or Little Endian
 *
 *  2) Strict Alignment
 *      Can data be accessed even if it is not properly aligned
 *
 *  3) Structure Packing
 *
 *  4) Standard definitions for data types requiring specific
 *     size representations
 *      8-bit
 *      16-bit
 *      32-bit
 *
 * ASSUMPTIONS
 *
 *  2. All Compilers conform to the ANSI C standard.
 *
 *      The American National Standard for Information
 *      Systems - Progamming Language C, ANSI X3.159-1989.
 *
 *  3. Standard definitions for data types requiring specific
 *     size representations.
 *
 *      It is assumed that there will be a way of identifing
 *      8-, 16-, and 32-bit representations.  Each compiler supplier will
 *      be required to supply, in this header file, the appropriate
 *      definitions for these data types.
 *
 *      It is assumed that there will be a way of identifing
 *      8-, 16-, and 32-bit representations.  Each compiler supplier will
 *      be required to supply, in this header file, the appropriate
 *      definitions for these data types.
 *
 *  4. The Compiler supports the "volatile" Type Qualifier.
 *
 *  5. The Compiler and Architecture can automatically align structures to
 *     the alignment of the largest data item within the structures.  I.e.,
 *     a structure whose largest element is a byte can be byte aligned.
 *
 *  6. Pointers are represented as 32-bit quantities
 *
 *  7. All Target architectures will align:
 *      8-bit (byte) items on byte boundaries
 *      16-bit (word) items on 16-bit boundaries
 *      32-bit (long) items on 32-bit boundaries
 *
 *  8. The char data type representation is indeterminate -- it may be either 7
 *     or 8 bits, and it may be unsigned or signed.
 *
 *  9. Network integer representation is *always* Big Endian
 *
 * USAGE
 *
 *
 *  After making the machine definition, and including this file, the user will
 *  be able to use the following macros, routines, and typedefs in his or
 *  her program:
 *
 *  NSwapHiLo32(x)      <description goes here>
 *  NSwapHiLo16(x)      <description goes here>
 *  NSwapLoHi32(x)      <description goes here>
 *  NSwapLoHi16(x)      <description goes here>
 *  etc etc etc         <description goes here>
 *
 *
 */


#define NMake32(a, b)       ((nuint32) (((nuint16)(a)) | (((nuint32)(nuint16)(b)) << 16)))
#define NGetLo16(a32)      ((nuint16)a32)
#define NGetHi16(a32)      ((nuint16)((nuint32)(a32) >> 16))
#define NMake16(a, b)       ((nuint16) (((nuint8)(a)) | \
            (((nuint16)((nuint8)(b))) << 8)))
#define NGetLo8(a16)       ((nuint8)(a16))
#define NGetHi8(a16)       ((nuint8)((nuint16)(a16) >> 8))

#define NMakePair32        NMake32
#define NGetFirst16(a)     ((nint16) NGetLo16(a))
#define NGetSecond16(a)    ((nint16) NGetHi16(a))

#define NMakePair16        NMake16
#define NGetFirst8(a)      ((nint8) NGetLo8(a))
#define NGetSecond8(a)     ((nint8) NGetHi8(a))

#define NMakeFixed32(i, f)  NMake32(f, i)
#define NGetFixedInt16(a)  ((nint16) NGetHi16(a))
#define NGetFixedFrac16(a) ((nint16) NGetLo16(a))


/* Swap, Copy, Get and Set macros */

#define NSwap32(x) ((nuint32) (\
    (((nuint32)((x) & 0x000000FFL)) << 24) | \
    (((nuint32)((x) & 0x0000FF00L)) <<  8) | \
    (((nuint32)((x) & 0x00FF0000L)) >>  8) | \
    (((nuint32)((x) & 0xFF000000L)) >> 24)))

#define NSwap16(x) ((nuint16) (\
    (((nuint16)((x) & 0x00FF)) << 8) | \
    (((nuint16)((x) & 0xFF00)) >> 8)))

#define NCopySwap32(pDest, pSrc)  \
      (((pnuint8) (pDest))[0] = ((pnuint8) (pSrc))[3], \
       ((pnuint8) (pDest))[1] = ((pnuint8) (pSrc))[2], \
       ((pnuint8) (pDest))[2] = ((pnuint8) (pSrc))[1], \
       ((pnuint8) (pDest))[3] = ((pnuint8) (pSrc))[0])

#define NCopySwap16(pDest, pSrc)  \
      (((pnuint8) (pDest))[0] = ((pnuint8) (pSrc))[1], \
       ((pnuint8) (pDest))[1] = ((pnuint8) (pSrc))[0])

#if defined(BIG_ENDIAN)
   #if !defined(N_INT_ENDIAN_HI_LO)
      #define N_INT_ENDIAN_HI_LO
   #endif /* N_INT_ENDIAN_HI_LO */
#endif /* BIG_ENDIAN */

#if defined(N_INT_ENDIAN_HI_LO)

   #define NSwapHiLo32(x)      ((nuint32) (x))
   #define NSwapHiLo16(x)      ((nuint16) (x))
   #define NSwapLoHi32(x)      NSwap32(x)
   #define NSwapLoHi16(x)      NSwap16(x)

#else /* ! N_INT_ENDIAN_HI_LO */

   #define NSwapLoHi32(x)      ((nuint32) (x))
   #define NSwapLoHi16(x)      ((nuint16) (x))
   #define NSwapHiLo32(x)      NSwap32(x)
   #define NSwapHiLo16(x)      NSwap16(x)

#endif /* N_INT_ENDIAN_HI_LO */

#if defined(STRICT_ALIGNMENT)

   #define NCopy32(pDest, pSrc)   \
    (((pnuint8) (pDest))[0] = ((pnuint8) (pSrc))[0], \
     ((pnuint8) (pDest))[1] = ((pnuint8) (pSrc))[1], \
     ((pnuint8) (pDest))[2] = ((pnuint8) (pSrc))[2], \
     ((pnuint8) (pDest))[3] = ((pnuint8) (pSrc))[3])

   #define NCopy16(pDest, pSrc)   \
    (((pnuint8) (pDest))[0] = ((pnuint8) (pSrc))[0], \
     ((pnuint8) (pDest))[1] = ((pnuint8) (pSrc))[1])

#if defined(N_INT_ENDIAN_HI_LO)     /* NSetxx now works with lvalue on right */
   #define NSet32(pDest, src) \
    (((pnuint8) (pDest))[0] = (nuint8)(src >> 24), \
     ((pnuint8) (pDest))[1] = (nuint8)(src >> 16), \
     ((pnuint8) (pDest))[2] = (nuint8)(src >> 8), \
     ((pnuint8) (pDest))[3] = (nuint8)src)


   #define NSet16(pDest, src) \
    (((pnuint8) (pDest))[0] = (nuint8)(src >> 8) , \
     ((pnuint8) (pDest))[1] = (nuint8)src)

#else                      /* NSetxx now works with lvalue on right */
   #define NSet32(pDest, src) \
    ((((pnuint8) (pDest))[0] = (nuint8)src), \
     (((pnuint8) (pDest))[1] = (nuint8)(src >> 8)), \
     (((pnuint8) (pDest))[2] = (nuint8)(src >> 16)), \
     (((pnuint8) (pDest))[3] = (nuint8)(src >> 24)))


   #define NSet16(pDest, src) \
    (((pnuint8) (pDest))[0] = (nuint8)src, \
     ((pnuint8) (pDest))[1] = (nuint8)(src >> 8))
#endif                     /* NSetxx now works with lvalue on right */

   /*AM Changed '||' to '|' on NGet16() and NGet32() */

#if defined(N_INT_ENDIAN_HI_LO)     /* DFS HiLo machines need data in opposite order */

   #define NGet32(pSrc) \
    (((pnuint8) (pSrc))[3]         |  \
     (((pnuint8) (pSrc))[2] << 8)  |  \
     (((pnuint8) (pSrc))[1] << 16) |  \
     (((pnuint8) (pSrc))[0] << 24))

   #define NGet16(pSrc) \
    (((pnuint8) (pSrc))[1]         |  \
     (((pnuint8) (pSrc))[0] << 8))

#else /* ! N_INT_ENDIAN_HI_LO */

   #define NGet32(pSrc) \
    (((pnuint8) (pSrc))[0]         |  \
     (((pnuint8) (pSrc))[1] << 8)  |  \
     (((pnuint8) (pSrc))[2] << 16) |  \
     (((pnuint8) (pSrc))[3] << 24))

   #define NGet16(pSrc) \
    (((pnuint8) (pSrc))[0]         |  \
     (((pnuint8) (pSrc))[1] << 8))

#endif /* N_INT_ENDIAN_HI_LO */

#else /* ! STRICT_ALIGNMENT */

   #define NCopy32(pDest, pSrc)   \
    (*((pnuint32) (pDest)) = *((pnuint32) (pSrc)))

   #define NCopy16(pDest, pSrc)   \
    (*((pnuint16) (pDest)) = *((pnuint16) (pSrc)))

   #define NSet32(pDest, src) \
    (*((pnuint32) (pDest)) = src)

   #define NSet16(pDest, src) \
    (*((pnuint16) (pDest)) = src)

   #define NGet32(pSrc) \
    (*((pnuint32) (pSrc)))

   #define NGet16(pSrc) \
    (*((pnuint16) (pSrc)))

#endif /* STRICT_ALIGNMENT */


#if defined(N_INT_ENDIAN_HI_LO)

   #define NCopyHiLo32        NCopy32
   #define NCopyHiLo16        NCopy16
   #define NCopyLoHi32        NCopySwap32
   #define NCopyLoHi16        NCopySwap16

#else /* ! N_INT_ENDIAN_HI_LO */

   #define NCopyHiLo32        NCopySwap32
   #define NCopyHiLo16        NCopySwap16
   #define NCopyLoHi32        NCopy32
   #define NCopyLoHi16        NCopy16

#endif /* N_INT_ENDIAN_HI_LO */


#define NPad32(s)           ((s + 3) & ~3)
#define NPad16(s)           (((s) + 1) & ~1)

#define NAlign32(s)  *(s) = (void *) (((nuint32)*(s) + 3) & ~3);
#if NESTTARGETOS == VXMVP
#define NAlignv32(s)  (*s = (void*) (((nuint32)*(s) + 3) & ~3))
#define NAlignp32(s)  (*s =  (((nuint32)*(s) + 3) & ~3))
#else
#define NAlignv32(s)  *(s) = (void *) (((nuint32)*(s) + 3) & ~3);
#define NAlignp32(s)  *(s) = (void *) (((nuint32)*(s) + 3) & ~3);
#endif

#if defined( __cplusplus )
   /* Special 'extern' for C++ to avoid name mangling */
   #define _N_EXTERN       extern "C"
#else
   #define _N_EXTERN       extern
#endif /* __cplusplus */

   #define N_CALLBACK
   #define N_GLOBAL_CALLBACK( retType ) retType N_CDECL
   #define N_EXTERN_CALLBACK( retType ) \
                        _N_EXTERN retType N_FAR
   #define N_TYPEDEF_CALLBACK( retType, typeName) \
                        typedef retType (N_CALLBACK *typeName)
   #define N_TYPEDEF_CALLBACK_C( retType, typeName ) \
                        typedef retType (N_CDECL     *typeName)

   /*
      Untyped logical macros.
   */

   #define NMin(a,b)               ((a) < (b) ? (a) : (b))
   #define NMax(a,b)               ((a) > (b) ? (a) : (b))


#define N_ALWAYS        1
#define N_SUCCESS       0
#define N_FAILURE       (-1)
#define N_YES           1
#define N_NO            0
#define N_FALSE         0
#define N_TRUE          1
#define N_UNKNOWN       (N_TRUE + 1)
#define N_ACL_FAILED    5	//20140401 Leena Bugzilla #870349

#if !defined( N_INC_NO_OLD_CONSTANTS )

   #if !defined( TRUE )
      #define TRUE      1
   #endif

   #if !defined( FALSE )
      #define FALSE     0
   #endif

#endif

#endif /* CITYPES_H */

