/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novell�s prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 2005 - 2007 Novell, Inc.  All rights reserved.

June 14, 2007
//+==========================================================================+
//| Source module name: ippclient.h                                          |
//+==========================================================================+
//|$Author:   dtaylor $              $Locker$
//|$Revision:   1.16  $            $Name$ $State$
//|$Date:   27 Jul 2007 10:07:06  $
//+==========================================================================+
*/
/* Inclusion Control */
#ifndef IPPCLIENT_H
#define IPPCLIENT_H

#include <curl/curl.h>
#include <stdint.h>

//Constants
#define IPP_CLIENT_ERROR_PROBLEM_READING_ATTRS    -1
#define IPP_CLIENT_ERROR_OUT_OF_MEMORY            -2
#define IPP_CLIENT_ERROR_UNABLE_TO_CONNECT        -3
#define IPP_CLIENT_ERROR_PROBLEM_WRITING_FILE     -4
#define IPP_CLIENT_ERROR_PROBLEM_DOWNLOADING_FILE -5
#define IPP_CLIENT_ERROR_PROBLEM_UPLOADING_FILE   -6
#define IPP_CLIENT_ERROR_INVALID_PARAM            -7
#define IPP_CLIENT_ERROR_IPP_CREATE_FAILED        -8
#define IPP_CLIENT_ERROR_HTTP_CREATE_FAILED       -9

#define IPP_CLIENT_RQST_BUFF_SIZE 4096
#define IPP_CLIENT_CHUNKSIZE 65536

#define IPP_VERSION_1_0                         0x0100
#define IPP_VERSION_1_1                         0x0101
//Operation 1.0 requests
#define OPERATION_RESERVED                      0x0000
#define OPERATION_RESERVED2                     0x0001
#define OPERATION_PRINTJOB                      0x0002
#define OPERATION_PRINTURI                      0x0003
#define OPERATION_VALIDATEJOB                   0x0004
#define OPERATION_CREATEJOB                     0x0005
#define OPERATION_SENDDOCUMENT                  0x0006
#define OPERATION_SENDURI                       0x0007
#define OPERATION_CANCELJOB                     0x0008
#define OPERATION_GET_JOB_ATTRS                 0x0009
#define OPERATION_GETJOBS                       0x000A
#define OPERATION_GET_PRT_ATTRS                 0x000B
//Operation 1.1 requests (additions)
#define OPERATION_HOLD_JOB                      0x000C
#define OPERATION_RELEASE_JOB                   0x000D
#define OPERATION_RESTART_JOB                   0x000E

#define OPERATION_PAUSE_PRINTER                 0x0010
#define OPERATION_RESUME_PRINTER                0x0011
#define OPERATION_PURGE_JOBS                    0x0012
#define OPERATION_SET_PRINTER_ATTRIBUTES        0x0013
#define OPERATION_SET_JOB_ATTRIBUTES            0x0014
#define OPERATION_GET_PRINTER_SUPPORT_VALUES    0x0015
#define OPERATION_CREATE_PRINTER_SUBSCRIPTION   0x0016
#define OPERATION_CREATE_JOB_SUPSCRIPTION       0x0017
#define OPERATION_GETSUBSCRIPTION_ATTRIBUTES    0x0018
#define OPERATION_GET_SUBSCRIPTIONS             0x0019
#define OPERATION_RENEW_SUBSCRIPTIONS           0x001A
#define OPERATION_CANCEL_SUBSCRIPTIONS          0x001B
#define OPERATION_GET_NOTIFICATIONS             0x001C
#define OPERATION_SEND_NOTIFICATIONS            0x001D

#define OPERATION_GET_CLIENT_PRT_SUPPORT_FILES  0x0021
#define OPERATION_ENABLE_PRINTER                0x0022
#define OPERATION_DISABLE_PRINTER               0x0023

#define OPERATION_HOLD_NEW_JOBS                 0x0025
#define OPERATION_RELEASE_HELD_NEW_JOBS         0x0026
#define OPERATION_DEACTIVATE_PRINTER            0x0027
#define OPERATION_ACTIVATE_PRINTER              0x0028
#define OPERATION_RESTART_PRINTER               0x0029
#define OPERATION_SHUTDOWN_PRINTER              0x002A
#define OPERATION_STARTUP_PRINTER               0x002B
#define OPERATION_REPROCESS_JOB                 0x002C
#define OPERATION_CANCEL_CURRENT_JOB            0x002D
#define OPERATION_SUSPEND_CURRENT_JOB           0x002E
#define OPERATION_RESUME_JOB                    0x002F
#define OPERATION_PROMOTE_JOB                   0x0030
#define OPERATION_SCHEDULE_JOB_AFTER            0x0031

//Novell Private Space Operations
#define OPERATION_NOVELL_LIST_PRINTERS          0x401A
#define OPERATION_NOVELL_LIST_DRIVERS           0x401B
#define OPERATION_NOVELL_MGMT                   0x401C
#define OPERATION_NOVELL_ADD_OBJECT             0x401D
#define OPERATION_NOVELL_LIST_OBJECT            0x401E
#define OPERATION_NOVELL_DELETE_OBJECT          0x401F
#define OPERATION_NOVELL_GET_DATA               0x4020
#define OPERATION_NOVELL_8                      0x4021
#define OPERATION_NOVELL_9                      0x4022
#define OPERATION_NOVELL_10                     0x4023
#define OPERATION_NOVELL_11                     0x4024
#define OPERATION_NOVELL_12                     0x4025
#define OPERATION_NOVELL_GET_INFO               0x4029

//delimiter tags
#define DELIMITER_RESERVED                      0x00
#define DELIMITER_OPERATION_ATTR_TAG            0x01
#define DELIMITER_JOB_ATTR_TAG                  0x02
#define DELIMITER_END_OF_ATTR_TAG               0x03
#define DELIMITER_PRINTER_ATTR_TAG              0x04
#define DELIMITER_UNSUPPORTED_ATTR_TAG          0x05
#define DELIMITER_SUBSCRIPTION_ATTRIBUTES_TAG   0x06
#define DELIMITER_EVENT_NOTIFICATION_ATTR_TAG   0x07
#define DELIMITER_IDS_ATTR_TAG                  0x0D
#define DELIMITER_REPOSITORY_ATTR_TAG           0x0E
#define DELIMITER_RESOURCE_ATTR_TAG             0x0F

//out of band values
#define OUTOFBAND_UNSUPPORTED                   0x10
#define OUTOFBAND_DEFAULT                       0x11
#define OUTOFBAND_UNKNOWN                       0x12
#define OUTOFBAND_NO_VALUE                      0x13

#define OUTOFBAND_NOT_SETTABLE                  0x15
#define OUTOFBAND_DELETE_ATTRIBUTE              0x16
#define OUTOFBAND_ADMIN_DEFINE                  0x17

//integer values
#define INTEGER_RESERVED                        0x20
#define INTEGER_INTEGER                         0x21
#define INTEGER_BOOLEAN                         0x22
#define INTEGER_ENUM                            0x23

//octet string values
#define OCTETSTRING_UNSPECIFIEDFORMAT           0x30
#define OCTETSTRING_DATETIME                    0x31
#define OCTETSTRING_RESOLUTION                  0x32
#define OCTETSTRING_RANGEOFINTEGER              0x33
#define OCTETSTRING_BEGIN_COLLECTION            0x34
#define OCTETSTRING_TEXT_WITH_LANG              0x35
#define OCTETSTRING_NAME_WITH_LANG              0x36
#define OUTOFBAND_END_COLLECTION                0x37

//character string values
#define CHARACTERSTRING_RESERVED                0x40
#define CHARACTERSTRING_TEXT_NO_LANG            0x41
#define CHARACTERSTRING_NAME_NO_LANG            0x42
#define CHARACTERSTRING_RESERVED2               0x43
#define CHARACTERSTRING_KEYWORD                 0x44
#define CHARACTERSTRING_URI                     0x45
#define CHARACTERSTRING_URISCHEME               0x46
#define CHARACTERSTRING_CHARSET                 0x47
#define CHARACTERSTRING_NATURAL_LANG            0x48
#define CHARACTERSTRING_MIMEMEDIATYPE           0x49
#define CHARACTERSTRING_MEMBER_ATTR_NAME        0x4A

#ifdef  __cplusplus
extern "C" {
#endif

//Typedefs

typedef enum
{
   NO_VALUE,
   BYTE_VALUE,
   SHORT_VALUE,
   INT_VALUE,
   TEXT_VALUE,
   DATE_TIME_VALUE,
   RESOLUTION_VALUE,
   RANGE_VALUE,
   STRING_WITH_LANG_VALUE,
   OPAQUE_DATA_VALUE
} IPPValueEnum;

typedef struct IPPDate
{
   uint16_t year;
   uint8_t mon;
   uint8_t day;
   uint8_t hour;
   uint8_t min;
   uint8_t sec;
   uint8_t dsec;
   char utcd;
   uint8_t utch;
   uint8_t utcm;
} IPPDate;

typedef struct IPPClientValue
{
   struct IPPClientValue *next;
   IPPValueEnum valueType;
   union
   {
      int8_t   byteVal;
      int16_t  shortVal;
      int32_t  intVal;
      char*    stringVal;
      struct   { char* value; char* lang; }
               stringWithLangVal;
      struct   { int8_t* value; int len; }
               octetStringVal;
      IPPDate  dateTimeVal;
      struct   { int32_t crossFeed; int32_t valueFeed; int32_t units; }
               resolutionVal;
      struct   { int32_t bottom; int32_t top; }
               rangeVal;
   } value;
} IPPClientValue;

typedef struct IPPClientAttribute
{
   char *name;
   IPPClientValue *value;
   struct IPPClientAttribute *next;
} IPPClientAttribute;

typedef struct IPPAttributeGroup
{
   IPPClientAttribute *attr;
   struct IPPAttributeGroup *next;
   int8_t delimiter;
} IPPAttributeGroup;

typedef struct
{
   IPPAttributeGroup *attrGroup;
} IPPAttributeSet;

//Function prototypes

int GetResourceData(const char *uri, int writefd);
int PutResourceData(const char *uri, const char *name, int readfd, const char *compression, const char *user, const char *pass, char **resulturip);
IPPAttributeSet *ListResourceAttr(const char *uri, const char *requestedAttrs[], int *error);
IPPAttributeSet *ListResources(const char *uri, const char *requestedAttrs[], int *error);
void DestroyAttributeSet(IPPAttributeSet *attrSetPtr);
int ListResourceAddTimeVersionAndCorePackages(
   char                *uri,
   time_t              *result,
   char                *versionPtr,
   char                *corePackagePtr);

//Caller must call free(&outpufp)
int base64Encode(const unsigned char* buf, int len, unsigned char** outbufp);

//To get the PDE information of a MAC driver.
int GetResourceInfo(const char *uri, char **attrVal);

#ifdef  __cplusplus
}
#endif

#endif
