/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novells prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 1994 - 2008 Novell, Inc.  All rights reserved.

March 13, 2008
//+==========================================================================+
//| Source module name: nwdp_att.h                                           |
//+==========================================================================+
//|$Author: dtaylor $              $Locker:  $
//|$Revision: 1.14 $            $Name:  $ $State: Exp $
//|$Date: 2008/03/13 23:41:39 $
//+===========================================================================
*/
/* Inclusion Control */
#if !defined( NWDP_ATT_H )
   #define NWDP_ATT_H

/* Standard Library Header Includes */

   #include <stdint.h>
   #include <sys/time.h>

   #if !defined(CITYPES_H)
   //    // #define N_INC_NO_OLD_CONSTANTS
   //    // #define N_INC_NO_OLD_MACROS
      #include <citypes.h>
   //    // #undef N_INC_NO_OLD_MACROS
   //    // #undef N_INC_NO_OLD_CONSTANTS
   #endif /* CITYPES_H */

   // #if !defined(NWDP_TXT_H)
   //    #include <nwdp_txt.h>
   // #endif /* NWDP_TXT_H */

   #ifdef HAVE_CONFIG_H
      #include "IPRNT_config.h"
   #endif

/* Header Includes */

/* Manifest Constant Definitions */

#define NWDP_EVENT_TYPE_VALUE_CHANGE 0
#define NWDP_EVENT_TYPE_ERROR 1
#define NWDP_EVENT_TYPE_WARNING 2
#define NWDP_EVENT_TYPE_REPORT 3
#define NWDP_HOLD_UNTIL_NO_HOLD 0
#define NWDP_HOLD_UNTIL_DAYTIME 1
#define NWDP_HOLD_UNTIL_EVENING 2
#define NWDP_HOLD_UNTIL_NIGHT 3
#define NWDP_HOLD_UNTIL_WEEKEND 4
#define NWDP_HOLD_UNTIL_SECOND_SHIFT 5
#define NWDP_HOLD_UNTIL_THIRD_SHIFT 6
#define NWDP_HOLD_UNTIL_INDEFINITE 7


    /*
   // The 'oidLength' field of the NWDPOid structure cannot be more
   // than NWDP_OID_MAX_LENGTH.
   */
   #define NWDP_OID_MAX_LENGTH          127

   #if !defined(NWDP_NSRV_MAX_DN_CHARS)
      #define NWDP_NSRV_MAX_DN_CHARS          256
      #define NWDP_NSRV_MAX_DN_BYTES \
            ((NWDP_NSRV_MAX_DN_CHARS+1)*2)

      #define NWDP_NSRV_MAX_TREE_CHARS        32
      #define NWDP_NSRV_MAX_TREE_BYTES \
            ((NWDP_NSRV_MAX_TREE_CHARS+1)*2)

      #define NWDP_NSRV_GUID_BYTES            16
   #endif


/* Macro Definitions */

   #define NWDPOidLenMac(__oidPtr)                 \
      ((((pNWDPOid)(__oidPtr))->oidLength)      + \
       sizeof(((pNWDPOid)(__oidPtr))->asn1Type) + \
       sizeof(((pNWDPOid)(__oidPtr))->oidLength) )

   #define NWDPTextPtrInitMac(__textStructPtr,__unicodeStrPtr)          \
      (  (__textStructPtr)->itemPtr   = (pnint8)(__unicodeStrPtr),      \
         (__textStructPtr)->itemCount = (uint)unisize(__unicodeStrPtr) )

   #define NWDPTextInitMac(__textStruct,__unicodeStrPtr) \
         NWDPTextPtrInitMac(&(__textStruct),__unicodeStrPtr)

/* Type Definitions */

// #define N_PACK_1
// #include <npackon.h>


   typedef struct
   {
      uint8_t asn1Type;                     /* OID is a type 6 */
      uint8_t oidLength;                   /* excludes this byte; count of
                                             significant OID digits.*/
      uint8_t oid[NWDP_OID_MAX_LENGTH];    /* octet str; when stored in files
                                             it is zero filled.  */
   } NWDPOid, *pNWDPOid;

   /*
   // The Fully Qualified Name or FQN for NDS consists of the 'dnPtr' field
   // which points to the NetWare 4.x Distinguished Name string component
   // and the optional Tree Name.  If the 'treeOptionPtr' field is NULL then
   // the API which expects the NWDPNSrvFQN will assume the NDS Context
   // has had the DCK_TREE_NAME buffer set previously to correspond.
   */
   typedef enum {
      NWDP_NSRV_SYNTAX_NDS_WITH_TREE = 0
   } NWDPNSrvSyntaxEnum, *pNWDPNSrvSyntaxEnum;

   typedef struct {
      NWDPNSrvSyntaxEnum designator;
      union {
       struct {
          pnuint16   dn16Ptr;
          pnuint16   treeOption16Ptr;
       } ndsWithTree;
      } u;
   } NWDPNSrvFQN, *pNWDPNSrvFQN;

   /*
   // The NWDPNSrvFQNBuffer is intended to be capable of using
   // the least amount of memory. This means that the strings
   // referred to by the 'fqn' structure's pointers are packed into the
   // ndsWithTree buffer array and any tree name will appear at
   // ndsWithTree[unilen(&ndsWithTree[0])+1].
   */
   typedef struct {
      NWDPNSrvFQN fqn;
      union {
       int16_t ndsWithTree[NWDP_NSRV_MAX_DN_CHARS +
                           NWDP_NSRV_MAX_TREE_CHARS + 2];
      } bufferData;
   } NWDPNSrvFQNBuffer, *pNWDPNSrvFQNBuffer;


typedef enum {
   NWDP_AVT_NULL = 0,
   NWDP_AVT_TEXT = 1,
   NWDP_AVT_DESCRIPTIVE_NAME = 2,
   NWDP_AVT_DESCRIPTOR = 3,
   NWDP_AVT_MESSAGE = 4,
   NWDP_AVT_ERROR_MESSAGE = 5,
   NWDP_AVT_SIMPLE_NAME = 6,
   NWDP_AVT_DIST_NAME_STR = 7,
   NWDP_AVT_DIST_NAME_STR_SEQ = 8,
   NWDP_AVT_DELTA_TIME = 9,
   NWDP_AVT_TIME = 10,
   NWDP_AVT_INTEGER = 11,
   NWDP_AVT_INTEGER_SEQ = 12,
   NWDP_AVT_CARDINAL = 13,
   NWDP_AVT_CARDINAL_SEQ = 14,
   NWDP_AVT_POSITIVE_INTEGER = 15,
   NWDP_AVT_INTEGER_RANGE = 16,
   NWDP_AVT_CARDINAL_RANGE = 17,
   NWDP_AVT_MAXIMUM_INTEGER = 18,
   NWDP_AVT_MINIMUM_INTEGER = 19,
   NWDP_AVT_INTEGER_64 = 20,
   NWDP_AVT_INTEGER_64_SEQ = 21,
   NWDP_AVT_CARDINAL_64 = 22,
   NWDP_AVT_CARDINAL_64_SEQ = 23,
   NWDP_AVT_POSITIVE_INTEGER_64 = 24,
   NWDP_AVT_INTEGER_64_RANGE = 25,
   NWDP_AVT_CARDINAL_64_RANGE = 26,
   NWDP_AVT_MAXIMUM_INTEGER_64 = 27,
   NWDP_AVT_MINIMUM_INTEGER_64 = 28,
   NWDP_AVT_REAL = 29,
   NWDP_AVT_REAL_SEQ = 30,
   NWDP_AVT_NON_NEGATIVE_REAL = 31,
   NWDP_AVT_REAL_RANGE = 32,
   NWDP_AVT_NON_NEGATIV_REAL_RANGE = 33,
   NWDP_AVT_BOOLEAN = 34,
   NWDP_AVT_PERCENT = 35,
   NWDP_AVT_OBJECT_IDENTIFIER = 36,
   NWDP_AVT_OBJECT_IDENTIFIER_SEQ = 37,
   NWDP_AVT_NAME_OR_OID = 38,
   NWDP_AVT_NAME_OR_OID_SEQ = 39,
   NWDP_AVT_DISTINGUISHED_NAME = 40,
   NWDP_AVT_RDN_SEQUENCE = 41,
   NWDP_AVT_REALIZATION = 42,
   NWDP_AVT_MEDIUM_DIMENSIONS = 43,
   NWDP_AVT_DIMENSION = 44,
   NWDP_AVT_XY_DIMENSIONS = 45,
   NWDP_AVT_LOCATIONS = 46,
   NWDP_AVT_AREA = 47,
   NWDP_AVT_AREA_SEQ = 48,
   NWDP_AVT_EDGE = 49,
   NWDP_AVT_FONT_REFERENCE = 50,
   NWDP_AVT_CARDINAL_OR_OID = 51,
   NWDP_AVT_OID_CARDINAL_MAP = 52,
   NWDP_AVT_CARDINAL_OR_NAM_OR_OID = 53,
   NWDP_AVT_POSITIVE_INT_OR_OID = 54,
   NWDP_AVT_EVENT_HANDLING_PROFILE = 55,
   NWDP_AVT_OCTET_STRING = 56,
   NWDP_AVT_PRIORITY = 57,
   NWDP_AVT_LOCALE = 58,
   NWDP_AVT_METHOD_DELIVERY_ADDR = 59,
   NWDP_AVT_OBJECT_IDENTIFICATION = 60,
   NWDP_AVT_RESULTS_PROFILE = 61,
   NWDP_AVT_CRITERIA = 62,
   NWDP_AVT_JOB_PASSWORD = 63,
   NWDP_AVT_JOB_LEVEL = 64,
   NWDP_AVT_JOB_CATEGORIES = 65,
   NWDP_AVT_PRINT_CHECKPOINT = 66,
   NWDP_AVT_IGNORED_ATTRIBUTE = 67,
   NWDP_AVT_RESOURCE = 68,
   NWDP_AVT_MEDIUM_SUBSTITUTION = 69,
   NWDP_AVT_FONT_SUBSTITUTION = 70,
   NWDP_AVT_RESOURCE_CONTEXT_SEQ = 71,
   NWDP_AVT_SIDES = 72,
   NWDP_AVT_PAGE_SELECT_SEQ = 73,
   NWDP_AVT_PAGE_MEDIA_SELECT = 74,
   NWDP_AVT_DOCUMENT_CONTENT = 75,
   NWDP_AVT_PAGE_SIZE = 76,
   NWDP_AVT_PRESENTATION_DIRECTION = 77,
   NWDP_AVT_PAGE_ORDER = 78,
   NWDP_AVT_FILE_REFERENCE = 79,
   NWDP_AVT_MEDIUM_SOURCE_SIZE = 80,
   NWDP_AVT_INPUT_TRAY_MEDIUM = 81,
   NWDP_AVT_OUTPUT_BINS_CHARS = 82,
   NWDP_AVT_PAGE_ID_TYPE = 83,
   NWDP_AVT_LEVEL_RANGE = 84,
   NWDP_AVT_CATEGORY_SET = 85,
   NWDP_AVT_NUMBERS_UP_SUPPORTED = 86,
   NWDP_AVT_FINISHING = 87,
   NWDP_AVT_PRT_CONTAINED_OBJ_ID = 88,
   NWDP_AVT_PRT_CONFIG_OBJECT_ID = 89,
   NWDP_AVT_TYPED_NAME = 90,
   NWDP_AVT_NET_ADDRESS = 91,
   NWDP_AVT_XY_DIMENSIONS_VALUE = 92,
   NWDP_AVT_NAME_OR_OID_DIM_MAP = 93,
   NWDP_AVT_PRINTER_STATE_REASON = 94,
   NWDP_AVT_ENUMERATION = 95,
   NWDP_AVT_QUALIFIED_NAME = 96,
   // NWDP_AVT_QUALIFIED_NAME_SET = 97,
   NWDP_AVT_COLORANT_SET = 98,
   NWDP_AVT_RESOURCE_PRINTER_ID = 99,
   NWDP_AVT_EVENT_OBJECT_ID = 100,
   NWDP_AVT_QUALIFIED_NAME_MAP = 101,
   NWDP_AVT_FILE_PATH = 102,
   NWDP_AVT_URI = 103,
   NWDP_AVT_CARDNL_OR_ENUM_OR_TIME = 104,
   NWDP_AVT_PRT_CONTAIN_OBJ_ID_SET = 105,
   NWDP_AVT_OCTET_STRING_PAIR = 106,
   NWDP_AVT_OCTET_STRING_INT_PAIR = 107,
   NWDP_AVT_XRI = 108,
   NWDP_AVT_EVENT_HANDLING_PROFIL2 = 109,
   NWDP_AVT_DRIVER_PROFILE_ID = 110,
   NWDP_AVT_PRINTER_REDIRECT = 111
} NWDPAVTEnum, *pNWDPAVTEnum;

typedef struct {
   uint     itemCount;
   int8_t  *itemPtr;
} NWDPText, *pNWDPText;

typedef struct {
   uint     itemCount;
   pnuint8  itemPtr;
} NWDPOctetString, *pNWDPOctetString;

typedef struct {
   int      flag;
   int      value;
} NWDPIntegerOption, *pNWDPIntegerOption;

typedef struct {
   uint     oidStructSize;
   pNWDPOid oidStructPtr;
} NWDPObjectIdentifier, *pNWDPObjectIdentifier;

typedef enum {
   NWDP_NAME_OR_OID_NONE = 0,
   NWDP_NAME_OR_OID_GLOBAL = 1,
   NWDP_NAME_OR_OID_LOCAL = 2,
} NWDPNameOrOidEnum, *pNWDPNameOrOidEnum;

typedef struct {
   NWDPNameOrOidEnum designator;
   union {
      NWDPObjectIdentifier globalForm;
      NWDPText localForm;
   } u;
} NWDPNameOrOid, *pNWDPNameOrOid;

// typedef struct {
//    NWDPText name;
//    pNWDPNameOrOid syntaxOptionPtr;
// } NWDPDistinguishedNameString, *pNWDPDistinguishedNameString;

// typedef struct {
//    PackText name;
//    nuint32 syntaxOptionPtr;
// } PackDistinguishedNameString, *pPackDistinguishedNameString;

typedef enum {
   NWDP_QUALIFIED_NAME_NONE = 0,
   NWDP_QUALIFIED_NAME_SIMPLE = 1,
   NWDP_QUALIFIED_NAME_NDS = 2,
} NWDPQualifiedNameEnum, *pNWDPQualifiedNameEnum;

typedef struct {
   NWDPText object;
   NWDPText treeOption;
} NWDPNdsName, *pNWDPNdsName;

typedef struct {
   NWDPQualifiedNameEnum designator;
   union {
      NWDPText simpleName;
      NWDPNdsName ndsName;
   } u;
} NWDPQualifiedName, *pNWDPQualifiedName;

typedef struct {
   uint                 itemCount;
   pNWDPQualifiedName   itemPtr;
} NWDPQualifiedNameSet, *pNWDPQualifiedNameSet;

// typedef struct {
//    uint                          itemCount;
//    pNWDPDistinguishedNameString  itemPtr;
// } NWDPDistinguishedNameStrSeq, *pNWDPDistinguishedNameStrSeq;

// typedef struct {
//    uint     itemCount;
//    nuint32  itemOffset;
// } PackDistinguishedNameStrSeq, *pPackDistinguishedNameStrSeq;

typedef struct {
   uint     itemCount;
   pnint itemPtr;
} NWDPIntegerSeq, *pNWDPIntegerSeq;

typedef struct {
   uint itemCount;
   pnuint itemPtr;
} NWDPCardinalSeq, *pNWDPCardinalSeq;

typedef struct {
   int lowerBound;
   int upperBound;
} NWDPIntegerRange, *pNWDPIntegerRange;

typedef struct {
   uint lowerBound;
   uint upperBound;
} NWDPCardinalRange, *pNWDPCardinalRange;

typedef struct {
   int      flag;
   nreal64  value;
} NWDPRealOption, *pNWDPRealOption;

typedef struct {
   uint     itemCount;
   pnreal64 itemPtr;
} NWDPRealSet, *pNWDPRealSet;

typedef struct {
   nreal64 lowerBound;
   nreal64 upperBound;
} NWDPRealRange, *pNWDPRealRange;

typedef struct {
   uint                    itemCount;
   pNWDPObjectIdentifier   itemPtr;
} NWDPObjectIdentifierSet, *pNWDPObjectIdentifierSet;

typedef struct {
   uint           itemCount;
   pNWDPNameOrOid itemPtr;
} NWDPNameOrOidSet, *pNWDPNameOrOidSet;

// typedef struct {
//    uint        itemCount;
//    pNWDPText   itemPtr;
// } NWDPRDNSequence, *pNWDPRDNSequence;

// typedef struct {
//    uint     itemCount;
//    nuint32  itemOffset;
// } PackRDNSequence, *pPackRDNSequence;

typedef enum {
   NWDP_REALIZATION_LOGICAL = 0,
   NWDP_REALIZATION_PHYSICAL = 1,
   NWDP_REALIZATION_LOG_AND_PHYS = 2,
} NWDPRealizationEnum, *pNWDPRealizationEnum;

typedef struct {
   nreal64 xDimension;
   nreal64 yDimension;
} NWDPXYRealDimensions, *pNWDPXYRealDimensions;

typedef enum {
   NWDP_DIMENSION_NUMERIC = 0,
   NWDP_DIMENSION_NAMED = 1,
} NWDPDimValueEnum, *pNWDPDimValueEnum;

typedef struct {
   NWDPDimValueEnum designator;
   union {
      nreal64 numericValue;
      NWDPNameOrOid namedValue;
   } u;
} NWDPDimValue, *pNWDPDimValue;

typedef struct {
   NWDPDimValue value;
   NWDPRealOption toleranceOption;
} NWDPDimension, *pNWDPDimension;

typedef struct {
   uint  xDimension;
   uint  yDimension;
} NWDPXYCardinalDimensions, *pNWDPXYCardinalDimensions;

typedef enum {
   NWDP_DIM_XY_REAL = 0,
   NWDP_DIM_XY_NAMED = 1,
   NWDP_DIM_XY_CARDINAL = 2,
} NWDPXYDimensionsValueEnum, *pNWDPXYDimensionsValueEnum;

typedef struct {
   NWDPXYDimensionsValueEnum designator;
   union {
      NWDPXYRealDimensions realValue;
      NWDPNameOrOid namedValue;
      NWDPXYCardinalDimensions cardinalValue;
   } u;
} NWDPXYDimensionsValue, *pNWDPXYDimensionsValue;

typedef struct {
   NWDPXYDimensionsValue value;
   NWDPRealOption toleranceOption;
} NWDPXYDimensions, *pNWDPXYDimensions;

typedef enum {
   NWDP_LOCATION_NUMERIC = 0,
   NWDP_LOCATION_NAMED = 1,
} NWDPLocationValueEnum, *pNWDPLocationValueEnum;

typedef struct {
   NWDPLocationValueEnum designator;
   union {
      NWDPRealSet numericValueSeq;
      NWDPNameOrOid namedValue;
   } u;
} NWDPLocationValue, *pNWDPLocationValue;

typedef struct {
   NWDPLocationValue value;
   NWDPRealOption toleranceOption;
} NWDPLocations, *pNWDPLocations;

typedef struct {
   nreal64 minimumX;
   nreal64 maximumX;
   nreal64 minimumY;
   nreal64 maximumY;
} NWDPArea, *pNWDPArea;

typedef struct {
   uint        itemCount;
   pNWDPArea   itemPtr;
} NWDPAreaSeq, *pNWDPAreaSeq;

typedef enum {
   NWDP_EDGE_BOTTOM = 0,
   NWDP_EDGE_RIGHT = 1,
   NWDP_EDGE_TOP = 2,
   NWDP_EDGE_LEFT = 3,
} NWDPEdge, *pNWDPEdge;

typedef struct {
   int      flag;
   NWDPEdge value;
} NWDPEdgeOption, *pNWDPEdgeOption;

typedef enum {
   NWDP_CARDINAL_OR_OID_NUMBER = 0,
   NWDP_CARDINAL_OR_OID_ID = 1,
} NWDPCardinalOrOidEnum, *pNWDPCardinalOrOidEnum;

typedef struct {
   NWDPCardinalOrOidEnum designator;
   union {
      uint                 cardinal;
      NWDPObjectIdentifier oid;
   } u;
} NWDPCardinalOrOid, *pNWDPCardinalOrOid;

typedef struct {
   NWDPObjectIdentifier oidOption;
   uint                 cardinal;
} NWDPOidCardinalMap, *pNWDPOidCardinalMap;

typedef enum {
   NWDP_CARDINAL_OR_NAM_OR_OID_NUM = 0,
   NWDP_CARDINAL_OR_NAME_OR_OID_ID = 1,
} NWDPCardinalOrNameOrOidEnum, *pNWDPCardinalOrNameOrOidEnum;

typedef struct {
   NWDPCardinalOrNameOrOidEnum designator;
   union {
      uint           cardinal;
      NWDPNameOrOid  nameOrOid;
   } u;
} NWDPCardinalOrNameOrOid, *pNWDPCardinalOrNameOrOid;

typedef enum {
   NWDP_INT_OR_OID_ID = 0,
   NWDP_INT_OR_OID_NUMBER = 1,
} NWDPPositivIntegerOrOidEnum, *pNWDPPositivIntegerOrOidEnum;

typedef struct {
   NWDPPositivIntegerOrOidEnum designator;
   union {
      NWDPObjectIdentifier oid;
      int                  integer;
   } u;
} NWDPPositiveIntegerOrOid, *pNWDPPositiveIntegerOrOid;

typedef struct {
   NWDPText printerName;
   uint     localIdentifier;
} NWDPPrtContainedObjectId, *pNWDPPrtContainedObjectId;

typedef struct {
   uint                       itemCount;
   pNWDPPrtContainedObjectId  itemPtr;
} NWDPPrtContainedObjectIdSet, *pNWDPPrtContainedObjectIdSet;

typedef struct {
   NWDPPrtContainedObjectId jobIdentifier;
   uint                     documentNumber;
} NWDPDocumentIdentifier, *pNWDPDocumentIdentifier;

// typedef enum {
//    NWDP_DA_OR_ADDR_AND_OR_DIR_NAME = 0,
//    NWDP_DA_DISTINGUISHED_NAME = 1,
//    NWDP_DA_TEXT = 2,
//    NWDP_DA_OCTET_STRING = 3,
//    NWDP_DA_DIST_NAME_STRING = 4,
//    NWDP_DA_RPC_ADDRESS = 5,
//    NWDP_DA_QUALIFIED_NAME = 6,
// } NWDPDeliveryAddressEnum, *pNWDPDeliveryAddressEnum;

// typedef struct {
//    NWDPDeliveryAddressEnum designator;
//    union {
//       NWDPText mhsAddress;
//       NWDPText distinguishedName;
//       NWDPText text;
//       NWDPOctetString octetString;
//       NWDPDistinguishedNameString distinguishedNameString;
//       NWDPQualifiedName qualifiedName;
//    } u;
// } NWDPDeliveryAddress, *pNWDPDeliveryAddress;

// typedef struct {
//    NWDPDeliveryAddressEnum designator;
//    union {
//       PackText mhsAddress;
//       PackText distinguishedName;
//       PackText text;
//       PackOctetString octetString;
//       PackDistinguishedNameString distinguishedNameString;
//       PackQualifiedName qualifiedName;
//    } u;
// } PackDeliveryAddress, *pPackDeliveryAddress;

typedef struct {
   NWDPText          printerName;
   NWDPQualifiedName qualifiedName;
} NWDPPrtConfigObjectId, *pNWDPPrtConfigObjectId;

// typedef struct {
//    NWDPText name;
//    NWDPObjectIdentifier containingClassOid;
//    nint32 eventType;
// } NWDPEventObjectId, *pNWDPEventObjectId;
//
// typedef struct {
//    PackText name;
//    PackObjectIdentifier containingClassOid;
//    nint32 eventType;
// } PackEventObjectId, *pPackEventObjectId;

typedef struct {
   uint     osType;
   NWDPText driverName;
   NWDPText profileName;
} NWDPDriverProfileId, *pNWDPDriverProfileId;

typedef struct {
   NWDPQualifiedName primary;
   NWDPQualifiedName secondary;
} NWDPQualifiedNameMap, *pNWDPQualifiedNameMap;

typedef enum {
   NWDP_CARD_OR_ENUM_OR_TIME_CARD = 0,
   NWDP_CARD_OR_ENUM_OR_TIME_ENUM = 1,
   NWDP_CARD_OR_ENUM_OR_TIME_TIME = 2,
} NWDPCardinalOrEnumOrTimeEnum, *pNWDPCardinalOrEnumOrTimeEnum;

typedef struct {
   NWDPCardinalOrEnumOrTimeEnum designator;
   union {
      uint  cardinal;
      int   enumeration;
      uint  time;
   } u;
} NWDPCardinalOrEnumOrTime, *pNWDPCardinalOrEnumOrTime;

typedef struct {
   NWDPOctetString octetString1;
   NWDPOctetString octetString2;
} NWDPOctetStringPair, *pNWDPOctetStringPair;

typedef struct {
   NWDPOctetString octetString;
   int   integer1;
   int   integer2;
} NWDPOctetStringIntegerPair, *pNWDPOctetStringIntegerPair;

// typedef struct {
//    uint     itemCount;
//    pnint8   itemPtr;
// } NWDPPrivAttrCertificate, *pNWDPPrivAttrCertificate;

// typedef struct {
//    NWDPPrivAttrCertificate operationPacOption;
//    NWDPPrivAttrCertificate proxyPacOption;
// } NWDPPrivileges, *pNWDPPrivileges;

// typedef struct {
//    NWDPObjectIdentifier method;
//    NWDPDeliveryAddress address;
// } NWDPDeliveryAddrForMethod, *pNWDPDeliveryAddrForMethod;

// typedef struct {
//    PackObjectIdentifier method;
//    PackDeliveryAddress address;
// } PackDeliveryAddrForMethod, *pPackDeliveryAddrForMethod;

typedef enum {
   NWDP_OBJ_ID_NONE = 0,
   NWDP_OBJ_ID_PRT_CONTAIND_OBJ_ID = 1,
   NWDP_OBJ_ID_DOCUMENT_IDENTIFIER = 2,
   NWDP_OBJ_ID_OBJECT_IDENTIFIER = 3,
   NWDP_OBJ_ID_OBJECT_NAME = 4,
   NWDP_OBJ_ID_NAME_OR_OID = 5,
   NWDP_OBJ_ID_SIMPLE_NAME = 6,
   NWDP_OBJ_ID_PRT_CONFIG_OBJ_ID = 7,
   NWDP_OBJ_ID_QUALIFIED_NAME = 8,
   NWDP_OBJ_ID_EVENT_OBJECT_ID = 9,
   NWDP_OBJ_ID_DRIVER_PROFILE_ID = 10,
} NWDPObjIdentificationEnum, *pNWDPObjIdentificationEnum;

typedef struct {
   NWDPObjIdentificationEnum designator;
   union {
      NWDPPrtContainedObjectId prtContainedObjectId;
      NWDPDocumentIdentifier documentIdentifier;
      NWDPObjectIdentifier objectIdentifier;
      // NWDPDistinguishedNameString objectName;
      NWDPNameOrOid nameOrOid;
      NWDPText simpleName;
      NWDPPrtConfigObjectId prtConfigObjectId;
      NWDPQualifiedName qualifiedName;
      // NWDPEventObjectId eventObjectId;
      NWDPDriverProfileId driverProfileId;
   } u;
} NWDPObjectIdentification, *pNWDPObjectIdentification;

typedef struct {
   uint                       itemCount;
   pNWDPObjectIdentification  itemPtr;
} NWDPObjectIdentificationSeq, *pNWDPObjectIdentificationSeq;

typedef struct {
   NWDPText name;
   uint     level;
   uint     interval;
} NWDPTypedName, *pNWDPTypedName;

typedef enum {
   NWDP_NET_IPX = 0,
   NWDP_NET_IP = 1,
   NWDP_NET_SDLC = 2,
   NWDP_NET_TOKENRING_ETHERNET = 3,
   NWDP_NET_OSI = 4,
   NWDP_NET_APPLETALK = 5,
   NWDP_NET_COUNT = 6,
} NWDPNetAddressTypeEnum, *pNWDPNetAddressTypeEnum;

typedef struct {
   NWDPNetAddressTypeEnum type;
   NWDPOctetString address;
} NWDPNetAddress, *pNWDPNetAddress;

typedef struct {
   NWDPNameOrOid nameOrOid;
   NWDPXYCardinalDimensions value;
} NWDPNameOrOidDimensionMap, *pNWDPNameOrOidDimensionMap;

typedef enum {
   NWDP_STATE_SEVERITY_OTHER = 1,
   NWDP_STATE_SEVERITY_WARNING = 1 + 1,
   NWDP_STATE_SEVERITY_CRITICAL = 1 + 2,
} NWDPStateSeverityEnum, *pNWDPStateSeverityEnum;

typedef enum {
   NWDP_TRAINING_OTHER = 1,
   NWDP_TRAINING_UNKNOWN = 1 + 1,
   NWDP_TRAINING_UNTRAINED = 1 + 2,
   NWDP_TRAINING_TRAINED = 1 + 3,
   NWDP_TRAINING_FIELD_SERVICE = 1 + 4,
   NWDP_TRAINING_MANAGEMENT = 1 + 5,
} NWDPTrainingEnum, *pNWDPTrainingEnum;

typedef struct {
   NWDPNameOrOid              identifier;
   NWDPStateSeverityEnum      severity;
   NWDPTrainingEnum           trainingLevel;
   NWDPObjectIdentifier       objectClassOid;
   NWDPObjectIdentification   objectIdentification;
   time_t                     time;
   pNWDPNameOrOid             messageOptionPtr;
} NWDPPrinterStateReason, *pNWDPPrinterStateReason;

// typedef enum {
//    NWDP_PERSISTENCE_PERMANENT = 0,
//    NWDP_PERSISTENCE_VOLATILE = 1,
// } NWDPPersistenceEnum, *pNWDPPersistenceEnum;

// typedef enum {
//    NWDP_ADDR_ITEM_USER = 0,
//    NWDP_ADDR_ITEM_SERVER = 1,
//    NWDP_ADDR_ITEM_VOLUME = 2,
//    NWDP_ADDR_ITEM_ORG_UNIT = 3,
//    NWDP_ADDR_ITEM_ORG = 4,
//    NWDP_ADDR_ITEM_GROUP = 5,
//    NWDP_ADDR_ITEM_DN = 6,
//    NWDP_ADDR_ITEM_USR_OR_CONTAINER = 7,
//    NWDP_ADDR_ITEM_CASE_EXACT_STR = 8,
//    NWDP_ADDR_ITEM_CASE_IGNORE_STR = 9,
//    NWDP_ADDR_ITEM_NUMERIC_STR = 10,
//    NWDP_ADDR_ITEM_DOS_FILENAME = 11,
//    NWDP_ADDR_ITEM_PHONE_NUMBER = 12,
//    NWDP_ADDR_ITEM_BOOLEAN = 13,
//    NWDP_ADDR_ITEM_INTEGER = 14,
//    NWDP_ADDR_ITEM_NET_ADDRESS = 15,
//    NWDP_ADDR_ITEM_CHOICE = 16,
//    NWDP_ADDR_ITEM_GROUPWISE_USER = 17,
// } NWDPAddressItemTypeEnum, *pNWDPAddressItemTypeEnum;

// typedef struct {
//    NWDPAddressItemTypeEnum designator;
//    union {
//       NWDPQualifiedName userName;
//       NWDPQualifiedName serverName;
//       NWDPQualifiedName volumeName;
//       NWDPQualifiedName orgUnitName;
//       NWDPQualifiedName orgName;
//       NWDPQualifiedName groupName;
//       NWDPQualifiedName dN;
//       NWDPQualifiedName userOrContainerName;
//       NWDPText          ceStr;
//       NWDPText          ciStr;
//       NWDPText          numStr;
//       NWDPText          filename;
//       NWDPText          phoneNumber;
//       nbool             bFlag;
//       int               integer;
//       NWDPNetAddress    netAddress;
//       NWDPText          choice;
//       NWDPText          gwUser;
//    } u;
// } NWDPAddressItem, *pNWDPAddressItem;

typedef struct {
   NWDPObjectIdentifier       deliveryMethodOption;
   NWDPNameOrOid              resultsSetCommentOption;
   int                        jobCopies;
   NWDPPrtContainedObjectId   outputBinOption;
} NWDPResultsProfile, *pNWDPResultsProfile;

// typedef struct {
//    NWDPAVTEnum designator;
//    union {
//       int   deltaTime;
//       uint  time;
//       int   integer;
//       uint  cardinal;
//       int   positiveInteger;
//       int   percent;
//    } u;
// } NWDPCriterionThreshold, *pNWDPCriterionThreshold;

// typedef struct {
//    NWDPObjectIdentifier type;
//    NWDPCriterionThreshold threshold;
// } NWDPCriteria, *pNWDPCriteria;

// typedef struct {
//    PackObjectIdentifier type;
//    NWDPCriterionThreshold threshold;
// } PackCriteria, *pPackCriteria;

// typedef struct {
//    NWDPObjectIdentifier organizationId;
//    uint                 level;
// } NWDPJobLevel, *pNWDPJobLevel;

// typedef struct {
//    NWDPObjectIdentifier organizationId;
//    NWDPCardinalSeq categories;
// } NWDPJobCategories, *pNWDPJobCategories;

typedef struct {
   NWDPAVTEnum designator;
   union {
      NWDPObjectIdentifier identifier;
      NWDPNameOrOid nameOrOid;
   } u;
} NWDPIgnoredAttributeValue, *pNWDPIgnoredAttributeValue;

typedef struct {
   uint                       itemCount;
   pNWDPIgnoredAttributeValue itemPtr;
} NWDPIgnoredAttrValueSet, *pNWDPIgnoredAttrValueSet;

typedef struct {
   uint                 documentNumberOption;
   NWDPObjectIdentifier attributeId;
   NWDPIgnoredAttrValueSet values;
} NWDPIgnoredAttribute, *pNWDPIgnoredAttribute;

// typedef enum {
//    NWDP_RESOURCE_NAME_OR_OID = 0,
//    NWDP_RESOURCE_TEXT = 1,
// } NWDPResourceEnum, *pNWDPResourceEnum;

// typedef struct {
//    NWDPResourceEnum designator;
//    union {
//       NWDPNameOrOid nameOrOid;
//       NWDPText name;
//    } u;
// } NWDPResource, *pNWDPResource;

// typedef struct {
//    NWDPResourceEnum designator;
//    union {
//       PackNameOrOid nameOrOid;
//       PackText name;
//    } u;
// } PackResource, *pPackResource;

// typedef struct {
//    NWDPNameOrOid original;
//    NWDPNameOrOid substitution;
// } NWDPMediumSubstitution, *pNWDPMediumSubstitution;

// typedef struct {
//    PackNameOrOid original;
//    PackNameOrOid substitution;
// } PackMediumSubstitution, *pPackMediumSubstitution;

// typedef struct {
//    NWDPText original;
//    NWDPText substitution;
// } NWDPFontSubstitution, *pNWDPFontSubstitution;

// typedef struct {
//    PackText original;
//    PackText substitution;
// } PackFontSubstitution, *pPackFontSubstitution;

// typedef enum {
//    NWDP_RESOURCE_CONTXT_NAM_OR_OID = 0,
//    NWDP_RESOURCE_CONTEXT_TEXT = 1,
// } NWDPResourceContextEnum, *pNWDPResourceContextEnum;

// typedef struct {
//    NWDPResourceContextEnum designator;
//    union {
//       NWDPNameOrOid objectName;
//       NWDPText pathName;
//    } u;
// } NWDPResourceContext, *pNWDPResourceContext;

// typedef struct {
//    NWDPResourceContextEnum designator;
//    union {
//       PackNameOrOid objectName;
//       PackText pathName;
//    } u;
// } PackResourceContext, *pPackResourceContext;

// typedef struct {
//    uint                 itemCount;
//    pNWDPResourceContext itemPtr;
// } NWDPResourceContextSeq, *pNWDPResourceContextSeq;

// typedef struct {
//    uint     itemCount;
//    nuint32  itemOffset;
// } PackResourceContextSeq, *pPackResourceContextSeq;

typedef enum {
   NWDP_PAGE_ID_NOMINAL_NUMBER = 0,
   NWDP_PAGE_ID_ALPHANUMERIC = 1,
   NWDP_PAGE_ID_TAG = 2,
} NWDPPageIdentifierEnum, *pNWDPPageIdentifierEnum;

typedef struct {
   NWDPPageIdentifierEnum designator;
   union {
      int      nominalPageNumber;
      NWDPText alphanumericPageNumber;
      NWDPNameOrOid pageTag;
   } u;
} NWDPPageIdentifier, *pNWDPPageIdentifier;

typedef struct {
   int                  flag;
   NWDPPageIdentifier   value;
} NWDPPageIdentifierOption, *pNWDPPageIdentifierOption;

typedef struct {
   NWDPPageIdentifierOption beginningPage;
   NWDPPageIdentifierOption endingPage;
} NWDPPageSelect, *pNWDPPageSelect;

// typedef struct {
//    uint              itemCount;
//    pNWDPPageSelect   itemPtr;
// } NWDPPageSelectSequence, *pNWDPPageSelectSequence;

// typedef struct {
//    uint     itemCount;
//    nuint32  itemOffset;
// } PackPageSelectSequence, *pPackPageSelectSequence;

typedef enum {
   NWDP_DOC_CONTENT_INCLUDED = 0,
   NWDP_DOC_CONTENT_REFERENCED = 1,
} NWDPDocumentContentEnum, *pNWDPDocumentContentEnum;

typedef struct {
   NWDPDocumentContentEnum designator;
   union {
      NWDPOctetString includedDocument;
      // NWDPDistinguishedNameString referencedDocument;
   } u;
} NWDPDocumentContent, *pNWDPDocumentContent;

typedef enum {
   NWDP_PAGE_SIZE_ID = 0,
   NWDP_PAGE_SIZE_DIMENSIONS = 1,
} NWDPPageSizeEnum, *pNWDPPageSizeEnum;

typedef struct {
   NWDPPageSizeEnum designator;
   union {
      NWDPObjectIdentifier pageSizeId;
      NWDPXYRealDimensions pageDimensions;
   } u;
} NWDPPageSize, *pNWDPPageSize;

typedef enum {
   NWDP_DIR_TO_RIGHT_TO_BOTTOM = 0,
   NWDP_DIR_TO_LEFT_TO_BOTTOM = 1,
   NWDP_DIR_BIDIRECT_TO_BOTTOM = 2,
   NWDP_DIR_TO_RIGHT_TO_TOP = 3,
   NWDP_DIR_TO_LEFT_TO_TOP = 4,
   NWDP_DIR_BIDIRECT_TO_TOP = 5,
   NWDP_DIR_TO_BOTTOM_TO_RIGHT = 6,
   NWDP_DIR_TO_BOTTOM_TO_LEFT = 7,
   NWDP_DIR_TO_TOP_TO_LEFT = 8,
   NWDP_DIR_TO_TOP_TO_RIGHT = 9,
} NWDPPresentatnDirectionEnum, *pNWDPPresentatnDirectionEnum;

typedef enum {
   NWDP_PAGE_ORDER_UNKNOWN = 0,
   NWDP_PAGE_ORDER_FIRST_TO_LAST = 1,
   NWDP_PAGE_ORDER_LAST_TO_FIRST = 2,
} NWDPPageOrderTypeEnum, *pNWDPPageOrderTypeEnum;

typedef enum {
   NWDP_PAGE_ID_TYPE_NUMERIC = 0,
   NWDP_PAGE_ID_TYPE_ALPHANUMERIC = 1,
   NWDP_PAGE_ID_TYPE_TAG = 2,
} NWDPPageIdTypeEnum, *pNWDPPageIdTypeEnum;

typedef enum {
   NWDP_MEDIA_SELECT_ALL_PAGES = 0,
   NWDP_MEDIA_SELECT_SELECTD_PAGES = 1,
} NWDPMediaSelectEnum, *pNWDPMediaSelectEnum;

typedef struct {
   NWDPPageSelect pageRange;
   NWDPNameOrOid mediumId;
} NWDPMediaSelect, *pNWDPMediaSelect;

typedef struct {
   uint              itemCount;
   pNWDPMediaSelect  itemPtr;
} NWDPMediaSelectSeq, *pNWDPMediaSelectSeq;

typedef struct {
   NWDPMediaSelectEnum designator;
   union {
      NWDPNameOrOid        mediumForAllPages;
      NWDPMediaSelectSeq   mediumForSelectedPagesSeq;
   } u;
} NWDPPageMediaSelect, *pNWDPPageMediaSelect;

typedef enum {
   NWDP_MEDIUM_SIZE_DISCRETE = 0,
   NWDP_MEDIUM_SIZE_CONTINUOUS = 1,
} NWDPMediumSizeEnum, *pNWDPMediumSizeEnum;

typedef struct {
   NWDPPageSize pageSize;
   nbool longEdgeFeeds;
   NWDPArea assuredReproductionArea;
} NWDPMediumDiscreteSizes, *pNWDPMediumDiscreteSizes;

typedef struct {
   NWDPRealRange sizeRangeAcrossFeedDirection;
   nreal64 sizeIncrementAcrossFeedDir;
   NWDPRealRange sizeRangeInFeedDirection;
   nreal64 sizeIncrementInFeedDir;
   nbool longEdgeFeeds;
   NWDPArea GenericAssuredReproductionArea;
} NWDPMediumContinuousSizes, *pNWDPMediumContinuousSizes;

typedef struct {
   NWDPMediumSizeEnum designator;
   union {
      NWDPMediumDiscreteSizes discreteSizes;
      NWDPMediumContinuousSizes continuousSizes;
   } u;
} NWDPMediumSize, *pNWDPMediumSize;

// typedef struct {
//    pNWDPNameOrOid inputTrayOptionPtr;
//    NWDPMediumSize mediumSize;
// } NWDPMediumSourceSize, *pNWDPMediumSourceSize;

// typedef struct {
//    nuint32 inputTrayOptionPtr;
//    PackMediumSize mediumSize;
// } PackMediumSourceSize, *pPackMediumSourceSize;

typedef struct {
   NWDPNameOrOid inputTray;
   NWDPNameOrOid medium;
} NWDPInputTrayMedium, *pNWDPInputTrayMedium;

typedef enum {
   NWDP_PAGE_FACE_UNKNOWN = 0,
   NWDP_PAGE_FACE_UP = 1,
   NWDP_PAGE_FACE_DOWN = 2,
} NWDPPageOrientationEnum, *pNWDPPageOrientationEnum;

typedef struct {
   NWDPPageOrderTypeEnum stackingOrder;
   NWDPPageOrientationEnum orientation;
} NWDPOutputBinChar, *pNWDPOutputBinChar;

// typedef struct {
//    uint                 itemCount;
//    pNWDPOutputBinChar   itemPtr;
// } NWDPOutBinsCharacteristics, *pNWDPOutBinsCharacteristics;

// typedef struct {
//    uint     itemCount;
//    nuint32  itemOffset;
// } PackOutBinsCharacteristics, *pPackOutBinsCharacteristics;

// typedef struct {
//    NWDPObjectIdentifier organizationId;
//    int                  minimum;
//    int                  maximum;
// } NWDPLevelRange, *pNWDPLevelRange;

// typedef struct {
//    NWDPObjectIdentifier organizationId;
//    NWDPCardinalSeq categoryMinimum;
//    NWDPCardinalSeq categoryMaximum;
// } NWDPCategorySet, *pNWDPCategorySet;

// typedef struct {
//    PackObjectIdentifier organizationId;
//    PackCardinalSeq categoryMinimum;
//    PackCardinalSeq categoryMaximum;
// } PackCategorySet, *pPackCategorySet;

typedef enum {
   NWDP_NUMBERS_UP_CARDINAL = 0,
   NWDP_NUMBERS_UP_NAME_OR_OID = 1,
   NWDP_NUMBERS_UP_CARDINAL_RANGE = 2,
} NWDPNumbersUpEnum, *pNWDPNumbersUpEnum;

typedef struct {
   NWDPNumbersUpEnum designator;
   union {
      uint              cardinal;
      NWDPNameOrOid     nameOrOid;
      NWDPCardinalRange cardinalRange;
   } u;
} NWDPNumbersUpSupported, *pNWDPNumbersUpSupported;

typedef enum {
   NWDP_IMP_ATTR_PLEX = 0,
   NWDP_IMP_ATTR_NUMBER_UP = 1,
   NWDP_IMP_ATTR_X_IMAGE_SHIFT = 2,
   NWDP_IMP_ATTR_Y_IMAGE_SHIFT = 3,
   NWDP_IMP_ATTR_LOG_PAGE_ORIGIN = 4,
   NWDP_IMP_ATTR_LOG_PAGE_X_OFFSET = 5,
   NWDP_IMP_ATTR_LOG_PAGE_Y_OFFSET = 6,
   NWDP_IMP_ATTR_LOG_PAGE_SCALING = 7,
} NWDPImpositionAttrEnum, *pNWDPImpositionAttrEnum;

typedef struct {
   NWDPImpositionAttrEnum designator;
   union {
      struct {
         uint     itemCount;
         pnint8   itemPtr;
      } plex;
      int      numberUp;
      nreal64  xImageShift;
      nreal64  yImageShift;
      struct {
         uint     itemCount;
         pnint8   itemPtr;
      } logPageOrigin;
      nreal64 logPageXOffset;
      nreal64 logPageYOffset;
      nreal64 logPageScaling;
   } u;
} NWDPImpositionAttr, *pNWDPImpositionAttr;

typedef enum {
   NWDP_IMPOSITION_OBJECT = 0,
   NWDP_IMPOSITION_ATTR = 1,
} NWDPImpositionEnum, *pNWDPImpositionEnum;

typedef struct {
   NWDPImpositionEnum designator;
   union {
      NWDPNameOrOid impositionObject;
      NWDPImpositionAttr impositionAttr;
   } u;
} NWDPImposition, *pNWDPImposition;

// typedef struct {
//    NWDPObjectIdentifier colorantSetClass;
//    NWDPNameOrOidSet colorantSpecSeq;
// } NWDPColorantSetDescr, *pNWDPColorantSetDescr;

// typedef struct {
//    PackObjectIdentifier colorantSetClass;
//    PackNameOrOidSet colorantSpecSeq;
// } PackColorantSetDescr, *pPackColorantSetDescr;

// typedef enum {
//    NWDP_COLORANT_SET_NAME = 0,
//    NWDP_COLORANT_SET_DESCR = 1,
// } NWDPColorantEnum, *pNWDPColorantEnum;

// typedef struct {
//    NWDPColorantEnum designator;
//    union {
//       NWDPNameOrOid colorantSetName;
//       NWDPColorantSetDescr colorantSetDescr;
//    } u;
// } NWDPColorantSet, *pNWDPColorantSet;

// typedef struct {
//    NWDPColorantEnum designator;
//    union {
//       PackNameOrOid colorantSetName;
//       PackColorantSetDescr colorantSetDescr;
//    } u;
// } PackColorantSet, *pPackColorantSet;

typedef struct {
   NWDPText keyName;
   NWDPText mfrName;
   NWDPText infFileName;
   int      osType;
} NWDPResourcePrinterId, *pNWDPResourcePrinterId;

typedef struct {
   NWDPText printerName;
   NWDPText url;
   uint     timeDeleted;
   uint     timeAccessed;
} NWDPPrinterRedirect, *pNWDPPrinterRedirect;

typedef struct {
   NWDPAVTEnum designator;
   union {
      NWDPText text;
      NWDPText descriptiveName;
      NWDPText descriptor;
      NWDPNameOrOid message;
      NWDPNameOrOid errorMessage;
      NWDPText simpleName;
      // NWDPDistinguishedNameString distinguishedNameString;
      // NWDPDistinguishedNameStrSeq distinguishedNameStringSeq;
      int   deltaTime;
      uint  time;
      int   integer;
      NWDPIntegerSeq integerSeq;
      uint  cardinal;
      NWDPCardinalSeq cardinalSeq;
      int   positiveInteger;
      NWDPIntegerRange integerRange;
      NWDPCardinalRange cardinalRange;
      int   maximumInteger;
      int   minimumInteger;
      nreal64 real;
      NWDPRealSet realSeq;
      nreal64 nonNegativeReal;
      NWDPRealRange realRange;
      NWDPRealRange nonNegativeRealRange;
      nbool boolean;
      int percent;
      NWDPObjectIdentifier identifier;
      NWDPObjectIdentifierSet objectIdentifierSeq;
      NWDPNameOrOid nameOrOid;
      NWDPNameOrOidSet nameOrOidSeq;
      NWDPText distinguishedName;
      // NWDPRDNSequence rdnSequence;
      NWDPRealizationEnum realization;
      NWDPXYRealDimensions mediumDimensions;
      pNWDPDimension dimensionPtr;
      pNWDPXYDimensions xyDimensionsPtr;
      pNWDPLocations locationsPtr;
      pNWDPArea areaPtr;
      NWDPAreaSeq areaSeq;
      NWDPEdge edge;
      NWDPText fontReference;
      NWDPCardinalOrOid cardinalOrOid;
      NWDPOidCardinalMap oidCardinalMap;
      NWDPCardinalOrNameOrOid cardinalOrNameOrOid;
      NWDPPositiveIntegerOrOid positiveIntegerOrOid;
      // pNWDPEventHandlingProfile eventHandlingProfilePtr;
      NWDPOctetString octetString;
      int jobPriority;
      NWDPText locale;
      // pNWDPDeliveryAddrForMethod deliveryMethodAddressPtr;
      pNWDPObjectIdentification objectIdentificationPtr;
      pNWDPResultsProfile resultsProfilePtr;
      // NWDPCriteria criteria;
      NWDPOctetString jobPassword;
      // NWDPJobLevel jobLevel;
      // NWDPJobCategories jobCategories;
      NWDPOctetString printCheckpoint;
      NWDPIgnoredAttribute ignoredAttribute;
      // NWDPResource resource;
      // pNWDPMediumSubstitution mediumSubstitutionPtr;
      // NWDPFontSubstitution fontSubstitution;
      // NWDPResourceContextSeq resourceContextSeq;
      int sides;
      // NWDPPageSelectSequence pageSelectSeq;
      NWDPPageMediaSelect pageMediaSelect;
      NWDPDocumentContent documentContent;
      NWDPPageSize pageSize;
      NWDPPresentatnDirectionEnum presentationDirection;
      NWDPPageOrderTypeEnum pageOrderType;
      // NWDPDistinguishedNameString fileReference;
      // pNWDPMediumSourceSize mediumSourceSizePtr;
      pNWDPInputTrayMedium inputTrayMediumPtr;
      // NWDPOutBinsCharacteristics outBinsCharacteristics;
      NWDPPageIdTypeEnum pageIdType;
      // NWDPLevelRange levelRange;
      // pNWDPCategorySet categorySetPtr;
      NWDPNumbersUpSupported numbersUpSupported;
      NWDPPrtContainedObjectId prtContainedObjectId;
      pNWDPPrtConfigObjectId prtConfigObjectIdPtr;
      NWDPTypedName typedName;
      NWDPNetAddress netAddress;
      NWDPXYDimensionsValue xyDimensionsValue;
      NWDPNameOrOidDimensionMap nameOrOidDimensionMap;
      pNWDPPrinterStateReason printerStateReasonPtr;
      int enumeration;
      NWDPQualifiedName qualifiedName;
      NWDPQualifiedNameSet qualifiedNameSet;
      // NWDPColorantSet colorantSet;
      pNWDPResourcePrinterId resourcePrinterIdPtr;
      // NWDPEventObjectId eventObjectId;
      pNWDPQualifiedNameMap qualifiedNameMapPtr;
      NWDPText filePath;
      NWDPText uniformResourceIdentifier;
      NWDPCardinalOrEnumOrTime cardinalOrEnumOrTime;
      NWDPPrtContainedObjectIdSet prtContainedObjectIdSet;
      NWDPOctetStringPair octetStringPair;
      NWDPOctetStringIntegerPair octetStringIntegerPair;
      // NWDPText extendedResourceIdentifier;
      // pNWDPEventHandlingProfile2 eventHandlingProfile2Ptr;
      pNWDPDriverProfileId driverProfileIdPtr;
      pNWDPPrinterRedirect printerRedirectPtr;
   } u;
} NWDPAttributeValue, *pNWDPAttributeValue;

typedef struct {
   uint                 itemCount;
   pNWDPAttributeValue  itemPtr;
} NWDPAttributeValueSet, *pNWDPAttributeValueSet;

#include <npackon.h>

typedef struct {
   uint        itemCount;
   nuint32     itemOffset;
} PackText, *pPackText;

typedef struct {
   uint        itemCount;
   nuint32     itemOffset;
} PackOctetString, *pPackOctetString;

typedef struct {
   nint32   flag;
   nint32   value;
} PackIntegerOption, *pPackIntegerOption;

typedef struct {
   uint     oidStructSize;
   uint     oidStructOffset;
} PackObjectIdentifier, *pPackObjectIdentifier;

typedef struct {
   NWDPNameOrOidEnum designator;
   union {
      PackObjectIdentifier globalForm;
      PackText localForm;
   } u;
} PackNameOrOid, *pPackNameOrOid;

typedef struct {
   PackText object;
   PackText treeOption;
} PackNdsName, *pPackNdsName;

typedef struct {
   NWDPQualifiedNameEnum designator;
   union {
      PackText simpleName;
      PackNdsName ndsName;
   } u;
} PackQualifiedName, *pPackQualifiedName;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackQualifiedNameSet, *pPackQualifiedNameSet;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackIntegerSeq, *pPackIntegerSeq;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackCardinalSeq, *pPackCardinalSeq;

typedef struct {
   nint32 lowerBound;
   nint32 upperBound;
} PackIntegerRange, *pPackIntegerRange;

typedef struct {
   nuint32 lowerBound;
   nuint32 upperBound;
} PackCardinalRange, *pPackCardinalRange;

typedef struct {
   nint32 flag;
   nreal64 value;
} PackRealOption, *pPackRealOption;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackRealSet, *pPackRealSet;

typedef struct {
   nreal64 lowerBound;
   nreal64 upperBound;
} PackRealRange, *pPackRealRange;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackObjectIdentifierSet, *pPackObjectIdentifierSet;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackNameOrOidSet, *pPackNameOrOidSet;

typedef struct {
   nreal64 xDimension;
   nreal64 yDimension;
} PackXYRealDimensions, *pPackXYRealDimensions;

typedef struct {
   NWDPDimValueEnum designator;
   union {
      nreal64 numericValue;
      PackNameOrOid namedValue;
   } u;
} PackDimValue, *pPackDimValue;

typedef struct {
   PackDimValue value;
   NWDPRealOption toleranceOption;
} PackDimension, *pPackDimension;

typedef struct {
   nuint32 xDimension;
   nuint32 yDimension;
} PackXYCardinalDimensions, *pPackXYCardinalDimensions;

typedef struct {
   NWDPXYDimensionsValueEnum designator;
   union {
      PackXYRealDimensions realValue;
      PackNameOrOid namedValue;
      PackXYCardinalDimensions cardinalValue;
   } u;
} PackXYDimensionsValue, *pPackXYDimensionsValue;

typedef struct {
   PackXYDimensionsValue value;
   PackRealOption toleranceOption;
} PackXYDimensions, *pPackXYDimensions;

typedef struct {
   NWDPLocationValueEnum designator;
   union {
      PackRealSet numericValueSeq;
      PackNameOrOid namedValue;
   } u;
} PackLocationValue, *pPackLocationValue;

typedef struct {
   PackLocationValue value;
   NWDPRealOption toleranceOption;
} PackLocations, *pPackLocations;

typedef struct {
   nreal64 minimumX;
   nreal64 maximumX;
   nreal64 minimumY;
   nreal64 maximumY;
} PackArea, *pPackArea;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackAreaSeq, *pPackAreaSeq;

typedef struct {
   nint32 flag;
   NWDPEdge value;
} PackEdgeOption, *pPackEdgeOption;

typedef struct {
   NWDPCardinalOrOidEnum designator;
   union {
      nint32 cardinal;
      PackObjectIdentifier oid;
   } u;
} PackCardinalOrOid, *pPackCardinalOrOid;

typedef struct {
   PackObjectIdentifier oidOption;
   nuint32 cardinal;
} PackOidCardinalMap, *pPackOidCardinalMap;

typedef struct {
   NWDPCardinalOrNameOrOidEnum designator;
   union {
      nint32 cardinal;
      PackNameOrOid nameOrOid;
   } u;
} PackCardinalOrNameOrOid, *pPackCardinalOrNameOrOid;

typedef struct {
   NWDPPositivIntegerOrOidEnum designator;
   union {
      PackObjectIdentifier oid;
      nint32 integer;
   } u;
} PackPositiveIntegerOrOid, *pPackPositiveIntegerOrOid;

typedef struct {
   PackText printerName;
   nuint32 localIdentifier;
} PackPrtContainedObjectId, *pPackPrtContainedObjectId;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackPrtContainedObjectIdSet, *pPackPrtContainedObjectIdSet;

typedef struct {
   PackPrtContainedObjectId jobIdentifier;
   nuint32 documentNumber;
} PackDocumentIdentifier, *pPackDocumentIdentifier;

typedef struct {
   PackText printerName;
   PackQualifiedName qualifiedName;
} PackPrtConfigObjectId, *pPackPrtConfigObjectId;

typedef struct {
   nuint32 osType;
   PackText driverName;
   PackText profileName;
} PackDriverProfileId, *pPackDriverProfileId;

typedef struct {
   PackQualifiedName primary;
   PackQualifiedName secondary;
} PackQualifiedNameMap, *pPackQualifiedNameMap;

typedef struct {
   NWDPCardinalOrEnumOrTimeEnum designator;
   union {
      nuint32 cardinal;
      nint32 enumeration;
      nuint32 time;
   } u;
} PackCardinalOrEnumOrTime, *pPackCardinalOrEnumOrTime;

typedef struct {
   PackOctetString octetString1;
   PackOctetString octetString2;
} PackOctetStringPair, *pPackOctetStringPair;

typedef struct {
   PackOctetString octetString;
   nint32 integer1;
   nint32 integer2;
} PackOctetStringIntegerPair, *pPackOctetStringIntegerPair;

// typedef struct {
//    uint     itemCount;
//    nuint32  itemOffset;
// } PackPrivAttrCertificate, *pPackPrivAttrCertificate;

// typedef struct {
//    PackPrivAttrCertificate operationPacOption;
//    PackPrivAttrCertificate proxyPacOption;
// } PackPrivileges, *pPackPrivileges;

typedef struct {
   NWDPObjIdentificationEnum designator;
   union {
      PackPrtContainedObjectId prtContainedObjectId;
      PackDocumentIdentifier documentIdentifier;
      PackObjectIdentifier objectIdentifier;
      // PackDistinguishedNameString objectName;
      PackNameOrOid nameOrOid;
      PackText simpleName;
      PackPrtConfigObjectId prtConfigObjectId;
      PackQualifiedName qualifiedName;
      // PackEventObjectId eventObjectId;
      PackDriverProfileId driverProfileId;
   } u;
} PackObjectIdentification, *pPackObjectIdentification;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackObjectIdentificationSeq, *pPackObjectIdentificationSeq;

typedef struct {
   PackText name;
   nint32 level;
   nint32 interval;
} PackTypedName, *pPackTypedName;

typedef struct {
   NWDPNetAddressTypeEnum type;
   PackOctetString address;
} PackNetAddress, *pPackNetAddress;

typedef struct {
   PackNameOrOid nameOrOid;
   PackXYCardinalDimensions value;
} PackNameOrOidDimensionMap, *pPackNameOrOidDimensionMap;

typedef struct {
   PackNameOrOid identifier;
   NWDPStateSeverityEnum severity;
   NWDPTrainingEnum trainingLevel;
   PackObjectIdentifier objectClassOid;
   PackObjectIdentification objectIdentification;
   nuint32 time;
   nuint32 messageOptionOffset;
} PackPrinterStateReason, *pPackPrinterStateReason;

// typedef struct {
//    NWDPAddressItemTypeEnum designator;
//    union {
//       PackQualifiedName userName;
//       PackQualifiedName serverName;
//       PackQualifiedName volumeName;
//       PackQualifiedName orgUnitName;
//       PackQualifiedName orgName;
//       PackQualifiedName groupName;
//       PackQualifiedName dN;
//       PackQualifiedName userOrContainerName;
//       PackText ceStr;
//       PackText ciStr;
//       PackText numStr;
//       PackText filename;
//       PackText phoneNumber;
//       nbool bFlag;
//       nint32 integer;
//       PackNetAddress netAddress;
//       PackText choice;
//       PackText gwUser;
//    } u;
// } PackAddressItem, *pPackAddressItem;

typedef struct {
   PackObjectIdentifier       deliveryMethodOption;
   PackNameOrOid              resultsSetCommentOption;
   nuint32                    deliveryAddressOptionPtr;
   nint32                     jobCopies;
   PackPrtContainedObjectId   outputBinOption;
} PackResultsProfile, *pPackResultsProfile;

// typedef struct {
//    NWDPAVTEnum designator;
//    union {
//       nint32 deltaTime;
//       nuint32 time;
//       nint32 integer;
//       nuint32 cardinal;
//       nint32 positiveInteger;
//       nint32 percent;
//    } u;
// } PackCriterionThreshold, *pPackCriterionThreshold;

// typedef struct {
//    PackObjectIdentifier organizationId;
//    nuint32 level;
// } PackJobLevel, *pPackJobLevel;

// typedef struct {
//    PackObjectIdentifier organizationId;
//    PackCardinalSeq categories;
// } PackJobCategories, *pPackJobCategories;

typedef struct {
   NWDPAVTEnum designator;
   union {
      PackObjectIdentifier identifier;
      PackNameOrOid nameOrOid;
   } u;
} PackIgnoredAttributeValue, *pPackIgnoredAttributeValue;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackIgnoredAttrValueSet, *pPackIgnoredAttrValueSet;

typedef struct {
   nuint32 documentNumberOption;
   PackObjectIdentifier attributeId;
   PackIgnoredAttrValueSet values;
} PackIgnoredAttribute, *pPackIgnoredAttribute;

typedef struct {
   NWDPPageIdentifierEnum designator;
   union {
      nint32 nominalPageNumber;
      PackText alphanumericPageNumber;
      PackNameOrOid pageTag;
   } u;
} PackPageIdentifier, *pPackPageIdentifier;

typedef struct {
   nint32 flag;
   PackPageIdentifier value;
} PackPageIdentifierOption, *pPackPageIdentifierOption;

typedef struct {
   PackPageIdentifierOption beginningPage;
   PackPageIdentifierOption endingPage;
} PackPageSelect, *pPackPageSelect;

typedef struct {
   NWDPDocumentContentEnum designator;
   union {
      PackOctetString includedDocument;
      // PackDistinguishedNameString referencedDocument;
   } u;
} PackDocumentContent, *pPackDocumentContent;

typedef struct {
   NWDPPageSizeEnum designator;
   union {
      PackObjectIdentifier pageSizeId;
      NWDPXYRealDimensions pageDimensions;
   } u;
} PackPageSize, *pPackPageSize;

typedef struct {
   PackPageSelect pageRange;
   PackNameOrOid  mediumId;
} PackMediaSelect, *pPackMediaSelect;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackMediaSelectSeq, *pPackMediaSelectSeq;

typedef struct {
   NWDPMediaSelectEnum designator;
   union {
      PackNameOrOid mediumForAllPages;
      PackMediaSelectSeq mediumForSelectedPagesSeq;
   } u;
} PackPageMediaSelect, *pPackPageMediaSelect;

typedef struct {
   PackPageSize pageSize;
   nbool longEdgeFeeds;
   PackArea assuredReproductionArea;
} PackMediumDiscreteSizes, *pPackMediumDiscreteSizes;

typedef struct {
   PackRealRange sizeRangeAcrossFeedDirection;
   nreal64 sizeIncrementAcrossFeedDir;
   PackRealRange sizeRangeInFeedDirection;
   nreal64 sizeIncrementInFeedDir;
   nbool longEdgeFeeds;
   PackArea GenericAssuredReproductionArea;
} PackMediumContinuousSizes, *pPackMediumContinuousSizes;

typedef struct {
   NWDPMediumSizeEnum designator;
   union {
      PackMediumDiscreteSizes discreteSizes;
      PackMediumContinuousSizes continuousSizes;
   } u;
} PackMediumSize, *pPackMediumSize;

typedef struct {
   PackNameOrOid inputTray;
   PackNameOrOid medium;
} PackInputTrayMedium, *pPackInputTrayMedium;

typedef struct {
   NWDPPageOrderTypeEnum stackingOrder;
   NWDPPageOrientationEnum orientation;
} PackOutputBinChar, *pPackOutputBinChar;

typedef struct {
   PackObjectIdentifier organizationId;
   nint32 minimum;
   nint32 maximum;
} PackLevelRange, *pPackLevelRange;

typedef struct {
   NWDPNumbersUpEnum designator;
   union {
      nuint32 cardinal;
      PackNameOrOid nameOrOid;
      NWDPCardinalRange cardinalRange;
   } u;
} PackNumbersUpSupported, *pPackNumbersUpSupported;

typedef struct {
   NWDPImpositionAttrEnum designator;
   union {
      struct {
         uint     itemCount;
         nuint32  itemOffset;
      } plex;
      nint32 numberUp;
      nreal64 xImageShift;
      nreal64 yImageShift;
      struct {
         uint     itemCount;
         nuint32  itemOffset;
      } logPageOrigin;
      nreal64 logPageXOffset;
      nreal64 logPageYOffset;
      nreal64 logPageScaling;
   } u;
} PackImpositionAttr, *pPackImpositionAttr;

typedef struct {
   NWDPImpositionEnum designator;
   union {
      PackNameOrOid impositionObject;
      PackImpositionAttr impositionAttr;
   } u;
} PackImposition, *pPackImposition;

typedef struct {
   PackText keyName;
   PackText mfrName;
   PackText infFileName;
   nint32 osType;
} PackResourcePrinterId, *pPackResourcePrinterId;

typedef struct {
   PackText printerName;
   PackText url;
   nuint32  timeDeleted;
   nuint32  timeAccessed;
} PackPrinterRedirect, *pPackPrinterRedirect;


typedef struct {
   NWDPAVTEnum designator;
   union {
      PackText text;
      PackText descriptiveName;
      PackText descriptor;
      PackNameOrOid message;
      PackNameOrOid errorMessage;
      PackText simpleName;
      // PackDistinguishedNameString distinguishedNameString;
      // PackDistinguishedNameStrSeq distinguishedNameStringSeq;
      nint32 deltaTime;
      nuint32 time;
      nint32 integer;
      PackIntegerSeq integerSeq;
      nuint32 cardinal;
      PackCardinalSeq cardinalSeq;
      nint32 positiveInteger;
      PackIntegerRange integerRange;
      PackCardinalRange cardinalRange;
      nint32 maximumInteger;
      nint32 minimumInteger;
      nreal64 real;
      PackRealSet realSeq;
      nreal64 nonNegativeReal;
      PackRealRange realRange;
      PackRealRange nonNegativeRealRange;
      nbool boolean;
      nint32 percent;
      PackObjectIdentifier identifier;
      PackObjectIdentifierSet objectIdentifierSeq;
      PackNameOrOid nameOrOid;
      PackNameOrOidSet nameOrOidSeq;
      PackText distinguishedName;
      // PackRDNSequence rdnSequence;
      NWDPRealizationEnum realization;
      PackXYRealDimensions mediumDimensions;
      nuint32 dimensionOffset;
      nuint32 xyDimensionsOffset;
      nuint32 locationsOffset;
      nuint32 areaOffset;
      PackAreaSeq areaSeq;
      NWDPEdge edge;
      PackText fontReference;
      PackCardinalOrOid cardinalOrOid;
      PackOidCardinalMap oidCardinalMap;
      PackCardinalOrNameOrOid cardinalOrNameOrOid;
      PackPositiveIntegerOrOid positiveIntegerOrOid;
      // nuint32 eventHandlingProfileOffset;
      PackOctetString octetString;
      nint32 jobPriority;
      PackText locale;
      // nuint32 deliveryMethodAddressPtr;
      nuint32 objectIdentificationOffset;
      nuint32 resultsProfileOffset;
      // PackCriteria criteria;
      PackOctetString jobPassword;
      // PackJobLevel jobLevel;
      // PackJobCategories jobCategories;
      PackOctetString printCheckpoint;
      PackIgnoredAttribute ignoredAttribute;
      // PackResource resource;
      // nuint32 mediumSubstitutionOffset;
      // PackFontSubstitution fontSubstitution;
      // PackResourceContextSeq resourceContextSeq;
      nint32 sides;
      // PackPageSelectSequence pageSelectSeq;
      PackPageMediaSelect pageMediaSelect;
      PackDocumentContent documentContent;
      PackPageSize pageSize;
      NWDPPresentatnDirectionEnum presentationDirection;
      NWDPPageOrderTypeEnum pageOrderType;
      // PackDistinguishedNameString fileReference;
      // nuint32 mediumSourceSizeOffset;
      nuint32 inputTrayMediumOffset;
      // PackOutBinsCharacteristics outBinsCharacteristics;
      NWDPPageIdTypeEnum pageIdType;
      PackLevelRange levelRange;
      // nuint32 categorySetOffset;
      PackNumbersUpSupported numbersUpSupported;
      PackPrtContainedObjectId prtContainedObjectId;
      nuint32 prtConfigObjectIdOffset;
      PackTypedName typedName;
      PackNetAddress netAddress;
      PackXYDimensionsValue xyDimensionsValue;
      PackNameOrOidDimensionMap nameOrOidDimensionMap;
      nuint32 printerStateReasonOffset;
      nint32 enumeration;
      PackQualifiedName qualifiedName;
      PackQualifiedNameSet qualifiedNameSet;
      // PackColorantSet colorantSet;
      nuint32 resourcePrinterIdOffset;
      // PackEventObjectId eventObjectId;
      nuint32 qualifiedNameMapOffset;
      PackText filePath;
      PackText uniformResourceIdentifier;
      PackCardinalOrEnumOrTime cardinalOrEnumOrTime;
      PackPrtContainedObjectIdSet prtContainedObjectIdSet;
      PackOctetStringPair octetStringPair;
      PackOctetStringIntegerPair octetStringIntegerPair;
      // PackText extendedResourceIdentifier;
      // nuint32 eventHandlingProfile2Ptr;
      nuint32 driverProfileIdOffset;
      nuint32 printerRedirectOffset;
   } u;
} PackAttributeValue, *pPackAttributeValue;

#include <npackoff.h>

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackAttributeValueSet, *pPackAttributeValueSet;

typedef enum {
   NWDP_MODIFY_OP_NULL = 0,
   NWDP_MODIFY_OP_REPLACE = 1,
   NWDP_MODIFY_OP_ADD_VALUES = 2,
   NWDP_MODIFY_OP_REMOVE_VALUES = 3,
   NWDP_MODIFY_OP_SET_TO_DEFAULT = 4,
   NWDP_MODIFY_OP_REMOVE_ATTRIBUTE = 5,
} NWDPModifyOperatorEnum, *pNWDPModifyOperatorEnum;
/* Note: For NDPS, all attribute sets are qualified */


typedef struct {
   NWDPObjectIdentifier    attributeId;
   NWDPAttributeValueSet   valueSet;
   uint                    qualifier;
} NWDPAttribute, *pNWDPAttribute;

typedef struct {
   PackObjectIdentifier attributeId;
   PackAttributeValueSet valueSet;
   nuint32 qualifier;
} PackAttribute, *pPackAttribute;

typedef struct {
   uint           itemCount;
   pNWDPAttribute itemPtr;
} NWDPAttributeSet, *pNWDPAttributeSet;

typedef struct {
   uint     itemCount;
   nuint32  itemOffset;
} PackAttributeSet, *pPackAttributeSet;

typedef enum {
   NWDP_MATCH_EXACT = 0,
   NWDP_MATCH_CASE_INSENSITIVE = 1,
   NWDP_MATCH_SAME_LETTER = 2,
   NWDP_MATCH_APPROXIMATE = 3,
} NWDPSubstrMatchCriteriaEnum, *pNWDPSubstrMatchCriteriaEnum;

typedef struct {
   NWDPObjectIdentifier          attributeId;
   NWDPSubstrMatchCriteriaEnum   matchCriteria;
   NWDPAttributeValue            initialValueOption;
   NWDPAttributeValueSet         anyValueSetOption;
   NWDPAttributeValue            finalValueOption;
} NWDPSubStrings, *pNWDPSubStrings;

typedef struct {
   PackObjectIdentifier          attributeId;
   NWDPSubstrMatchCriteriaEnum   matchCriteria;
   PackAttributeValue            initialValueOption;
   PackAttributeValueSet         anyValueSetOption;
   PackAttributeValue            finalValueOption;
} PackSubStrings, *pPackSubStrings;

// typedef enum {
//    NWDP_DP_ACCESS_RIGHTS_USER = 0,
//    NWDP_DP_ACCESS_RIGHTS_ADMIN = 1,
// } NWDPDpAccessRightsEnum, *pNWDPDpAccessRightsEnum;

// typedef struct {
//    NWDPText                accessId;
//    NWDPDpAccessRightsEnum  accessRights;
// } NWDPDpAccessListElement, *pNWDPDpAccessListElement;

// typedef struct {
//    PackText                accessId;
//    NWDPDpAccessRightsEnum  accessRights;
// } PackDpAccessListElement, *pPackDpAccessListElement;

// typedef struct {
//    NWDPText          userName;
//    NWDPOctetString   accountingInformation;
// } NWDPAccessAndAccounting, *pNWDPAccessAndAccounting;

// typedef enum {
//    NWDP_PROBLEM_TYPE_STANDARD = 0,
//    NWDP_PROBLEM_TYPE_EXTENDED = 1,
// } NWDPProblemTypeEnum, *pNWDPProblemTypeEnum;

// typedef enum {
//    NWDP_ACCESS_WRONG_OBJECT_CLASS = 0,
//    NWDP_ACCESS_LACK_ACCESS_RIGHTS = 1,
//    NWDP_ACCESS_CANT_INTERRUPT_JOB = 2,
//    NWDP_ACCESS_WRONG_OBJECT_STATE = 3,
//    NWDP_ACCESS_CLIENT_NOT_BOUND = 4,
//    NWDP_ACCESS_NOT_AVAILABLE = 5,
//    NWDP_ACCESS_NOTIF_SVC_NOT_CONN = 6,
//    NWDP_ACCESS_PDS_NOT_CONNECTED = 7,
// } NWDPAccessProblemEnum, *pNWDPAccessProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPAccessProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPAccessProblem, *pNWDPAccessProblem;

// typedef struct {
//    NWDPAccessProblem problem;
//    NWDPObjectIdentification objectIdentification;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPAccessError, *pNWDPAccessError;

// typedef enum {
//    NWDP_ATTR_INVALID_SYNTAX = 0,
//    NWDP_ATTR_UNDEFINED_TYPE = 1,
//    NWDP_ATTR_WRONG_MATCHING = 2,
//    NWDP_ATTR_CONSTRAINT_VIOLATED = 3,
//    NWDP_ATTR_UNSUPPORTED_TYPE = 4,
//    NWDP_ATTR_ILLEGAL_MODIFICATION = 5,
//    NWDP_ATTR_CONSIST_W_OTHER_ATTR = 6,
//    NWDP_ATTR_UNDEFINED_ATTR_VALUE = 7,
//    NWDP_ATTR_UNSUPPORTED_VALUE = 8,
//    NWDP_ATTR_INVALID_NONCOMPUL_MOD = 9,
//    NWDP_ATTR_PER_JOB_INADMISSIBLE = 10,
//    NWDP_ATTR_NOT_MULTI_VALUED = 11,
//    NWDP_ATTR_MANDATORY_OMITTED = 12,
//    NWDP_ATTR_ILLEGAL_FOR_CLASS = 13,
// } NWDPAttributeProblemEnum, *pNWDPAttributeProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPAttributeProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPAttributeProblem, *pNWDPAttributeProblem;

// typedef struct {
//    NWDPAttributeProblem problem;
//    NWDPAttribute attribute;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPAttributeProblemItem, *pNWDPAttributeProblemItem;

// typedef struct {
//    struct {
//       uint                       itemCount;
//       pNWDPAttributeProblemItem  itemPtr;
//    } problems;
//    NWDPObjectIdentification objectIdentification;
// } NWDPAttributeError, *pNWDPAttributeError;

// typedef enum {
//    NWDP_DOC_ACCESS_NOT_AVAILABLE = 0,
//    NWDP_DOC_ACCESS_FIDELI_TIME_EXP = 1,
//    NWDP_DOC_ACCESS_DENIED = 2,
//    NWDP_DOC_ACCESS_UNKNOWN_DOC = 3,
//    NWDP_DOC_ACCESS_NO_DOCS_IN_JOB = 4,
// } NWDPDocAccessProblemEnum, *pNWDPDocAccessProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPDocAccessProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPDocAccessProblem, *pNWDPDocAccessProblem;

// typedef struct {
//    NWDPDocAccessProblem problem;
//    NWDPObjectIdentification objectIdentification;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPDocAccessError, *pNWDPDocAccessError;

// typedef enum {
//    NWDP_PRINTER_ERROR = 0,
//    NWDP_PRINTER_NEEDS_ATTENTION = 1,
//    NWDP_PRINTER_NEEDS_KEY_OPERATOR = 2,
// } NWDPPrinterProblemEnum, *pNWDPPrinterProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPPrinterProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPPrinterProblem, *pNWDPPrinterProblem;

// typedef struct {
//    NWDPPrinterProblem problem;
//    NWDPObjectIdentification objectIdentification;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPPrinterError, *pNWDPPrinterError;

// typedef enum {
//    NWDP_SECURITY_AUTHENTICATION = 0,
//    NWDP_SECURITY_CREDENTIALS = 1,
//    NWDP_SECURITY_RIGHTS = 2,
//    NWDP_SECURITY_INVALID_PAC = 3,
// } NWDPSecurityProblemEnum, *pNWDPSecurityProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPSecurityProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPSecurityProblem, *pNWDPSecurityProblem;

// typedef struct {
//    NWDPSecurityProblem problem;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPSecurityError, *pNWDPSecurityError;

// typedef enum {
//    NWDP_SELECTION_INVALID_ID = 0,
//    NWDP_SELECTION_UNKNOWN_ID = 1,
//    NWDP_SELECTION_OBJECT_EXISTS = 2,
//    NWDP_SELECTION_ID_CHANGED = 3,
//    NWDP_SELECTION_OBJECT_DELETED = 4,
// } NWDPSelectionProblemEnum, *pNWDPSelectionProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPSelectionProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPSelectionProblem, *pNWDPSelectionProblem;

// typedef struct {
//    NWDPSelectionProblem problem;
//    NWDPObjectIdentification objectIdentification;
//    pNWDPAttribute attributeOptionPtr;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPSelectionError, *pNWDPSelectionError;

// typedef enum {
//    NWDP_SERVICE_SERVER_BUSY = 0,
//    NWDP_SERVICE_SERVER_UNAVAILABLE = 1,
//    NWDP_SERVICE_OPERATION_COMPLEX = 2,
//    NWDP_SERVICE_RESOURCE_LIMIT = 3,
//    NWDP_SERVICE_UNCLASS_SERVER_ERR = 4,
//    NWDP_SERVICE_TOO_MANY_ITEM_LIST = 5,
//    NWDP_SERVICE_RESOURCE_NOT_AVAIL = 6,
//    NWDP_SERVICE_CANCEL_DOC_SUPPORT = 7,
//    NWDP_SERVICE_MODIFY_DOC_SUPPORT = 8,
//    NWDP_SERVICE_MULTI_DOC_SUPPORT = 9,
//    NWDP_SERVICE_PARM_VAL_SUPPORT = 10,
//    NWDP_SERVICE_INVALID_CHECKPOINT = 11,
//    NWDP_SERVICE_CONTINUATN_CONTEXT = 12,
//    NWDP_SERVICE_PAUSE_LIMIT_EXCEED = 13,
//    NWDP_SERVICE_UNSUPPORTED_OP = 14,
//    NWDP_SERVICE_NOTIF_SERVICE_ERR = 15,
//    NWDP_SERVICE_ACCTG_SERVICE_ERR = 16,
// } NWDPServiceProblemEnum, *pNWDPServiceProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPServiceProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPServiceProblem, *pNWDPServiceProblem;

// typedef struct {
//    NWDPServiceProblem problem;
//    NWDPObjectIdentification objectIdentification;
//    pNWDPAttribute attributeOptionPtr;
//    nuint32 libError;
//    nuint32 otherError;
//    nuint32 otherError2;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPServiceError, *pNWDPServiceError;

// typedef enum {
//    NWDP_UPDATE_NO_MODS_ALLOWED = 0,
//    NWDP_UPDATE_INSUFFICIENT_RIGHTS = 1,
//    NWDP_UPDATE_PREV_OP_INCOMPLETE = 2,
//    NWDP_UPDATE_CANCEL_NOT_POSSIBLE = 3,
// } NWDPUpdateProblemEnum, *pNWDPUpdateProblemEnum;

// typedef struct {
//    NWDPProblemTypeEnum designator;
//    union {
//       NWDPUpdateProblemEnum standardProblem;
//       NWDPObjectIdentifier extendedProblem;
//    } u;
// } NWDPUpdateProblem, *pNWDPUpdateProblem;

// typedef struct {
//    NWDPUpdateProblem problem;
//    NWDPObjectIdentification objectIdentification;
//    pNWDPNameOrOid messageOptionPtr;
// } NWDPUpdateError, *pNWDPUpdateError;

// typedef enum {
//    NWDP_ERROR_TYPE_SECURITY = 0,
//    NWDP_ERROR_TYPE_SERVICE = 1,
//    NWDP_ERROR_TYPE_ACCESS = 2,
//    NWDP_ERROR_TYPE_PRINTER = 3,
//    NWDP_ERROR_TYPE_SELECTION = 4,
//    NWDP_ERROR_TYPE_DOCUMENT_ACCESS = 5,
//    NWDP_ERROR_TYPE_ATTRIBUTE = 6,
//    NWDP_ERROR_TYPE_UPDATE = 7,
// } NWDPErrorTypeEnum, *pNWDPErrorTypeEnum;

// typedef struct {
//    NWDPErrorTypeEnum designator;
//    union {
//       NWDPSecurityError securityError;
//       struct {
//          uint              itemCount;
//          pNWDPServiceError itemPtr;
//       } serviceErrorSeq;
//       struct {
//          uint              itemCount;
//          pNWDPAccessError  itemPtr;
//       } accessErrorSeq;
//       NWDPPrinterError printerError;
//       struct {
//          uint                 itemCount;
//          pNWDPSelectionError  itemPtr;
//       } selectionErrorSeq;
//       NWDPDocAccessError docAccessError;
//       NWDPAttributeError attributeError;
//       NWDPUpdateError updateError;
//    } u;
// } NWDPErrorReturn, *pNWDPErrorReturn;

typedef struct {
   NWDPText name;
   struct {
      uint     itemCount;
      pnint8   itemPtr;
   } password;
} NWDPCreds, *pNWDPCreds;

typedef struct {
   pnstr serverNamePtr;
   nuint16 connection;
} NWDPNdpsCred0, *pNWDPNdpsCred0;

typedef struct {
   pnstr serverNamePtr;
   nuint16 connection;
   NWDPText clientName;
} NWDPNdpsCred1, *pNWDPNdpsCred1;

typedef struct {
   pnstr serverNamePtr;
   nuint16 connection;
   NWDPText clientName;
   NWDPNetAddress clientAddress;
} NWDPNdpsCred2, *pNWDPNdpsCred2;

typedef enum {
   NWDP_CREDENTIALS_SIMPLE = 0,
   NWDP_CREDENTIALS_CERTIFIED = 1,
   NWDP_CREDENTIALS_NDPS_0 = 2,
   NWDP_CREDENTIALS_NDPS_1 = 3,
   NWDP_CREDENTIALS_NDPS_2 = 4,
} NWDPCredentialsEnum, *pNWDPCredentialsEnum;

typedef struct {
   NWDPCredentialsEnum designator;
   union {
      NWDPCreds simple;
      struct {
         uint     itemCount;
         pnint8   itemPtr;
      } certified;
      NWDPNdpsCred0 ndpsCred0;
      NWDPNdpsCred1 ndpsCred1;
      NWDPNdpsCred2 ndpsCred2;
   } u;
} NWDPCredentials, *pNWDPCredentials;


// #include <npackoff.h>


/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */



#endif /* NWDP_ATT_H */

