/*
##################################################################################################################
# (c) Copyright 2001-2020 Micro Focus or one of its affiliates.
#
# The only warranties for products and services of Micro Focus and its affiliates and licensors (“Micro Focus”)
# are as may be set forth in the express warranty statements accompanying such products and services. Nothing
# herein should be construed as constituting an additional warranty. Micro Focus shall not be liable for technical
# or editorial errors or omissions contained herein. The information contained herein is subject to change without
# notice.
##################################################################################################################
//+==========================================================================+
//| Source module name: nwdpndps.h                                           |
//+==========================================================================+
//|$Author: dtaylor $              $Locker:  $
//|$Revision: 1.25 $            $Name:  $ $State: Exp $
//|$Date: 2008/03/13 23:41:39 $
//+===========================================================================
*/
/* Inclusion Control */
#if !defined(NWDPNDPS_H)
   #define NWDPNDPS_H

/* Standard Library Header Includes */
//    #if !defined(NWDPFILT_H)
//       #include <nwdpfilt.h>
//    #endif /* NWDPFILT_H */

/* Header Includes */
   #if !defined ATTRSET_H
      #include <attrset.h>
   #endif /* ATTRSET_H */

/* Manifest Constant Definitions */

   #define  NWDP_OP_TIMEOUT            60
   #define  NWDP_OP_TIMEOUT_SLEEP_MS   50
   #define  NWDP_OP_TIMEOUT_MAX_COUNT  (((NWDP_OP_TIMEOUT * 1000) + 1) / NWDP_OP_TIMEOUT_SLEEP_MS)

   #define  NULLPROC (0)
   #define  NWDP_PRINTPROGRAM (395638L)
   #define  NWDP_PRINTVERS (1L)
   #define  NWDP_BindPSM (1L)
   #define  NWDP_BindPA (2L)
   #define  NWDP_Unbind (3L)
   #define  NWDP_Print (4L)
   #define  NWDP_ModifyJob (5L)
   #define  NWDP_CancelJob (6L)
   #define  NWDP_ListObjectAttributes (7L)
   #define  NWDP_PromoteJob (8L)
   #define  NWDP_Interrupt (9L)
   #define  NWDP_Pause (10L)
   #define  NWDP_Resume (11L)
   #define  NWDP_Clean (12L)
   #define  NWDP_Create (13L)
   #define  NWDP_Delete (14L)
   #define  NWDP_DisablePA (15L)
   #define  NWDP_EnablePA (16L)
   #define  NWDP_ResubmitJobs (17L)
   #define  NWDP_Set (18L)
   #define  NWDP_ShutdownPA (19L)
   #define  NWDP_StartupPA (20L)
   #define  NWDP_ReorderJob (21L)
   #define  NWDP_PausePA (22L)
   #define  NWDP_ResumePA (23L)
   #define  NWDP_TransferData (24L)
   #define  NWDP_DeviceControl (25L)
   #define  NWDP_AddEventProfile (26L)
   #define  NWDP_RemoveEventProfile (27L)
   #define  NWDP_ModifyEventProfile (28L)
   #define  NWDP_ListEventProfiles (29L)
   #define  NWDP_ShutdownPSM (30L)
   #define  NWDP_CancelPSMShutdown (31L)
   #define  NWDP_SetPrinterDSInfo (32L)
   #define  NWDP_CleanUserJobs (33L)
   #define  NWDP_MapGuidToNdsName (34L)
   #define  NWDP_AddEventProfile2 (35L)
   #define  NWDP_ListEventProfiles2 (36L)
   #define  NWDP_QueryHealthMon (101L)
   #define  NWDP_AccountingBindPsm (102L)
   #define  NWDP_AccountingUnbindPsm (103L)
   #define  NWDP_GetAuditLogInfo (104L)
   #define  NWDP_BackupManagerDatabase (105L)
   #define  NWDP_AccountingJobAction (106L)
   #define  NWDP_BindPSM_OAUTH (107L)
   #define  NWDP_BindPA_OAUTH (108L)

   #define  NWDP_PsmCallbackOp (201L)
   #define  NWDP_AccountingBindPa (202L)
   #define  NWDP_AccountingUnbindPa (203L)
   #define  NWDP_SubmitAccountingInfo (204L)
   #define  NWDP_RenamePA (205L) //juhi rename PA
   #define  NWDP_MoveJob (206L)
   #define  NWDP_GetWalkupExpiry (207L)


   #define  NWDPSessionHandle nptr

   typedef enum
   {
      NWDP_RES_OS_DOS = 0,
      NWDP_RES_OS_WIN_31 = 1,
      NWDP_RES_OS_WIN_95 = 2,
      NWDP_RES_OS_LINUX_2_4 = 3,
      NWDP_RES_OS_OS_2 = 4,
      NWDP_RES_OS_MAC_OS_X = 5,
      NWDP_RES_OS_UNIX = 6,
      NWDP_RES_OS_WIN_NT4 = 7,
      NWDP_RES_OS_WIN_NT5 = 8,
      NWDP_RES_OS_WIN_98 = 9,
      NWDP_RES_OS_WIN_NT5_1 = 10,
      NWDP_RES_OS_WIN_NT6_X86_32 = 11,
      NWDP_RES_OS_WIN_NT6_X86_64 = 12,
      NWDP_RES_OS_WIN_NT6_1_X86_32 = 30, //20090322 Karna Natikar fate #305512
      NWDP_RES_OS_WIN_NT6_1_X86_64 = 31,  //20090522 Karna Natikar bugzilla #506264
                                                                           // 32 corresponds to win7 AMD 64 
      NWDP_RES_OS_WIN_NT6_2_X86_32 = 33,  //20120326 Juhi  fate #314575
      NWDP_RES_OS_WIN_NT6_2_X86_64 = 34   //20120326 Juhi  fate #314575
   } NWDPOSTypeEnum, *pNWDPOSTypeEnum;

/* Macro Definitions */

/* Type Definitions */

//    #define N_PACK_1
//    #include <npackon.h>

typedef struct {
   NWDPText       accountId;
   NWDPText       tenentId;
   NWDPText       userName; 
   NWDPText       token;
} AuthAttr, *pAuthAttr;

typedef struct {
   NWDPText       printerName;
   NWDPText       loginName;
   NWDPText       userName;
   uint           clientAddress;
   int            localBindFlag;
   uint           isOAuthAuthentication;
   AuthAttr       authAttr;
} NWDPBindPAArgument, *pNWDPBindPAArgument;

typedef struct {
   PackText       printerName;
   PackText       loginName;
   PackText       userName;
   uint           clientAddress;
   int            localBindFlag;
   uint           isOAuthAuthentication;
   AuthAttr       authAttr;
} PackBindPAArgument, *pPackBindPAArgument;

typedef struct {
   nuint             errorCode;
   NWDPSessionHandle sessionHandle;
   nuint             security;
   NWDPText          paName;
} NWDPBindPAResult, *pNWDPBindPAResult;

typedef struct {
   uint              errorCode;
   NWDPSessionHandle sessionHandle;
   uint              security;
   PackText          paName;
} PackBindPAResult, *pPackBindPAResult;

typedef struct {
   uint                 errorCode;
   NWDPSessionHandle    sessionHandle;
   nuint                security;
   NWDPQualifiedName    psmName;
} NWDPBindPSMResult, *pNWDPBindPSMResult;

typedef struct {
   uint                 errorCode;
   NWDPSessionHandle    sessionHandle;
   nuint                security;
   PackQualifiedName    psmName;
} PackBindPSMResult, *pPackBindPSMResult;

typedef struct {
   NWDPSessionHandle    sessionHandle;
} NWDPSimpleArgument, *pNWDPSimpleArgument;

typedef struct {
   NWDPSessionHandle    sessionHandle;
} PackSimpleArgument, *pPackSimpleArgument;

typedef struct {
   NWDPSessionHandle    sessionHandle;
} NWDPUnbindArgument, *pNWDPUnbindArgument;

typedef struct {
   NWDPSessionHandle    sessionHandle;
} PackUnbindArgument, *pPackUnbindArgument;

typedef struct {
   uint                 errorCode;
} NWDPSimpleResult, *pNWDPSimpleResult;

typedef struct {
   uint                 errorCode;
} PackSimpleResult, *pPackSimpleResult;

//juhi rename PA
typedef struct {
   uint                 errorCode;
} NWDPRenamePaResult, *pNWDPRenamePaResult;

typedef struct {
   uint                 errorCode;
} PackRenamePaResult, *pPackRenamePaResult;
//juhi rename PA

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  attrSet;
} NWDPSimpleAttrResult, *pNWDPSimpleAttrResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  attrSet;
} PackSimpleAttrResult, *pPackSimpleAttrResult;

typedef struct {
   NWDPObjectIdentifier transferMethod;
   pNWDPDocumentContent documentContentOptionPtr;
   NWDPObjectIdentifier documentType;
   NWDPAttributeSet     documentAttributes;
} NWDPDocumentDescription, *pNWDPDocumentDescription;

typedef struct {
   PackObjectIdentifier transferMethod;
   uint                 documentContentOptionOffset;
   PackObjectIdentifier documentType;
   PackAttributeSet     documentAttributes;
} PackDocumentDescription, *pPackDocumentDescription;

typedef struct {
   NWDPText printerName;
   nbool jobSubmissionComplete;
   NWDPAttributeSet jobAttributes;
   pNWDPDocumentDescription firstDocumentOptionPtr;
} NWDPCreateJob, *pNWDPCreateJob;

typedef struct {
   PackText             printerName;
   nbool                jobSubmissionComplete;
   PackAttributeSet     jobAttributes;
   uint                 firstDocumentOptionOffset;
} PackCreateJob, *pPackCreateJob;

typedef struct {
   NWDPPrtContainedObjectId existingJob;
   nbool jobSubmissionComplete;
   pNWDPDocumentDescription newDocumentPtr;
} NWDPAddDocument, *pNWDPAddDocument;

typedef struct {
   PackPrtContainedObjectId   existingJob;
   nbool                      jobSubmissionComplete;
   uint                       newDocumentOffset;
} PackAddDocument, *pPackAddDocument;

typedef struct {
   NWDPPrtContainedObjectId existingJob;
} NWDPCloseJob, *pNWDPCloseJob;

typedef struct {
   PackPrtContainedObjectId existingJob;
} PackCloseJob, *pPackCloseJob;

typedef enum {
   NWDP_PRINT_ARG_CREATE_JOB = 0,
   NWDP_PRINT_ARG_ADD_DOCUMENT = 1,
   NWDP_PRINT_ARG_CLOSE_JOB = 2
} NWDPPrintArgEnum, *pNWDPPrintArgEnum;

typedef struct {
   NWDPPrintArgEnum designator;
   union {
      NWDPCreateJob createJob;
      NWDPAddDocument addDocument;
      NWDPCloseJob closeJob;
   } u;
} NWDPPrintOperation, *pNWDPPrintOperation;

typedef struct {
   NWDPPrintArgEnum designator;
   union {
      PackCreateJob     createJob;
      PackAddDocument   addDocument;
      PackCloseJob      closeJob;
   } u;
} PackPrintOperation, *pPackPrintOperation;

typedef struct {
   NWDPSessionHandle    sessionHandle;
   NWDPPrintOperation   printOperation;
} NWDPPrintArgument, *pNWDPPrintArgument;

typedef struct {
   NWDPSessionHandle    sessionHandle;
   PackPrintOperation   printOperation;
} PackPrintArgument, *pPackPrintArgument;

typedef struct {
   uint                       errorCode;
   NWDPPrtContainedObjectId   jobIdentification;
   NWDPObjectIdentifier       serverStateOption;
   pNWDPNameOrOid             serverMessageOptionPtr;
   NWDPAttributeSet           documentStatusOption;
   NWDPAttributeSet           jobStatus;
} NWDPPrintResult, *pNWDPPrintResult;

typedef struct {
   uint                       errorCode;
   PackPrtContainedObjectId   jobIdentification;
   PackObjectIdentifier       serverStateOption;
   uint                       serverMessageOptionOffset;
   PackAttributeSet           documentStatusOption;
   PackAttributeSet           jobStatus;
} PackPrintResult, *pPackPrintResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPPrtContainedObjectId   jobIdentification;
   uint                       documentNumberOption;
   NWDPAttributeSet           jobAttrModificationSet;
   NWDPAttributeSet           docAttrModificationSet;
   pNWDPNameOrOid             modifyMessageOptionPtr;
} NWDPModifyJobArgument, *pNWDPModifyJobArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackPrtContainedObjectId   jobIdentification;
   uint                       documentNumberOption;
   PackAttributeSet           jobAttrModificationSet;
   PackAttributeSet           docAttrModificationSet;
   uint                       modifyMessageOptionOffset;
} PackModifyJobArgument, *pPackModifyJobArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  statusOption;
} NWDPModifyJobResult, *pNWDPModifyJobResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  statusOption;
} PackModifyJobResult, *pPackModifyJobResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPPrtContainedObjectId   jobIdentifier;
   uint                       documentNumberOption;
   pNWDPNameOrOid             cancelMessageOptionPtr;
   NWDPIntegerOption          retentionPeriodOption;
} NWDPCancelJobArgument, *pNWDPCancelJobArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackPrtContainedObjectId   jobIdentifier;
   uint                       documentNumberOption;
   uint                       cancelMessageOptionOffset;
   PackIntegerOption          retentionPeriodOption;
} PackCancelJobArgument, *pPackCancelJobArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  jobStatusOption;
} NWDPCancelJobResult, *pNWDPCancelJobResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  jobStatusOption;
} PackCancelJobResult, *pPackCancelJobResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPSessionHandle          dstSessionHandle;
   NWDPPrtContainedObjectId   jobIdentifier;
   uint                       documentNumber;
//   NWDPAttributeSet           jobAttrSet;
//   NWDPAttributeSet           docAttrSet;
   NWDPQualifiedName          destPrinterName;
   uint	                      isOAuthAuthentication;
   AuthAttr                   authAttr;
} NWDPMoveJobArgument, *pNWDPMoveJobArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPSessionHandle          dstSessionHandle;
   PackPrtContainedObjectId   jobIdentifier;
   uint                       documentNumber;
 //  PackAttributeSet           jobAttrSet;
 //  PackAttributeSet           docAttrSet;
   PackQualifiedName          destPrinterName;
	uint                      isOAuthAuthentication;
   AuthAttr                   authAttr;
} PackMoveJobArgument, *pPackMoveJobArgument;

typedef struct {
   uint              errorCode;
//   NWDPPrtContainedObjectId oldJobIdentifier;
   NWDPPrtContainedObjectId newJobIdentifier;
} NWDPMoveJobResult, *pNWDPMoveJobResult;

typedef struct {
   uint              errorCode;
  // PackPrtContainedObjectId   oldJobIdentifier;
   PackPrtContainedObjectId   newJobIdentifier;
} PackMoveJobResult, *pPackMoveJobResult;

//////////////
typedef enum {
   NWDP_FILTER_EQUALITY = 0,
   NWDP_FILTER_SUBSTRINGS = 1,
   NWDP_FILTER_GREATER_OR_EQUAL = 2,
   NWDP_FILTER_LESS_OR_EQUAL = 3,
   NWDP_FILTER_PRESENT = 4,
   NWDP_FILTER_SUBSET_OF = 5,
   NWDP_FILTER_SUPERSET_OF = 6,
   NWDP_FILTER_NON_NULL_SET_INTERS = 7
} NWDPFilterItemEnum, *pNWDPFilterItemEnum;

typedef struct {
   NWDPFilterItemEnum designator;
   union {
      NWDPAttribute equality;
      NWDPSubStrings substrings;
      NWDPAttribute greaterOrEqual;
      NWDPAttribute lessOrEqual;
      NWDPObjectIdentifier present;
      NWDPAttribute subsetOf;
      NWDPAttribute supersetOf;
      NWDPAttribute nonNullSetIntersect;
   } u;
} NWDPFilterItem, *pNWDPFilterItem;

typedef struct {
   NWDPFilterItemEnum designator;
   union {
      PackAttribute equality;
      PackSubStrings substrings;
      PackAttribute greaterOrEqual;
      PackAttribute lessOrEqual;
      PackObjectIdentifier present;
      PackAttribute subsetOf;
      PackAttribute supersetOf;
      PackAttribute nonNullSetIntersect;
   } u;
} PackFilterItem, *pPackFilterItem;

typedef enum {
   NWDP_FILTER_ITEM = 0,
   NWDP_FILTER_AND = 1,
   NWDP_FILTER_OR = 2,
   NWDP_FILTER_NOT = 3
} NWDPFilterEnum, *pNWDPFilterEnum;

typedef struct NWDPFilter_T {
   NWDPFilterEnum designator;
   union {
      NWDPFilterItem filterItem;
      struct {
         nuint itemCount;
         struct NWDPFilter_T *itemPtr;
      } filterAnd;
      struct {
         nuint itemCount;
         struct NWDPFilter_T *itemPtr;
      } filterOr;
      struct NWDPFilter_T *filterNotPtr;
   } u;
} NWDPFilter, *pNWDPFilter;

typedef struct PackFilter_T {
   NWDPFilterEnum designator;
   union {
      PackFilterItem filterItem;
      struct {
         uint  itemCount;
         uint  itemOffset;
      } filterAnd;
      struct {
         uint  itemCount;
         uint  itemOffset;
      } filterOr;
      uint  filterNotOffset;
   } u;
} PackFilter, *pPackFilter;

typedef struct {
   NWDPObjectIdentificationSeq objectIdentificationSeqOption;
   pNWDPFilter objectFilterOptionPtr;
   uint        timeLimitOption;
   uint        countLimitOption;
} NWDPSelector, *pNWDPSelector;

typedef struct {
   PackObjectIdentificationSeq objectIdentificationSeqOption;
   uint        objectFilterOptionOffset;
   uint        timeLimitOption;
   uint        countLimitOption;
} PackSelector, *pPackSelector;

typedef enum {
   NWDP_LIST_OP_ATTRIBUTES = 0,
   NWDP_LIST_OP_ORDERED_JOBS = 2,
   NWDP_LIST_OP_ORDERED_JOBS_OF_A_USER = 4,//For user's jobs from one single printer.
   NWDP_LIST_OP_ORDERED_WALKUP_JOBS_OF_A_USER = 6,//For user's jobs from all the walkup printers on the server.
} NWDPListOperatorEnum, *pNWDPListOperatorEnum;

typedef struct {
   NWDPObjectIdentifier       objectClass;
   uint                       scope;
   pNWDPSelector              selectorOptionPtr;
   pNWDPObjectIdentifierSet   requestedAttrsOptionPtr;
   NWDPListOperatorEnum       listOperator;
} NWDPListSpecification, *pNWDPListSpecification;

typedef struct {
   PackObjectIdentifier objectClass;
   uint                 scope;
   uint                 selectorOptionOffset;
   uint                 requestedAttrsOptionOffset;
   NWDPListOperatorEnum listOperator;
} PackListSpecification, *pPackListSpecification;

typedef struct {
   NWDPOctetString   context;
   nbool             abort;
} NWDPListContinuation, *pNWDPListContinuation;

typedef struct {
   PackOctetString   context;
   nbool             abort;
} PackListContinuation, *pPackListContinuation;

typedef enum {
   NWDP_LIST_ATTRIBUTES_ARG_CONT = 0,
   NWDP_LIST_ATTRIBUTES_ARG_SPEC = 1
} NWDPListAttrsArgEnum, *pNWDPListAttrsArgEnum;

typedef struct {
   NWDPListAttrsArgEnum designator;
   union {
      NWDPListContinuation continuation;
      NWDPListSpecification specification;
   } u;
} NWDPListAttrsOperation, *pNWDPListAttrsOperation;

typedef struct {
   NWDPListAttrsArgEnum designator;
   union {
      PackListContinuation continuation;
      PackListSpecification specification;
   } u;
} PackListAttrsOperation, *pPackListAttrsOperation;

typedef struct {
   NWDPSessionHandle       sessionHandle;
   NWDPListAttrsOperation  listAttrsOperation;
} NWDPListObjectAttrsArgument, *pNWDPListObjectAttrsArgument;

typedef struct {
   NWDPSessionHandle       sessionHandle;
   PackListAttrsOperation  listAttrsOperation;
} PackListObjectAttrsArgument, *pPackListObjectAttrsArgument;

typedef enum {
   NWDP_LIMIT_ENCOUNTERED_TIME = 0,
   NWDP_LIMIT_ENCOUNTERED_COUNT = 1,
   NWDP_LIMIT_ENCOUNTERED_ERROR = 2
} NWDPLimitEncounteredEnum, *pNWDPLimitEncounteredEnum;

typedef struct {
   int                        length;
   NWDPLimitEncounteredEnum   value;
} NWDPLimitEncounteredOption, *pNWDPLimitEncounteredOption;

typedef struct {
   NWDPObjectIdentification   objectIdentification;
   NWDPAttributeSet           attributes;
   NWDPObjectIdentifier       objectClass;
} NWDPObjectResult, *pNWDPObjectResult;

typedef struct {
   PackObjectIdentification   objectIdentification;
   PackAttributeSet           attributes;
   PackObjectIdentifier       objectClass;
} PackObjectResult, *pPackObjectResult;

typedef struct {
   uint              itemCount;
   pNWDPObjectResult itemPtr;
} NWDPObjectResultSet, *pNWDPObjectResultSet;

typedef struct {
   uint     itemCount;
   uint     itemOffset;
} PackObjectResultSet, *pPackObjectResultSet;

typedef struct {
   uint                       errorCode;
   uint                       answerTime;
   NWDPOctetString            continuationOption;
   NWDPLimitEncounteredOption limitEncounteredOption;
   NWDPObjectResultSet        resultSet;
} NWDPListObjectAttrsResult, *pNWDPListObjectAttrsResult;

typedef struct {
   uint                       errorCode;
   uint                       answerTime;
   PackOctetString            continuationOption;
   NWDPLimitEncounteredOption limitEncounteredOption;
   PackObjectResultSet        resultSet;
} PackListObjectAttrsResult, *pPackListObjectAttrsResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPPrtContainedObjectId   jobIdentifier;
   pNWDPNameOrOid             messageOptionPtr;
} NWDPPromoteJobArgument, *pNWDPPromoteJobArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackPrtContainedObjectId   jobIdentifier;
   uint                       messageOptionOffset;
} PackPromoteJobArgument, *pPackPromoteJobArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  jobStatusOption;
} NWDPPromoteJobResult, *pNWDPPromoteJobResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  jobStatusOption;
} PackPromoteJobResult, *pPackPromoteJobResult;

typedef enum {
   NWDP_INTERRUPTED_JOB_ID = 0,
   NWDP_INTERRUPTED_PRINTER_NM = 1
} NWDPInterruptJobEnum, *pNWDPInterruptJobEnum;

typedef struct {
   NWDPInterruptJobEnum designator;
   union {
      NWDPPrtContainedObjectId jobIdentifier;
      NWDPText printerName;
   } u;
} NWDPInterruptJob, *pNWDPInterruptJob;

typedef struct {
   NWDPInterruptJobEnum designator;
   union {
      PackPrtContainedObjectId   jobIdentifier;
      PackText                   printerName;
   } u;
} PackInterruptJob, *pPackInterruptJob;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPInterruptJob           interruptedJob;
   pNWDPNameOrOid             interruptMessageOptionPtr;
   NWDPPrtContainedObjectId   interruptingJob;
} NWDPInterruptArgument, *pNWDPInterruptArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackInterruptJob           interruptedJob;
   uint                       interruptMessageOptionOffset;
   PackPrtContainedObjectId   interruptingJob;
} PackInterruptArgument, *pPackInterruptArgument;

typedef struct {
   uint                       errorCode;
   NWDPPrtContainedObjectId   interruptedJobId;
   NWDPAttributeSet           jobStatusOption;
} NWDPInterruptResult, *pNWDPInterruptResult;

typedef struct {
   uint                       errorCode;
   PackPrtContainedObjectId   interruptedJobId;
   PackAttributeSet           jobStatusOption;
} PackInterruptResult, *pPackInterruptResult;

typedef enum {
   NWDP_PAUSE_JOB_ID = 0,
   NWDP_PAUSE_PRINTER_NM = 1
} NWDPPauseJobEnum, *pNWDPPauseJobEnum;

typedef struct {
   NWDPPauseJobEnum designator;
   union {
      NWDPPrtContainedObjectId jobIdentifier;
      NWDPText printerName;
   } u;
} NWDPPauseJob, *pNWDPPauseJob;

typedef struct {
   NWDPPauseJobEnum designator;
   union {
      PackPrtContainedObjectId jobIdentifier;
      PackText printerName;
   } u;
} PackPauseJob, *pPackPauseJob;

typedef struct {
   NWDPSessionHandle sessionHandle;
   NWDPPauseJob      pausedJob;
   pNWDPNameOrOid    pauseMessageOptionPtr;
} NWDPPauseArgument, *pNWDPPauseArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   PackPauseJob      pausedJob;
   uint              pauseMessageOptionOffset;
} PackPauseArgument, *pPackPauseArgument;

typedef struct {
   uint                       errorCode;
   NWDPPrtContainedObjectId   pausedJobId;
   NWDPAttributeSet           jobStatusOption;
} NWDPPauseResult, *pNWDPPauseResult;

typedef struct {
   uint                       errorCode;
   PackPrtContainedObjectId   pausedJobId;
   PackAttributeSet           jobStatusOption;
} PackPauseResult, *pPackPauseResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPPrtContainedObjectId   resumedJob;
   pNWDPNameOrOid             resumeMessageOptionPtr;
} NWDPResumeArgument, *pNWDPResumeArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackPrtContainedObjectId   resumedJob;
   uint                       resumeMessageOptionOffset;
} PackResumeArgument, *pPackResumeArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  jobStatusOption;
} NWDPResumeResult, *pNWDPResumeResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  jobStatusOption;
} PackResumeResult, *pPackResumeResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   pNWDPNameOrOid    cleanMessageOptionPtr;
} NWDPCleanArgument, *pNWDPCleanArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   uint              cleanMessageOptionOffset;
} PackCleanArgument, *pPackCleanArgument;

typedef struct {
   uint              errorCode;
} NWDPCleanResult, *pNWDPCleanResult;

typedef struct {
   uint              errorCode;
} PackCleanResult, *pPackCleanResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPObjectIdentifier       objectClass;
   NWDPObjectIdentification   objectId;
   nbool                      force;
   pNWDPObjectIdentification  referenceObjectOptionPtr;
   NWDPAttributeSet           objectAttrSetOption;
} NWDPCreateArgument, *pNWDPCreateArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackObjectIdentifier       objectClass;
   PackObjectIdentification   objectId;
   nbool                      force;
   uint                       referenceObjectOptionOffset;
   PackAttributeSet           objectAttrSetOption;
} PackCreateArgument, *pPackCreateArgument;

//juhi rename printer
typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPText       printerOldName;
   NWDPText       printerNewName;
} NWDPRenamePaArgument, *pNWDPRenamePaArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackText         printerOldName;
   PackText       printerNewName;
} PackRenamePaArgument, *pPackRenamePaArgument;
//juhi rename printer

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  returnedAttrsOption;
} NWDPCreateResult, *pNWDPCreateResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  returnedAttrsOption;
} PackCreateResult, *pPackCreateResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPObjectIdentifier       objectClass;
   NWDPObjectIdentification   objectId;
} NWDPDeleteArgument, *pNWDPDeleteArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackObjectIdentifier       objectClass;
   PackObjectIdentification   objectId;
} PackDeleteArgument, *pPackDeleteArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  returnedAttrsOption;
} NWDPDeleteResult, *pNWDPDeleteResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet returnedAttrsOption;
} PackDeleteResult, *pPackDeleteResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   pNWDPNameOrOid    disablePAMessageOptionPtr;
} NWDPDisablePAArgument, *pNWDPDisablePAArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   uint              disablePAMessageOptionOffset;
} PackDisablePAArgument, *pPackDisablePAArgument;

typedef struct {
   uint              errorCode;
} NWDPDisablePAResult, *pNWDPDisablePAResult;

typedef struct {
   uint              errorCode;
} PackDisablePAResult, *pPackDisablePAResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   pNWDPNameOrOid    enablePAMessageOptionPtr;
} NWDPEnablePAArgument, *pNWDPEnablePAArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   uint              enablePAMessageOptionOffset;
} PackEnablePAArgument, *pPackEnablePAArgument;

typedef struct {
   uint              errorCode;
} NWDPEnablePAResult, *pNWDPEnablePAResult;

typedef struct {
   uint errorCode;
} PackEnablePAResult, *pPackEnablePAResult;

typedef enum {
   NWDP_RESUBMIT_OP_COPY = 0,
   NWDP_RESUBMIT_OP_MOVE = 1
} NWDPResubmitOpEnum, *pNWDPResubmitOpEnum;
  /* If documentNumber is 0, docAttrSet is applied to all documents */

typedef struct {
   NWDPPrtContainedObjectId   jobId;
   uint                       documentNumber;
   NWDPAttributeSet           jobAttrSet;
   NWDPAttributeSet           docAttrSet;
} NWDPResubmitJob, *pNWDPResubmitJob;

typedef struct {
   PackPrtContainedObjectId   jobId;
   uint                       documentNumber;
   PackAttributeSet           jobAttrSet;
   PackAttributeSet           docAttrSet;
} PackResubmitJob, *pPackResubmitJob;

typedef struct {
   uint              itemCount;
   pNWDPResubmitJob  itemPtr;
} NWDPResubmitJobSet, *pNWDPResubmitJobSet;

typedef struct {
   uint        itemCount;
   uint        itemOffset;
} PackResubmitJobSet, *pPackResubmitJobSet;

typedef struct {
   NWDPSessionHandle    sessionHandle;
   NWDPQualifiedName    destPrinterNameOption;
   pNWDPNetAddress      destPrinterNetAddressPtr;
   NWDPResubmitOpEnum   operation;
   NWDPResubmitJobSet   resubmitJobSet;
   pNWDPNameOrOid       resubmitMessageOptionPtr;
   uint                 isOAuthAuthentication;
   AuthAttr             authAttr;
} NWDPResubmitJobsArgument, *pNWDPResubmitJobsArgument;

typedef struct {
   NWDPSessionHandle    sessionHandle;
   PackQualifiedName    destPrinterNameOption;
   uint                 destPrinterNetAddressOffset;
   NWDPResubmitOpEnum   operation;
   PackResubmitJobSet   resubmitJobSet;
   uint                 resubmitMessageOptionOffset;
   uint                 isOAuthAuthentication;
   AuthAttr             authAttr;
} PackResubmitJobsArgument, *pPackResubmitJobsArgument;

typedef struct {
   NWDPPrtContainedObjectId oldJobIdentifier;
   NWDPPrtContainedObjectId newJobIdentifier;
   NWDPAttributeSet jobStatusOption;
} NWDPResubmitJobResult, *pNWDPResubmitJobResult;

typedef struct {
   PackPrtContainedObjectId   oldJobIdentifier;
   PackPrtContainedObjectId   newJobIdentifier;
   PackAttributeSet           jobStatusOption;
} PackResubmitJobResult, *pPackResubmitJobResult;

typedef struct {
   uint                    itemCount;
   pNWDPResubmitJobResult  itemPtr;
} NWDPResubmitJobResultSet, *pNWDPResubmitJobResultSet;

typedef struct {
   uint        itemCount;
   uint        itemOffset;
} PackResubmitJobResultSet, *pPackResubmitJobResultSet;

typedef struct {
   uint                       errorCode;
   NWDPResubmitJobResultSet   resubmitJobResultSet;
} NWDPResubmitJobsResult, *pNWDPResubmitJobsResult;

typedef struct {
   uint                       errorCode;
   PackResubmitJobResultSet   resubmitJobResultSet;
} PackResubmitJobsResult, *pPackResubmitJobsResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPObjectIdentifier       objectClass;
   NWDPObjectIdentification   objectId;
   NWDPAttributeSet           attrModificationSet;
} NWDPSetArgument, *pNWDPSetArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackObjectIdentifier       objectClass;
   PackObjectIdentification   objectId;
   PackAttributeSet           attrModificationSet;
} PackSetArgument, *pPackSetArgument;

typedef struct {
   uint              errorCode;
} NWDPSetResult, *pNWDPSetResult;

typedef struct {
   uint              errorCode;
} PackSetResult, *pPackSetResult;

typedef enum {
   NWDP_SHUTDN_TYPE_DO_CURRNT_JOBS = 0,
   NWDP_SHUTDN_TYPE_IMMEDIATE = 1,
   NWDP_SHUTDN_TYPE_DO_PENDNG_JOBS = 2
} NWDPShutdownTypeEnum, *pNWDPShutdownTypeEnum;

typedef struct {
   NWDPSessionHandle    sessionHandle;
   NWDPShutdownTypeEnum shutdownType;
   NWDPText             printerName;
   pNWDPNameOrOid       shutdownMessageOptionPtr;
} NWDPShutdownArgument, *pNWDPShutdownArgument;

typedef struct {
   NWDPSessionHandle    sessionHandle;
   NWDPShutdownTypeEnum shutdownType;
   PackText             printerName;
   uint                 shutdownMessageOptionOffset;
} PackShutdownArgument, *pPackShutdownArgument;

typedef struct {
   uint              errorCode;
} NWDPShutdownResult, *pNWDPShutdownResult;

typedef struct {
   uint              errorCode;
} PackShutdownResult, *pPackShutdownResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   NWDPText          printerName;
   pNWDPNameOrOid    startupMessageOptionPtr;
} NWDPStartupArgument, *pNWDPStartupArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   PackText          printerName;
   uint              startupMessageOptionOffset;
} PackStartupArgument, *pPackStartupArgument;

typedef struct {
   uint              errorCode;
} NWDPStartupResult, *pNWDPStartupResult;

typedef struct {
   uint              errorCode;
} PackStartupResult, *pPackStartupResult;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPPrtContainedObjectId   jobIdentification;
   NWDPPrtContainedObjectId   referenceJobId;
} NWDPReorderJobArgument, *pNWDPReorderJobArgument;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   PackPrtContainedObjectId   jobIdentification;
   PackPrtContainedObjectId   referenceJobId;
} PackReorderJobArgument, *pPackReorderJobArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  jobStatusOption;
} NWDPReorderJobResult, *pNWDPReorderJobResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  jobStatusOption;
} PackReorderJobResult, *pPackReorderJobResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   pNWDPNameOrOid    pauseMessageOptionPtr;
} NWDPPausePAArgument, *pNWDPPausePAArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   uint              pauseMessageOptionOffset;
} PackPausePAArgument, *pPackPausePAArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  printerStatusOption;
} NWDPPausePAResult, *pNWDPPausePAResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  printerStatusOption;
} PackPausePAResult, *pPackPausePAResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   pNWDPNameOrOid    resumeMessageOptionPtr;
} NWDPResumePAArgument, *pNWDPResumePAArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   uint              resumeMessageOptionOffset;
} PackResumePAArgument, *pPackResumePAArgument;

typedef struct {
   uint              errorCode;
   NWDPAttributeSet  printerStatusOption;
} NWDPResumePAResult, *pNWDPResumePAResult;

typedef struct {
   uint              errorCode;
   PackAttributeSet  printerStatusOption;
} PackResumePAResult, *pPackResumePAResult;

typedef struct {
   uint              errorCode;
} NWDPTransferDataResult, *pNWDPTransferDataResult;

typedef struct {
  uint               errorCode;
} PackTransferDataResult, *pPackTransferDataResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   pNWDPNameOrOid    cancelShutdownMessageOptionPtr;
} NWDPCancelPSMShutdownArg, *pNWDPCancelPSMShutdownArg;

typedef struct {
   NWDPSessionHandle sessionHandle;
   uint              cancelShutdownMessageOptionOffset;
} PackCancelPSMShutdownArg, *pPackCancelPSMShutdownArg;

typedef struct {
   uint              errorCode;
} NWDPCancelShutdownResult, *pNWDPCancelShutdownResult;

typedef struct {
   uint              errorCode;
} PackCancelShutdownResult, *pPackCancelShutdownResult;

typedef enum {
   NWDP_SET_PRINTER_OBJ_ADD = 0,
   NWDP_SET_PRINTER_OBJ_REMOVE = 1,
   NWDP_SET_PRINTER_OBJ_UPDATE = 2
} NWDPSetPrinterDSInfoEnum, *pNWDPSetPrinterDSInfoEnum;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPSetPrinterDSInfoEnum   opCode;
   NWDPText                   paNameOption;
   NWDPQualifiedName          dsObjectNameOption;
} NWDPSetPrinterDSInfoArg, *pNWDPSetPrinterDSInfoArg;

typedef struct {
   NWDPSessionHandle          sessionHandle;
   NWDPSetPrinterDSInfoEnum   opCode;
   PackText                   paNameOption;
   PackQualifiedName          dsObjectNameOption;
} PackSetPrinterDSInfoArg, *pPackSetPrinterDSInfoArg;

typedef struct {
   nuint errorCode;
} NWDPSetPrinterDSInfoResult, *pNWDPSetPrinterDSInfoResult;

typedef struct {
   nuint errorCode;
} PackSetPrinterDSInfoResult, *pPackSetPrinterDSInfoResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   NWDPText          clientName;
   NWDPText          requestUri;
   NWDPText          language;
} NWDPQueryHealthMonArg, *pNWDPQueryHealthMonArg;

typedef struct {
   NWDPSessionHandle sessionHandle;
   PackText          clientName;
   PackText          requestUri;
   PackText          language;
} PackQueryHealthMonArg, *pPackQueryHealthMonArg;

typedef struct {
   uint              errorCode;
   NWDPSessionHandle sessionHandle;
   NWDPOctetString   data;
} NWDPQueryHealthMonResult, *pNWDPQueryHealthMonResult;

typedef struct {
   uint              errorCode;
   NWDPSessionHandle sessionHandle;
   PackOctetString   data;
} PackQueryHealthMonResult, *pPackQueryHealthMonResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
   int               fileOffset;
   NWDPText          serviceName;
   NWDPText          fileName;
} NWDPGetAuditLogInfoArg, *pNWDPGetAuditLogInfoArg;

typedef struct {
   NWDPSessionHandle sessionHandle;
   int               fileOffset;
   PackText          serviceName;
   PackText          fileName;
} PackGetAuditLogInfoArg, *pPackGetAuditLogInfoArg;

typedef struct {
   uint              errorCode;
   int               fileOffset;
   int               suppliedRecordCount;
   int               continuationFlag;
   NWDPText          fileName;
   NWDPOctetString   data;
} NWDPGetAuditLogInfoResult, *pNWDPGetAuditLogInfoResult;

typedef struct {
   uint              errorCode;
   int               fileOffset;
   int               suppliedRecordCount;
   int               continuationFlag;
   PackText          fileName;
   PackOctetString   data;
} PackGetAuditLogInfoResult, *pPackGetAuditLogInfoResult;

typedef struct {
   NWDPSessionHandle sessionHandle;
} NWDPGetWalkupExpiry, *pNWDPGetWalkupExpiry;

typedef struct {
   NWDPSessionHandle sessionHandle;
} PackGetWalkupExpiry, *pPackGetWalkupExpiry;

typedef struct {
   uint              errorCode;
   uint              time;
} NWDPGetWalkupExpiryRes, *pNWDPGetWalkupExpiryRes;

typedef struct {
   uint              errorCode;
   uint              time;
} PackGetWalkupExpiryRes, *pPackGetWalkupExpiryRes;

typedef struct {
   NWDPSessionHandle sessionHandle;
   int               status;
   struct {
      uint     itemCount;
      pnint8   itemPtr;
   } data;
} NWDPTransferDataArgument, *pNWDPTransferDataArgument;

typedef struct {
   NWDPSessionHandle sessionHandle;
   int               status;
   struct {
      uint     itemCount;
      uint     itemOffset;
   } data;
} PackTransferDataArgument, *pPackTransferDataArgument;

/*
// Begin Accounting structures
*/

typedef struct {
   uint        version;
   uint8_t     name[64];
} AcctgBindPsmArg, *pAcctgBindPsmArg;

typedef struct {
   uint8_t     name[64];
} AcctgUnbindPsmArg, *pAcctgUnbindPsmArg;

typedef struct {
   int               paHandle;
   uint8_t           printerAgent[64];
   uint8_t           configString[512];
} AcctgBindPAArg, *pAcctgBindPAArg;

   /*
   // These are the values for the jobAcctgPointMask in AcctgBindPAReply.
   */
   #define  ACCOUNTING_POINT_NEW_JOB      1
   #define  ACCOUNTING_POINT_JOB_CREATED  2
   #define  ACCOUNTING_POINT_JOB_START    4
   #define  ACCOUNTING_POINT_JOB_CLOSE    8

typedef struct {
   uint              errorCode;
   int               paHandle;
   uint              jobAcctgPointMask;
   uint8_t           errorString[512];
} AcctgBindPAReply, *pAcctgBindPAReply;

typedef struct {
   int                        paHandle;
} AcctgUnbindPAArg, *pAcctgUnbindPAArg;

typedef enum {
   NWDP_ACCTG_ARG_NEW_JOB     = 1,
   NWDP_ACCTG_ARG_JOB_CREATED = 2,
   NWDP_ACCTG_ARG_JOB_START   = 3,
   NWDP_ACCTG_ARG_JOB_CLOSE   = 4
} AcctgReportTypeEnum, *pAcctgReportTypeEnum;

typedef enum {
   ACC_JOB_COMPLETE_UNKNOWN =     0,
   ACC_JOB_COMPLETE_NORMAL =      1,
   ACC_JOB_COMPLETE_CANCEL_USER = 2,
   ACC_JOB_COMPLETE_CANCEL_OPER = 3,
   ACC_JOB_COMPLETE_ABORT_SYS   = 4,
   ACC_JOB_COMPLETE_SILENT_CANCEL_OPER = 5,  //20150514 Juhi Mittal Bugzilla#Silent Job Cancel
   ACC_JOB_COMPLETE_CANCEL_DUE_TO_WALKUP_EXPIRY = 6, //20151007 Leena M Bugzilla#Walkup
   ACC_JOB_COMPLETE_CANCEL_DUE_TO_JOB_EXPIRY = 7
} JobCompleteTypeEnum;

typedef struct {
   int                        paHandle;
   AcctgReportTypeEnum        acctgReportType;
   uint8_t                    printerName[64];
   uint                       jobNumber;
   uint8_t                    jobOwner[512];
   uint8_t                    submitterAddress[64];
   uint8_t                    jobName[1024];
   uint8_t                    jobPoolPath[512];
   uint                       jobSize;
   uint                       jobPageCount;
   int                        jobHasBannerFlag;
   time_t                     createTime;
   time_t                     completeTime;
   JobCompleteTypeEnum        jobCompleteType;
} AcctgInfoArg, *pAcctgInfoArg;

typedef enum {
   ACCT_JOB_ACTION_NONE        = 0,
   ACCT_JOB_ACTION_CANCEL      = 1,
   ACCT_JOB_ACTION_ADD_HOLD    = 2,
   ACCT_JOB_ACTION_REMOVE_HOLD = 3,
   ACCT_JOB_ACTION_SILENT_CANCEL  =4 //20150514 Juhi Mittal Bugzilla#Silent Job Cancel
} AcctgJobActionEnum;

typedef struct {
   uint                 errorCode;
   int                  paHandle;
   uint                 jobNumber;
   uint                 jobSize;
   uint                 jobPageCount;
   AcctgJobActionEnum   jobAction;
   uint8_t              errorString[512];
} AcctgInfoReply, *pAcctgInfoReply;

typedef struct {
   int                  paHandle;
   uint                 jobNumber;
   AcctgJobActionEnum   jobAction;
} AcctgJobActionArg, *pAcctgJobActionArg;

/*
// End Accounting structures
*/

// #include <npackoff.h>


/* Structure Definitions */

/* Global Variable Declarations */

/* Function Prototype Declarations */

#if defined(NWDP_SERVER_PROTOTYPES)
N_EXTERN_FUNC(pNWDPBindPSMResult)
nwdp_bindpsm_1(
   pNWDPBindArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPBindPSMResult)
nwdp_bindpa_1(
   pNWDPBindPAArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPSimpleResult)
nwdp_unbind_1(
   pNWDPUnbindArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPPrintResult)
nwdp_print_1(
   pNWDPPrintArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPModifyJobResult)
nwdp_modifyjob_1(
   pNWDPModifyJobArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPMoveJobResult)
nwdp_movejob_1(
   pNWDPMoveJobArgument argp,
   psvc_req rqstp
   );
N_EXTERN_LIBRARY(nint)
nwdp_getwalkupexpiry_1(
   pNWDPGetWalkupExpiry argp,
   pNWDPGetWalkupExpiryRes resp
   );
N_EXTERN_FUNC(pNWDPCancelJobResult)
nwdp_canceljob_1(
   pNWDPCancelJobArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPListObjectAttrsResult)
nwdp_listobjectattributes_1(
   pNWDPListObjectAttrsArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPPromoteJobResult)
nwdp_promotejob_1(
   pNWDPPromoteJobArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPInterruptResult)
nwdp_interrupt_1(
   pNWDPInterruptArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPPauseResult)
nwdp_pause_1(
   pNWDPPauseArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPResumeResult)
nwdp_resume_1(
   pNWDPResumeArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPCleanResult)
nwdp_clean_1(
   pNWDPCleanArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPCreateResult)
nwdp_create_1(
   pNWDPCreateArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPDeleteResult)
nwdp_delete_1(
   pNWDPDeleteArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPDisablePAResult)
nwdp_disablepa_1(
   pNWDPDisablePAArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPEnablePAResult)
nwdp_enablepa_1(
   pNWDPEnablePAArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPResubmitJobsResult)
nwdp_resubmitjobs_1(
   pNWDPResubmitJobsArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPSetResult)
nwdp_set_1(
   pNWDPSetArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPShutdownResult)
nwdp_shutdownpa_1(
   pNWDPShutdownArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPStartupResult)
nwdp_startuppa_1(
   pNWDPStartupArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPReorderJobResult)
nwdp_reorderjob_1(
   pNWDPReorderJobArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPPausePAResult)
nwdp_pausepa_1(
   pNWDPPausePAArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPResumePAResult)
nwdp_resumepa_1(
   pNWDPResumePAArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPTransferDataResult)
nwdp_transferdata_1(
   pNWDPTransferDataArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPShutdownResult)
nwdp_shutdownpsm_1(
   pNWDPShutdownArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPCancelShutdownResult)
nwdp_cancelpsmshutdown_1(
   pNWDPCancelPSMShutdownArg argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPSetPrinterDSInfoResult)
nwdp_setprinterdsinfo_1(
   pNWDPSetPrinterDSInfoArg argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPCleanResult)
nwdp_cleanuserjobs_1(
   pNWDPCleanArgument argp,
   psvc_req rqstp
   );
N_EXTERN_FUNC(pNWDPSimpleResult)
nwdp_backupmanagerdatabase_1(
   pNWDPSimpleArgument argp,
   psvc_req rqstp
   );
#elif defined(NWDP_CLIENT_PROTOTYPES)

N_EXTERN_LIBRARY(nint)
nwdp_bindpsm_1(
   pCLIENT clnt,
   pNWDPBindArgument argp,
   pNWDPBindPSMResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_bindpa_1(
   pCLIENT clnt,
   pNWDPBindPAArgument argp,
   pNWDPBindPSMResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_unbind_1(
   pCLIENT clnt,
   pNWDPUnbindArgument argp,
   pNWDPSimpleResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_print_1(
   pCLIENT clnt,
   pNWDPPrintArgument argp,
   pNWDPPrintResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_modifyjob_1(
   pCLIENT clnt,
   pNWDPModifyJobArgument argp,
   pNWDPModifyJobResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_movejob_1(
   pCLIENT clnt,
   pNWDPMoveJobArgument argp,
   pNWDPMoveJobResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_getwalkupexpiry_1(
   pCLIENT clnt,
   pNWDPGetWalkupExpiry argp,
   pNWDPGetWalkupExpiryRes resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_canceljob_1(
   pCLIENT clnt,
   pNWDPCancelJobArgument argp,
   pNWDPCancelJobResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_listobjectattributes_1(
   pCLIENT clnt,
   pNWDPListObjectAttrsArgument argp,
   pNWDPListObjectAttrsResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_promotejob_1(
   pCLIENT clnt,
   pNWDPPromoteJobArgument argp,
   pNWDPPromoteJobResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_interrupt_1(
   pCLIENT clnt,
   pNWDPInterruptArgument argp,
   pNWDPInterruptResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_pause_1(
   pCLIENT clnt,
   pNWDPPauseArgument argp,
   pNWDPPauseResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_resume_1(
   pCLIENT clnt,
   pNWDPResumeArgument argp,
   pNWDPResumeResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_clean_1(
   pCLIENT clnt,
   pNWDPCleanArgument argp,
   pNWDPCleanResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_create_1(
   pCLIENT clnt,
   pNWDPCreateArgument argp,
   pNWDPCreateResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_delete_1(
   pCLIENT clnt,
   pNWDPDeleteArgument argp,
   pNWDPDeleteResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_disablepa_1(
   pCLIENT clnt,
   pNWDPDisablePAArgument argp,
   pNWDPDisablePAResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_enablepa_1(
   pCLIENT clnt,
   pNWDPEnablePAArgument argp,
   pNWDPEnablePAResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_resubmitjobs_1(
   pCLIENT clnt,
   pNWDPResubmitJobsArgument argp,
   pNWDPResubmitJobsResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_set_1(
   pCLIENT clnt,
   pNWDPSetArgument argp,
   pNWDPSetResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_shutdownpa_1(
   pCLIENT clnt,
   pNWDPShutdownArgument argp,
   pNWDPShutdownResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_startuppa_1(
   pCLIENT clnt,
   pNWDPStartupArgument argp,
   pNWDPStartupResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_reorderjob_1(
   pCLIENT clnt,
   pNWDPReorderJobArgument argp,
   pNWDPReorderJobResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_pausepa_1(
   pCLIENT clnt,
   pNWDPPausePAArgument argp,
   pNWDPPausePAResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_resumepa_1(
   pCLIENT clnt,
   pNWDPResumePAArgument argp,
   pNWDPResumePAResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_transferdata_1(
   pCLIENT clnt,
   pNWDPTransferDataArgument argp,
   pNWDPTransferDataResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_shutdownpsm_1(
   pCLIENT clnt,
   pNWDPShutdownArgument argp,
   pNWDPShutdownResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_cancelpsmshutdown_1(
   pCLIENT clnt,
   pNWDPCancelPSMShutdownArg argp,
   pNWDPCancelShutdownResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_setprinterdsinfo_1(
   pCLIENT clnt,
   pNWDPSetPrinterDSInfoArg argp,
   pNWDPSetPrinterDSInfoResult resp
   );
N_EXTERN_LIBRARY(nint)
nwdp_cleanuserjobs_1(
   pCLIENT clnt,
   pNWDPCleanArgument argp,
   pNWDPCleanResult resp
   );
N_EXTERN_LIBRARY(pNWDPSimpleResult)
nwdp_backupmanagerdatabase_1(
   pNWDPSimpleArgument argp,
   psvc_req rqstp
   );
#endif /* NWDP_CLIENT_PROTOTYPES/NWDP_SERVER_PROTOTYPES */

#endif /* NWDPNDPS_H */

