/*
##################################################################################################################
# (c) Copyright 2001-2020 Micro Focus or one of its affiliates.
#
# The only warranties for products and services of Micro Focus and its affiliates and licensors (“Micro Focus”)
# are as may be set forth in the express warranty statements accompanying such products and services. Nothing
# herein should be construed as constituting an additional warranty. Micro Focus shall not be liable for technical
# or editorial errors or omissions contained herein. The information contained herein is subject to change without
# notice.
##################################################################################################################
# Source module name: psmops.h
##################################################################################################################
*/
//+==========================================================================+
//| Source module name: psmops.h
//+==========================================================================+
//|$Author: dtaylor $              $Locker:  $
//|$Revision: 1.3 $            $Name:  $ $State: Exp $
//|$Date: 2008/02/27 17:53:35 $
//+===========================================================================

/* Inclusion Control */
#ifndef PSMOPS_H
#define  PSMOPS_H

/* Standard Library Header Includes */
   #include <nwdpndps.h>
   // #include <attrset.h>

/* Header Includes */
   // #include "nwdpxfer.h"

/* Manifest Constant Definitions */

/* Macro Definitions */

/* Type Definitions */

/* Structure Definitions */

/* Global Variable Declarations */

/* External Function Prototypes */
   int nwdp_printprogram_a(
      nuint32              opCode,
      pnuint8              requestPtr,
      ppnuint8             resultDataPtr);

   int BindToPsm(
      uint                 opCode,
      int                  localBindFlag,
      nuint32              clientAddress,
      pnuint8              printerNamePtr,
      pnuint8              loginNamePtr,
      pnuint8              userNamePtr,
      NWDPSessionHandle   *sessionHandlePtr,
      pnuint8              printerNameOptPtr,
      pAuthAttr            userAuthAttrPtr);

   void UnbindFromPsm(
      NWDPSessionHandle    sessionHandle);

   void BindAccountingToPsm(
      uint8_t             *accountingServiceNamePtr);

   void UnbindAccountingFromPsm(
      uint8_t             *accountingServiceNamePtr);

   int AcctgJobAction(
      int                  paHandle,
      uint                 jobNumber,
      AcctgJobActionEnum   jobAction);

   int CreateObject(
      nptr                       sessionHandle,
      pNWDPOid                   classOidPtr,
      pNWDPObjectIdentification  objectIdPtr,
      pNWDPAttributeSet          attrSetPtr,
      int                        forceFlag);

   int DeleteObject(
      NWDPSessionHandle          sessionHandle,
      pNWDPOid                   classOidPtr,
      pNWDPObjectIdentification  objectIdPtr);

   int GetObjectAttributes(
      nptr                          sessionHandle,
      NWDPListOperatorEnum          listOperator,
      pNWDPOid                      classOidPtr,
      nuint32                       scope,
      pNWDPSelector                 selectorOptionPtr,
      pNWDPObjectIdentifierSet      oidSetPtr,
      pnuint8                       listContinuationPtr,
      pNWDPListObjectAttrsResult   *loaResultPtr);

   int GetPrinterAttributes(
      NWDPSessionHandle             sessionHandle,
      uint8_t                      *printerNamePtr,
      pNWDPObjectIdentifierSet      requestedAttrsOptionPtr,
      pAttrSetStruct               *attrSetPtrPtr);

   int GetJobAttributes(
      NWDPSessionHandle             sessionHandle,
      uint8_t                      *printerNamePtr,
      uint                          jobNumber,
      pNWDPObjectIdentifierSet      requestedAttrsOptionPtr,
      pAttrSetStruct               *attrSetPtrPtr);

   int GetDocAttributes(
      NWDPSessionHandle             sessionHandle,
      uint8_t                      *printerNamePtr,
      uint                          jobNumber,
      uint                          docNumber,
      pNWDPObjectIdentifierSet      requestedAttrsOptionPtr,
      pAttrSetStruct               *attrSetPtrPtr);

   int SetObjectAttributes(
      nptr                          sessionHandle,
      pNWDPOid                      classOidPtr,
      pNWDPObjectIdentification     requestedAttrsOptionPtr,
      pNWDPAttributeSet             attrSetPtr);

   int SetPrinterAttributes(
      NWDPSessionHandle             sessionHandle,
      uint8_t                      *printerNamePtr,
      pNWDPAttributeSet             attrSetPtr);

   int SetJobAttributes(
      NWDPSessionHandle             sessionHandle,
      uint8_t                      *printerNamePtr,
      uint                          jobNumber,
      pNWDPAttributeSet             attrSetPtr);

   int SetDocAttributes(
      NWDPSessionHandle             sessionHandle,
      uint8_t                      *printerNamePtr,
      uint                          jobNumber,
      uint                          docNumber,
      pNWDPAttributeSet             attrSetPtr);

   int SubmitPrintJob(
      NWDPSessionHandle       sessionHandle,
      NWDPPrintArgEnum        designator,
      pnuint                  jobIdPtr,
      pNWDPAttributeSet       jobAttributesPtr,
      pNWDPAttributeSet       docAttrsOptionPtr,
      pNWDPPrintResult       *printResultOptionPtr);

/* Function Prototype Declarations */

#endif /* PSMOPS_H */

/****************************************************************************/
