/*
//+==========================================================================+
Novell Developer License Agreement

1. PURPOSE. Novell makes available the Novell developer software and documentation (the "Software") under the terms of this Novell Developer License Agreement.  If You do not agree to these terms, You may not access or use the Software.

2. DEFINITIONS. The following terms have the meanings assigned to them below:

   "Derivative Software" means the Binary code Software and/or Binary code that results from your compilation of modified or unmodified source code Software. Derivative Software may not include Early Access Release Materials or Internal Tools.

   "Developer Product" means Your own computer product that incorporates Derivative Software and does not substantially duplicate the capabilities or compete with the Derivative Software or the Software.

   "Early Access Release Materials" means Software and/or Documentation Novell identifies as "beta", "pre-release," "futures," or as an "early access release."

   "Internal Tools" means compatibility criteria, test suites, test tools, end user products, and other programs designed to aid in the development of, but not be incorporated in, Derivative Software Products.

3. LICENSES. Use of the Software and Documentation is subject to the restrictions contained in this Agreement. The Software contains various software programs with different license rights. Novell grants You the non-exclusive, non-transferable right to: a) internally use the Early Access Release Materials and Internal Tools in support of Your efforts to develop Derivative Software hereunder (but You may not include any portion of Early Access Release Materials or Internal Tools in Derivative Software); b) use, modify, and compile source code Software for the purpose of creating Developer Products, if the source code Software is identified as licensed for use in creating Developer Products; and, c) reproduce and distribute Derivative Software as part of a Developer Product.

   Sample Source Code. Sample source code that is made available as part of the Software may include a license grant that is broader then the license granted above in 3. If so, Your license to use the sample source code is as described in the license language included with the sample source code.

   Open Source Software. Your license to use software that is provided subject to a separate open source license is described in and subject to the license agreement included with the software.

   Third Party Products. As a service to You, certain third party software products may be made available to You from Novell. Your license to use such products is as described in and subject to the license agreement provided by the third party.

4. RESTRICTED SOFTWARE. Notwithstanding anything to the contrary in this Agreement, portions of the Software and/or Documentation may be subject to restrictions set forth in terms that accompany those portions. You agree to abide by such restrictions. If such restrictions are unacceptable to You, You may not use the Software.

5. RESERVATION OF RIGHTS. Novell reserves all rights not expressly granted to You. Without limiting the generality of the foregoing You: a) acknowledge that the source code of the binary code Software represents and embodies trade secrets of Novell or its licensors (except for source code made publicly available by the licensor); b) agree not to disassemble, decompile, or otherwise reverse engineer the binary code Software to discover the source code and/or trade secrets embodied in the source code; c) acknowledge that Novell has not authorized You to rent, lease, and/or time share the Software; and, d) while certain test tools and test suites may be provided, YOU AGREE THAT ONLY NOVELL CAN ISSUE AND PUBLISH TEST BULLETINS OR AUTHORIZE USE OF THE "YES" OR OTHER NOVELL LOGOS.

6. EARLY ACCESS MATERIALS. Novell does not represent or warrant that it will make the Early Access Materials generally available to the public or that any target dates will be met. Novell may change or cancel its plans at any time. You acknowledge that any Early Access Release product is of pre-release quality, has not been fully tested, and may contain errors; You assume the entire risk arising out of the use of the Early Access Release Software and any information provided with the Early Access Release Software.

7. SUPPORT. Novell shall have no obligation to provide support to You or to users of Developer Product(s).

8. TERM AND TERMINATION. This License will become effective on the date you acquire the Software and will remain in force until terminated. You may terminate this License at any time by destroying the Documentation and the Software together with all copies and adaptations. This License shall also automatically terminate if you breach any of the terms or conditions. You agree to destroy the original and all adaptations or copies of the Software and Documentation, or to return them to Novell upon termination of this License. Your right to use any Early Access Release Software will terminate upon the earlier of (i) first commercial shipment by Novell of the Early Access Release product, (ii) other termination of this Agreement, or (iii) time-based or other disabling of the Early Access Release product. Upon termination of this Agreement, end users of the Developer Product may continue to use the Developer Product under the terms of their license from You. You will have the right to maintain one copy of each version of the source code Software and/or the Developer Product but only for the purpose and to the extent reasonably necessary for you to provide support and maintenance to end users.

9. DEVELOPER INDEMNIFICATION. You agree to indemnify, defend and hold Novell harmless from all damages, liabilities and expenses incurred by Novell as a result of any claim, or judgment against Novell by any third party arising out of, or connected in any manner with, distribution or use of software created by You through the use of Software licensed to You under this Agreement or arising out of breach of this Agreement. If Novell receives notice of such a claim, Novell will promptly notify You in writing and allow You sole control of the defense of any such claim or action and all negotiations for its settlement and compromise, provided You give adequate assurances that You will diligently pursue resolution of the claim.

10.GOVERNING LAW. Except as otherwise restricted by law, this License shall be governed by, and interpreted in accordance with, the laws of the State of Utah of the United States of America, without regard to Utah law governing conflicts of law. This Agreement shall be treated as though it were executed in Utah County, Utah.  Any action relating to this License agreement shall be brought in a Utah court of competent jurisdiction.

11.ENTIRE AGREEMENT. This Agreement sets forth the entire understanding and License between you and Novell and may be amended only in a writing signed by both parties. No vendor, distributor, dealer, retailer, sales person or other person is authorized to modify this license or to make any warranty, representation or promise which is different than, or in addition to, the representations or promises of this license. This Agreement is not assignable by you in whole or in part without Novell�s prior written approval.

12.SEVERABILITY / WAIVER. If a provision is invalid or unenforceable, the remaining provisions will remain in effect and the parties will amend the Agreement to reflect the original agreement to the maximum extent possible. No waiver of any contractual right will be effective unless in writing by an authorized representative of the waiving party. No waiver of a right arising from any breach or failure to perform will be deemed a waiver of any future right.

13.DISCLAIMER. EXCEPT AS OTHERWISE RESTRICTED BY LAW, THE SOFTWARE AND ANY ASSOCIATED SERVICES ARE PROVIDED "AS IS." NOVELL MAKES NO  WARRANTY, REPRESENTATION OR PROMISE. NOVELL DISCLAIMS AND EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. NOVELL DOES NOT WARRANT THAT THE SOFTWARE WILL SATISFY YOUR REQUIREMENTS OR THAT THE SOFTWARE IS WITHOUT DEFECT OR ERROR OR THAT ITS OPERATION WILL BE UNINTERRUPTED. Some states do not allow some limitations on implied warranties, so the above limitations may not fully apply to you. This warranty gives you specific legal rights which vary from state to state.

14.LIMITATION OF LIABILITY. NEITHER NOVELL NOR ANY OF ITS LICENSORS, EMPLOYEES, OR AGENTS SHALL IN ANY CASE BE LIABLE FOR ANY SPECIAL, INCIDENTAL, CONSEQUENTIAL (INCLUDING LOST PROFITS OR REVENUE, LOSS OF USE OF SOFTWARE, LOSS OF DATA, COSTS OF RE-CREATING LOST DATA, OR THE COST OF ANY SUBSTITUTE EQUIPMENT OR PROGRAM), INDIRECT OR PUNITIVE DAMAGES, EVEN IF ADVISED OF THE POSSIBILITY OF THOSE DAMAGES. EXCEPT AS OTHERWISE RESTRICTED BY LAW, NOVELL'S AGGREGATE LIABILITY ARISING FROM OR RELATING TO YOUR USE OF THE SOFTWARE  OR ANY ASSOCIATED SERVICES IS LIMITED TO THE GREATER OF $100 OR THE TOTAL OF PAYMENTS MADE FOR SUCH SERVICES. Some states do not allow the complete exclusion or limitation of incidental or consequential damages, so the above limitation or exclusion may not fully apply to you.

15.EXPORT. You may not export, re-export, or use the Software in violation of any applicable laws or regulations including, without limitation, U.S. export regulations or the laws of the country in which you reside.  U.S. GOVERNMENT RESTRICTED RIGHTS. Use, duplication, or disclosure by the United States Government is subject to restrictions as set forth in FAR s 52.227-14 (June 1987) Alternate III(g)(3) (June 1987), FAR s 52.227-19 (June 1987), or DFARS s 52.227-7013 (c)(1)(ii) (June 1988), as applicable. Contractor/Manufacturer is Novell, Inc., 1800 S.  Novell Place, Provo, Utah 84606. OTHER. Those terms which by their nature extend beyond termination of this Agreement shall survive and remain in effect until all obligations are satisfied. The application of the United Nations Convention of Contracts for the International Sale of Goods is expressly excluded.

Copyright (c) 1994 - 2008 Novell, Inc.  All rights reserved.

March 13, 2008
//+==========================================================================+
//| Source module name: psmpackc.c
//+==========================================================================+
//|$Author: dtaylor $              $Locker:  $
//|$Revision: 1.4 $            $Name:  $ $State: Exp $
//|$Date: 2008/03/13 23:41:39 $
//+===========================================================================
*/
   /*
   // Each buffer begins with a XferDataBuf structure.
   // The XferDataBuf contains a pointer to pointer for the calling request
   //   function to find the reply buffer.
   // Compute the offset of the extended value area of the packed buffer.
   */

/* Standard Library Header Includes */
   #include <string.h>

/* Local Header Includes */
   #include <aspack.h>
   #include <cimalloc.h>
   #include <nwdpxfer.h>

   #include "psmpackc.h"

/* Local Manifest Constant Definitions */

   #define AS_ALIGNMENT                    4

/* Local Macro Definitions */

   #define ASAlignMac(val)                   \
      (((val) + (AS_ALIGNMENT - 1)) &        \
       (~(nuint32)0 - (AS_ALIGNMENT - 1)))

/* Type Definitions */

/* Structure Definitions */

/* Local Function Prototypes */
   int PsmPackDocDescLen(
      pNWDPDocumentDescription   valuePtr,
      pnuint                     valueLenPtr);

   int PsmPackFilterLen(
      pNWDPFilter          valuePtr,
      pnuint               valueLenPtr);

   int PsmPackDocDesc(
      pNWDPDocumentDescription   srcDescPtr,
      pnuint8                   *extendedValuePtr);

   int PsmPackFilter(
      pPackFilter          newFilterPtr,
      pNWDPFilter          srcFilterPtr,
      ppnuint8             extendedValuePtr,
      pnuint8              base);

   // int PsmUnpackAttribute(
   //    pNWDPAttribute       srcAttrPtr,
   //    pnuint8              base);

/* Modularly Global Variables */

/*
=============================================================================
// Function Name: PsmPackBind
=============================================================================
//
// Description: Pack a Bind request.
//
// =============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
// =============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackBind(
   pNWDPBindPAArgument  srcValuePtr,
   int                 *packedSizePtr)
{
   nuint32              valueLen;
   pPackBindPAArgument  newValuePtr;
   pnuint8              tmpValuePtr;
   pnuint8              extendedValuePtr;

   valueLen = sizeof(PackBindPAArgument) + XFER_DATA_OFFSET;

   valueLen += ASAlignMac(srcValuePtr->printerName.itemCount);
   valueLen += ASAlignMac(srcValuePtr->loginName.itemCount);
   valueLen += ASAlignMac(srcValuePtr->userName.itemCount);

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      return NULL;

   newValuePtr = (pPackBindPAArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackBindPAArgument);

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->printerName,
                          (pNWDPOctetString)&srcValuePtr->printerName,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackBindError;
   }

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->loginName,
                          (pNWDPOctetString)&srcValuePtr->loginName,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackBindError;
   }

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->userName,
                          (pNWDPOctetString)&srcValuePtr->userName,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackBindError;
   }

   newValuePtr->clientAddress = srcValuePtr->clientAddress;
   newValuePtr->localBindFlag = srcValuePtr->localBindFlag;

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackBindError:
   CiFreeMac(tmpValuePtr);
   return NULL;
}

/*
//+==========================================================================+
// Function Name: PsmPackAcctgBindPsm
//+==========================================================================+
//
// Description: Pack a Accounting Bind Psm request
//
//+==========================================================================+
// Returns: N_SUCCESS
//          N_FAILURE
//
//+==========================================================================+
// Assumptions: None.
//
//+==========================================================================+
*/
pnuint8 PsmPackAcctgBindPsm(
   pAcctgBindPsmArg     srcValuePtr,
   int                 *packedSizePtr)
{
   uint                 valueLen;
   pAcctgBindPsmArg     newValuePtr;
   pnuint8              tmpValuePtr;

   valueLen = sizeof(AcctgBindPsmArg) + XFER_DATA_OFFSET;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackAcctgBindPsmEnd;

   newValuePtr = (pAcctgBindPsmArg)(tmpValuePtr + XFER_DATA_OFFSET);
   *newValuePtr = *srcValuePtr;

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackAcctgBindPsmEnd:
   return NULL;
}

/*
//+==========================================================================+
// Function Name: PsmPackAcctgUnbindPsm
//+==========================================================================+
//
// Description: Pack a Accounting Unbind Psm request
//
//+==========================================================================+
// Returns: N_SUCCESS
//          N_FAILURE
//
//+==========================================================================+
// Assumptions: None.
//
//+==========================================================================+
*/
pnuint8 PsmPackAcctgUnbindPsm(
   pAcctgUnbindPsmArg   srcValuePtr,
   int                 *packedSizePtr)
{
   uint                 valueLen;
   pAcctgUnbindPsmArg   newValuePtr;
   pnuint8              tmpValuePtr;

   valueLen = sizeof(AcctgUnbindPsmArg) + XFER_DATA_OFFSET;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackAcctgUnbindPsmEnd;

   newValuePtr = (pAcctgUnbindPsmArg)(tmpValuePtr + XFER_DATA_OFFSET);
   *newValuePtr = *srcValuePtr;

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackAcctgUnbindPsmEnd:
   return NULL;
}

/*
//+==========================================================================+
// Function Name: PsmPackAcctgBindPaRes
//+==========================================================================+
//
// Description: Pack the result for a Accounting Unbind PA request
//
//+==========================================================================+
// Returns: N_SUCCESS
//          N_FAILURE
//
//+==========================================================================+
// Assumptions: None.
//
//+==========================================================================+
*/
pnuint8 PsmPackAcctgBindPaRes(
   pAcctgBindPAReply    srcValuePtr,
   int                 *packedSizePtr)
{
   uint                 valueLen;
   pAcctgBindPAReply    newValuePtr;
   pnuint8              tmpValuePtr;

   valueLen = sizeof(AcctgBindPAReply) + XFER_DATA_OFFSET;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackAcctgBindPaResEnd;

   newValuePtr = (pAcctgBindPAReply)(tmpValuePtr + XFER_DATA_OFFSET);
   *newValuePtr = *srcValuePtr;

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackAcctgBindPaResEnd:
   return NULL;
}

/*
//+==========================================================================+
// Function Name: PsmPackAcctgUnbindPaRes
//+==========================================================================+
//
// Description: Pack the result for a Accounting Unbind PA request
//
//+==========================================================================+
// Returns: N_SUCCESS
//          N_FAILURE
//
//+==========================================================================+
// Assumptions: None.
//
//+==========================================================================+
*/
pnuint8 PsmPackAcctgUnbindPaRes(
   pAcctgBindPAReply    srcValuePtr,
   int                 *packedSizePtr)
{
   uint                 valueLen;
   pAcctgBindPAReply    newValuePtr;
   pnuint8              tmpValuePtr;

   valueLen = sizeof(AcctgBindPAReply) + XFER_DATA_OFFSET;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackAcctgUnbindPaResEnd;

   newValuePtr = (pAcctgBindPAReply)(tmpValuePtr + XFER_DATA_OFFSET);
   *newValuePtr = *srcValuePtr;

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackAcctgUnbindPaResEnd:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmPackSimpleArg
=============================================================================
//
// Description: Pack a Simple request argument.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackSimpleArg(
   pNWDPSimpleArgument  srcValuePtr,
   int                 *packedSizePtr)
{
   nuint32              valueLen;
   pPackSimpleArgument  newValuePtr;
   pnuint8              tmpValuePtr;

   valueLen = sizeof(NWDPSimpleArgument) + XFER_DATA_OFFSET;
   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      return NULL;

   newValuePtr = (pPackSimpleArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;

   *packedSizePtr = valueLen;
   return tmpValuePtr;
}

/*
=============================================================================
// Function Name: PsmPackPrint
=============================================================================
//
// Description: Pack a Print request
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackPrint(
   pNWDPPrintArgument   srcValuePtr,
   int                 *packedSizePtr)
{
   nuint                valueLen;
   pPackPrintArgument   newValuePtr;
   pnuint8              tmpValuePtr;
   pnuint8              extendedValuePtr;

   valueLen = sizeof(PackPrintArgument) + XFER_DATA_OFFSET;

   if (srcValuePtr->printOperation.designator == NWDP_PRINT_ARG_CREATE_JOB)
   {
      valueLen += ASAlignMac(srcValuePtr->printOperation.u.
                                 createJob.printerName.itemCount);
      if (ASAttrSeqLen((pAttrSetStruct)&srcValuePtr->printOperation.u.
                              createJob.jobAttributes,
                        &valueLen))
      {
         goto PsmPackPrintEnd;
      }
      if (PsmPackDocDescLen(srcValuePtr->printOperation.u.createJob.
                              firstDocumentOptionPtr,
                            &valueLen))
      {
         goto PsmPackPrintEnd;
      }
   }
   else if (srcValuePtr->printOperation.designator == NWDP_PRINT_ARG_ADD_DOCUMENT)
   {
      valueLen += ASAlignMac(srcValuePtr->printOperation.u.addDocument.
                                 existingJob.printerName.itemCount);
      if (PsmPackDocDescLen(srcValuePtr->printOperation.u.addDocument.
                                 newDocumentPtr,
                            &valueLen))
      {
         goto PsmPackPrintEnd;
      }
   }
   else if (srcValuePtr->printOperation.designator == NWDP_PRINT_ARG_CLOSE_JOB)
   {
      valueLen +=
         ASAlignMac(srcValuePtr->printOperation.u.closeJob.existingJob.
                        printerName.itemCount);
   }
   else
   {
      /* Should never get here */
      CiSetLastErrorMac(NDPS_E_UNDEFINED_TYPE);
      goto PsmPackPrintEnd;
   }

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackPrintEnd;

   newValuePtr = (pPackPrintArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackPrintArgument);

   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;
   newValuePtr->printOperation.designator =
      srcValuePtr->printOperation.designator;

   if (srcValuePtr->printOperation.designator == NWDP_PRINT_ARG_CREATE_JOB)
   {
      if (_ASPackOctetString((pPackOctetString)&newValuePtr->printOperation.u.
                                 createJob.printerName,
                             (pNWDPOctetString)&srcValuePtr->printOperation.u.
                                 createJob.printerName,
                             &extendedValuePtr,
                             (pnuint8)newValuePtr))
      {
         goto PsmPackPrintError;
      }

      newValuePtr->printOperation.u.createJob.jobSubmissionComplete =
         srcValuePtr->printOperation.u.createJob.jobSubmissionComplete;

      if (srcValuePtr->printOperation.u.createJob.jobAttributes.itemCount)
      {
         newValuePtr->printOperation.u.createJob.jobAttributes.itemCount =
            srcValuePtr->printOperation.u.createJob.jobAttributes.itemCount;
         newValuePtr->printOperation.u.createJob.jobAttributes.itemOffset =
            (extendedValuePtr - (pnuint8)newValuePtr);
         if (ASPackAttrSeq(&newValuePtr->printOperation.u.createJob.jobAttributes,
                           &srcValuePtr->printOperation.u.createJob.jobAttributes,
                           &extendedValuePtr))
         {
            goto PsmPackPrintError;
         }
      }

      if (srcValuePtr->printOperation.u.createJob.firstDocumentOptionPtr != NULL)
      {
         newValuePtr->printOperation.u.createJob.firstDocumentOptionOffset =
            (extendedValuePtr - (pnuint8)newValuePtr);
         if (PsmPackDocDesc(srcValuePtr->printOperation.u.createJob.
                              firstDocumentOptionPtr,
                            &extendedValuePtr))
         {
            goto PsmPackPrintError;
         }
      }

      *packedSizePtr = valueLen;
      return tmpValuePtr;
   }

   if (srcValuePtr->printOperation.designator == NWDP_PRINT_ARG_ADD_DOCUMENT)
   {
      if (_ASPackOctetString((pPackOctetString)&newValuePtr->printOperation.u.
                                 addDocument.existingJob.printerName,
                             (pNWDPOctetString)&srcValuePtr->printOperation.u.
                                 addDocument.existingJob.printerName,
                             &extendedValuePtr,
                             (pnuint8)newValuePtr))
      {
         goto PsmPackPrintError;
      }
      newValuePtr->printOperation.u.addDocument.existingJob.localIdentifier =
         newValuePtr->printOperation.u.addDocument.existingJob.localIdentifier;
      newValuePtr->printOperation.u.createJob.jobSubmissionComplete =
         srcValuePtr->printOperation.u.createJob.jobSubmissionComplete;

      if (srcValuePtr->printOperation.u.addDocument.newDocumentPtr != NULL)
      {
         newValuePtr->printOperation.u.addDocument.newDocumentOffset =
            (extendedValuePtr - (pnuint8)newValuePtr);
         if (PsmPackDocDesc(srcValuePtr->printOperation.u.addDocument.
                              newDocumentPtr,
                            &extendedValuePtr))
         {
            goto PsmPackPrintError;
         }
      }

      *packedSizePtr = valueLen;
      return tmpValuePtr;
   }

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->printOperation.u.
                              closeJob.existingJob.printerName,
                          (pNWDPOctetString)&srcValuePtr->printOperation.u.
                              closeJob.existingJob.printerName,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackPrintError;
   }

   newValuePtr->printOperation.u.closeJob.existingJob.localIdentifier =
      srcValuePtr->printOperation.u.closeJob.existingJob.localIdentifier;

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackPrintError:
   CiFreeMac(tmpValuePtr);
PsmPackPrintEnd:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmPackListAttrs
=============================================================================
//
// Description: Pack a ListAttrs request
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackListAttrs(
   pNWDPListObjectAttrsArgument  srcValuePtr,
   int                          *packedSizePtr)
{
   nuint                         index1;
   nuint                         valueLen;
   pPackListObjectAttrsArgument  newValuePtr;
   pnuint8                       tmpValuePtr;
   pnuint8                       extendedValuePtr;
   pPackSelector                 selectorPtr;
   pPackObjectIdentifierSet      attrSetPtr;
   pPackObjectIdentification     newItemPtr;
   pNWDPObjectIdentification     srcItemPtr;
   pNWDPFilter                   srcFilterPtr;
   pPackFilter                   newFilterPtr;

   valueLen = sizeof(PackListObjectAttrsArgument) + XFER_DATA_OFFSET;
   if (srcValuePtr->listAttrsOperation.designator == NWDP_LIST_ATTRIBUTES_ARG_CONT)
   {
      valueLen += ASAlignMac(srcValuePtr->listAttrsOperation.u.continuation.
                                 context.itemCount);
   }
   else
   {
      valueLen += ASAlignMac(srcValuePtr->listAttrsOperation.u.specification.
                        objectClass.oidStructSize);
      if (srcValuePtr->listAttrsOperation.u.specification.selectorOptionPtr != NULL)
      {
         valueLen += sizeof(PackSelector);
         index1 = srcValuePtr->listAttrsOperation.u.specification.
                     selectorOptionPtr->objectIdentificationSeqOption.itemCount;
         valueLen += ASAlignMac(index1 * sizeof(PackObjectIdentification));
         srcItemPtr = srcValuePtr->listAttrsOperation.u.specification.
                        selectorOptionPtr->objectIdentificationSeqOption.itemPtr;
         for (;
              index1;
              index1--, srcItemPtr++)
         {
            if (_ASObjectIdentificationLength(srcItemPtr, &valueLen))
               goto PsmPackListAttrsEnd;
         }
         if (srcValuePtr->listAttrsOperation.u.specification.
               selectorOptionPtr->objectFilterOptionPtr != NULL)
         {
            if (PsmPackFilterLen(srcValuePtr->listAttrsOperation.u.
                                    specification.selectorOptionPtr->
                                    objectFilterOptionPtr,
                                 &valueLen))
            {
               goto PsmPackListAttrsEnd;
            }
         }
      }

      if (srcValuePtr->listAttrsOperation.u.specification.
            requestedAttrsOptionPtr != NULL)
      {
         valueLen += sizeof(NWDPObjectIdentifierSet);
         if (_ASObjectIdentifierSetLength(srcValuePtr->listAttrsOperation.u.
                                             specification.
                                             requestedAttrsOptionPtr,
                                          &valueLen))
         {
            goto PsmPackListAttrsEnd;
         }
      }
   }

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackListAttrsEnd;

   newValuePtr = (pPackListObjectAttrsArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackListObjectAttrsArgument);

   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;
   newValuePtr->listAttrsOperation.designator =
      srcValuePtr->listAttrsOperation.designator;

   if (srcValuePtr->listAttrsOperation.designator ==
         NWDP_LIST_ATTRIBUTES_ARG_CONT)
   {
      if (_ASPackOctetString(&newValuePtr->listAttrsOperation.u.continuation.
                                 context,
                             &srcValuePtr->listAttrsOperation.u.continuation.
                                 context,
                             &extendedValuePtr,
                             (pnuint8)newValuePtr))
      {
         goto PsmPackListAttrsError;
      }

      newValuePtr->listAttrsOperation.u.continuation.abort =
         srcValuePtr->listAttrsOperation.u.continuation.abort;
   }
   else
   {
      if (_ASPackOctetString((pPackOctetString)&newValuePtr->listAttrsOperation.
                                 u.specification.objectClass,
                             (pNWDPOctetString)&srcValuePtr->listAttrsOperation.
                                 u.specification.objectClass,
                             &extendedValuePtr,
                             (pnuint8)newValuePtr))
      {
         goto PsmPackListAttrsError;
      }

      newValuePtr->listAttrsOperation.u.specification.scope =
         srcValuePtr->listAttrsOperation.u.specification.scope;

      if (srcValuePtr->listAttrsOperation.u.specification.selectorOptionPtr
            != NULL)
      {
         selectorPtr = (pPackSelector)extendedValuePtr;
         extendedValuePtr += sizeof(PackSelector);
         newValuePtr->listAttrsOperation.u.specification.selectorOptionOffset =
            ((pnuint8)selectorPtr - (pnuint8)newValuePtr);

         /*
         // Now add the fields as indicated
         //          typedef struct {
         //Phase 1      NWDPObjectIdentificationSeq objectIdentificationSeqOption;
         //Phase 2      pNWDPFilter objectFilterOptionPtr;
         //Phase 3      nuint32 timeLimitOption;
         //Phase 4      nuint32 countLimitOption;
         //          } NWDPSelector, *pNWDPSelector;
         */

         /*
         // Phase 1 - NWDPObjectIdentificationSeq objectIdentificationSeqOption;
         */
         index1 = srcValuePtr->listAttrsOperation.u.specification.
                     selectorOptionPtr->objectIdentificationSeqOption.itemCount;
         if (index1 != 0)
         {
            srcItemPtr = srcValuePtr->listAttrsOperation.u.specification.
                           selectorOptionPtr->objectIdentificationSeqOption.itemPtr;
            selectorPtr->objectIdentificationSeqOption.itemCount = index1;
            selectorPtr->objectIdentificationSeqOption.itemOffset =
               (extendedValuePtr - (pnuint8)newValuePtr);
            newItemPtr = (pPackObjectIdentification)extendedValuePtr;
            extendedValuePtr += index1 * sizeof(PackObjectIdentification);

            for (;
                 index1;
                 index1--, srcItemPtr++, newItemPtr++)
            {
               if (_ASPackObjectIdentification(newItemPtr,
                                               srcItemPtr,
                                               &extendedValuePtr,
                                               (pnuint8)newValuePtr))
               {
                  goto PsmPackListAttrsError;
               }
            }
         }

         /*
         // Phase 2 - pNWDPFilter objectFilterOptionPtr;
         */
         srcFilterPtr = srcValuePtr->listAttrsOperation.u.specification.
                           selectorOptionPtr->objectFilterOptionPtr;
         if (srcFilterPtr != NULL)
         {
            newFilterPtr = (pPackFilter)extendedValuePtr;
            selectorPtr->objectFilterOptionOffset =
               ((pnuint8)selectorPtr - (pnuint8)newValuePtr);
            extendedValuePtr += sizeof(PackFilter);
            if (PsmPackFilter(newFilterPtr,
                              srcFilterPtr,
                              &extendedValuePtr,
                              (pnuint8)newValuePtr))
            {
               goto PsmPackListAttrsError;
            }
         }
         /*
         // Phase 3 - nuint32 timeLimitOption;
         */
         selectorPtr->timeLimitOption =
            srcValuePtr->listAttrsOperation.u.specification.selectorOptionPtr->
               timeLimitOption;

         /*
         // Phase 4 - nuint32 countLimitOption;
         */
         selectorPtr->countLimitOption =
            srcValuePtr->listAttrsOperation.u.specification.selectorOptionPtr->
               countLimitOption;

      } /* end if(selectorPtr) */

      if (srcValuePtr->listAttrsOperation.u.specification.
            requestedAttrsOptionPtr != NULL)
      {
         newValuePtr->listAttrsOperation.u.specification.
               requestedAttrsOptionOffset =
            (extendedValuePtr - (pnuint8)newValuePtr);
         attrSetPtr = (pPackObjectIdentifierSet)extendedValuePtr;
         extendedValuePtr += sizeof(PackObjectIdentifierSet);

         if (srcValuePtr->listAttrsOperation.u.specification.
               requestedAttrsOptionPtr->itemCount != 0)
         {
            if (_ASPackIdentifierSet(attrSetPtr,
                                     srcValuePtr->listAttrsOperation.u.
                                       specification.requestedAttrsOptionPtr,
                                     &extendedValuePtr,
                                     (pnuint8)newValuePtr))
            {
               goto PsmPackListAttrsError;
            }
         }
      }

      newValuePtr->listAttrsOperation.u.specification.listOperator =
         srcValuePtr->listAttrsOperation.u.specification.listOperator;
   }

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackListAttrsError:
   CiFreeMac(tmpValuePtr);
PsmPackListAttrsEnd:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmPackCreate
=============================================================================
//
// Description: Pack a Create request
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackCreate(
   pNWDPCreateArgument        srcValuePtr,
   int                       *packedSizePtr)
{
   nuint                      valueLen;
   pPackCreateArgument        newValuePtr;
   pPackObjectIdentification  objectIdentificationPtr;
   pnuint8                    tmpValuePtr;
   pnuint8                    extendedValuePtr;

   valueLen = sizeof(PackCreateArgument) + XFER_DATA_OFFSET;
   valueLen += ASAlignMac(srcValuePtr->objectClass.oidStructSize);
   if (_ASObjectIdentificationLength(&srcValuePtr->objectId, &valueLen))
      goto PsmPackCreateEnd;
   if (srcValuePtr->referenceObjectOptionPtr != NULL)
   {
      valueLen += sizeof(PackObjectIdentification);
      if (_ASObjectIdentificationLength(srcValuePtr->referenceObjectOptionPtr,
                                        &valueLen))
      {
         goto PsmPackCreateEnd;
      }
   }
   if (ASAttrSeqLen((pAttrSetStruct)&srcValuePtr->objectAttrSetOption,
                     &valueLen))
   {
      goto PsmPackCreateEnd;
   }

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackCreateEnd;

   newValuePtr = (pPackCreateArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackCreateArgument);

   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->objectClass,
                          (pNWDPOctetString)&srcValuePtr->objectClass,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackCreateError;
   }

   if (_ASPackObjectIdentification(&newValuePtr->objectId,
                                   &srcValuePtr->objectId,
                                   &extendedValuePtr,
                                   (pnuint8)newValuePtr))
   {
      goto PsmPackCreateError;
   }

   newValuePtr->force = srcValuePtr->force;

   if (srcValuePtr->referenceObjectOptionPtr != NULL)
   {
      objectIdentificationPtr = (pPackObjectIdentification)extendedValuePtr;
      extendedValuePtr += sizeof(PackObjectIdentification);
      if (_ASPackObjectIdentification(objectIdentificationPtr,
                                      srcValuePtr->referenceObjectOptionPtr,
                                      &extendedValuePtr,
                                      (pnuint8)newValuePtr))
      {
         goto PsmPackCreateError;
      }
      newValuePtr->referenceObjectOptionOffset =
         ((pnuint8)objectIdentificationPtr -(pnuint8)newValuePtr);
   }

   if (srcValuePtr->objectAttrSetOption.itemCount)
   {
      newValuePtr->objectAttrSetOption.itemCount =
         srcValuePtr->objectAttrSetOption.itemCount;
      newValuePtr->objectAttrSetOption.itemOffset =
         (extendedValuePtr - (pnuint8)newValuePtr);
      if (ASPackAttrSeq(&newValuePtr->objectAttrSetOption,
                        &srcValuePtr->objectAttrSetOption,
                        &extendedValuePtr))
      {
         goto PsmPackCreateError;
      }
   }

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackCreateError:
   CiFreeMac(tmpValuePtr);
PsmPackCreateEnd:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmPackDelete
=============================================================================
//
// Description: Pack a Delete request
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackDelete(
   pNWDPDeleteArgument  srcValuePtr,
   int                 *packedSizePtr)
{
   nuint                valueLen;
   pPackDeleteArgument  newValuePtr;
   pnuint8              tmpValuePtr;
   pnuint8              extendedValuePtr;

   valueLen = sizeof(PackDeleteArgument) + XFER_DATA_OFFSET;
   valueLen += ASAlignMac(srcValuePtr->objectClass.oidStructSize);
   if (_ASObjectIdentificationLength(&srcValuePtr->objectId, &valueLen))
      goto PsmPackDeleteEnd;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackDeleteEnd;

   newValuePtr = (pPackDeleteArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackDeleteArgument);

   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->objectClass,
                          (pNWDPOctetString)&srcValuePtr->objectClass,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackDeleteError;
   }

   if (_ASPackObjectIdentification(&newValuePtr->objectId,
                                   &srcValuePtr->objectId,
                                   &extendedValuePtr,
                                   (pnuint8)newValuePtr))
   {
      goto PsmPackDeleteError;
   }

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackDeleteError:
   CiFreeMac(tmpValuePtr);
PsmPackDeleteEnd:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmPackSet
=============================================================================
//
// Description: Pack a Set request
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackSet(
   pNWDPSetArgument     srcValuePtr,
   int                 *packedSizePtr)
{
   nuint                valueLen;
   pPackSetArgument     newValuePtr;
   pnuint8              tmpValuePtr;
   pnuint8              extendedValuePtr;

   valueLen = sizeof(PackSetArgument) + XFER_DATA_OFFSET;
   valueLen += ASAlignMac(srcValuePtr->objectClass.oidStructSize);
   if (_ASObjectIdentificationLength(&srcValuePtr->objectId, &valueLen))
      goto PsmPackSetEnd;
   if (ASAttrSeqLen((pAttrSetStruct)&srcValuePtr->attrModificationSet,
                     &valueLen))
   {
      goto PsmPackSetEnd;
   }

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackSetEnd;

   newValuePtr = (pPackSetArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackSetArgument);

   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->objectClass,
                          (pNWDPOctetString)&srcValuePtr->objectClass,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackSetError;
   }

   if (_ASPackObjectIdentification(&newValuePtr->objectId,
                                   &srcValuePtr->objectId,
                                   &extendedValuePtr,
                                   (pnuint8)newValuePtr))
   {
      goto PsmPackSetError;
   }

   if (srcValuePtr->attrModificationSet.itemCount)
   {
      newValuePtr->attrModificationSet.itemCount =
         srcValuePtr->attrModificationSet.itemCount;
      newValuePtr->attrModificationSet.itemOffset =
         (extendedValuePtr - (pnuint8)newValuePtr);
      if (ASPackAttrSeq(&newValuePtr->attrModificationSet,
                        &srcValuePtr->attrModificationSet,
                        &extendedValuePtr))
      {
         goto PsmPackSetError;
      }
   }

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackSetError:
   CiFreeMac(tmpValuePtr);
PsmPackSetEnd:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmPackTransferData
=============================================================================
//
// Description: Pack a TransferData request
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackTransferData(
   pNWDPTransferDataArgument  srcValuePtr,
   int                       *packedSizePtr)
{
   nuint                      valueLen;
   pPackTransferDataArgument  newValuePtr;
   pnuint8                    tmpValuePtr;
   pnuint8                    extendedValuePtr;

   valueLen = sizeof(PackTransferDataArgument) + XFER_DATA_OFFSET;
   valueLen += ASAlignMac(srcValuePtr->data.itemCount);

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackTransferDataEnd;

   newValuePtr = (pPackTransferDataArgument)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackTransferDataArgument);

   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;
   newValuePtr->status = srcValuePtr->status;

   if (_ASPackOctetString((pPackOctetString)&newValuePtr->data,
                          (pNWDPOctetString)&srcValuePtr->data,
                          &extendedValuePtr,
                          (pnuint8)newValuePtr))
   {
      goto PsmPackTransferDataError;
   }

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackTransferDataError:
   CiFreeMac(tmpValuePtr);
PsmPackTransferDataEnd:
   return NULL;
}

/*
//+==========================================================================+
// Function Name: PsmPackAccountingInfo
//+==========================================================================+
//
// Description: Pack a Accounting Job Action request
//
//+==========================================================================+
// Returns: N_SUCCESS
//          N_FAILURE
//
//+==========================================================================+
// Assumptions: None.
//
//+==========================================================================+
*/
pnuint8 PsmPackAcctgJobAction(
   pAcctgJobActionArg   srcValuePtr,
   int                 *packedSizePtr)
{
   uint                 valueLen;
   pAcctgJobActionArg   newValuePtr;
   pnuint8              tmpValuePtr;

   valueLen = sizeof(AcctgJobActionArg) + XFER_DATA_OFFSET;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      return NULL;

   newValuePtr = (pAcctgJobActionArg)(tmpValuePtr + XFER_DATA_OFFSET);
   *newValuePtr = *srcValuePtr;

   *packedSizePtr = valueLen;
   return tmpValuePtr;
}

/*
=============================================================================
// Function Name: PsmPackSimpleRes
=============================================================================
//
// Description: Pack a Simple result.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackSimpleRes(
   pNWDPSimpleResult    srcValuePtr,
   int                 *packedSizePtr)
{
   nuint                valueLen;
   pPackSimpleResult    newValuePtr;
   pnuint8              tmpValuePtr;
   pnuint8              extendedValuePtr;

   valueLen = sizeof(PackSimpleResult) + XFER_DATA_OFFSET;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      goto PsmPackSimpleResEnd;

   newValuePtr = (pPackSimpleResult)(tmpValuePtr + XFER_DATA_OFFSET);
   extendedValuePtr = (pnuint8)newValuePtr + sizeof(PackSimpleResult);

   newValuePtr->errorCode = srcValuePtr->errorCode;

   *packedSizePtr = valueLen;
   return tmpValuePtr;

PsmPackSimpleResEnd:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmPackAccountingRes
=============================================================================
//
// Description: Pack a Accounting result.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmPackAcctgInfoRes(
   pAcctgInfoReply      srcValuePtr,
   int                 *packedSizePtr)
{
   nuint                valueLen;
   pAcctgInfoReply      newValuePtr;
   pnuint8              tmpValuePtr;

   valueLen = sizeof(AcctgInfoReply) + XFER_DATA_OFFSET;

   tmpValuePtr = CiCallocMac(1, valueLen);
   if (tmpValuePtr == NULL)
      return NULL;

   newValuePtr = (pAcctgInfoReply)(tmpValuePtr + XFER_DATA_OFFSET);
   *newValuePtr = *srcValuePtr;

   *packedSizePtr = valueLen;
   return tmpValuePtr;
}

/*
=============================================================================
// Function Name: PsmPackAttributeLen                                      º
=============================================================================
//
// Description: Get the length of memory referenced by a Attribute struct
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
int PsmPackAttributeLen(
   pNWDPAttribute       valuePtr,
   pnuint               valueLenPtr)
{
   nuint                index1;
   pNWDPAttributeValue  attrValuePtr;

   /* add the length for the attribute OID */
   *valueLenPtr += ASAlignMac(valuePtr->attributeId.oidStructSize);

   /* add the length of the extended value buffers */
   for (index1 = valuePtr->valueSet.itemCount,
                  attrValuePtr = valuePtr->valueSet.itemPtr;
        index1;
        index1--, attrValuePtr++)
   {
      if (ASPackValueLen(attrValuePtr, valueLenPtr))
         return (N_FAILURE);
   }

   return N_SUCCESS;
}

/*
=============================================================================
// Function Name: PsmPackFilterLen                                         º
=============================================================================
//
// Description: Get the length of memory referenced by a List Filter struct
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
int PsmPackFilterLen(
   pNWDPFilter          valuePtr,
   pnuint               valueLenPtr)
{
   nuint                index1;
   pNWDPFilter          filterItemPtr;
   pNWDPAttributeValue  attrValuePtr;

   *valueLenPtr += sizeof(PackFilter);
   switch(valuePtr->designator)
   {
      case NWDP_FILTER_ITEM:
         switch (valuePtr->u.filterItem.designator)
         {
            case NWDP_FILTER_EQUALITY:
            case NWDP_FILTER_GREATER_OR_EQUAL:
            case NWDP_FILTER_LESS_OR_EQUAL:
            case NWDP_FILTER_SUBSET_OF:
            case NWDP_FILTER_SUPERSET_OF:
            case NWDP_FILTER_NON_NULL_SET_INTERS:
               return (PsmPackAttributeLen(&valuePtr->u.filterItem.u.equality,
                                           valueLenPtr));

            case NWDP_FILTER_SUBSTRINGS:
               *valueLenPtr += ASAlignMac(valuePtr->u.filterItem.u.substrings.
                                             attributeId.oidStructSize);
               if (ASPackValueLen(&valuePtr->u.filterItem.u.substrings.
                                       initialValueOption,
                                   valueLenPtr))
               {
                  return N_FAILURE;
               }
               /* add the length of the extended value buffers */
               for (index1 = valuePtr->u.filterItem.u.substrings.
                                    anyValueSetOption.itemCount,
                                 attrValuePtr = valuePtr->u.filterItem.u.
                                          substrings.anyValueSetOption.itemPtr;
                    index1;
                    index1--, attrValuePtr++)
               {
                  if (ASPackValueLen(attrValuePtr, valueLenPtr))
                     return N_FAILURE;
               }
               return (ASPackValueLen(&valuePtr->u.filterItem.u.substrings.
                                          finalValueOption,
                                      valueLenPtr));

            case NWDP_FILTER_PRESENT:
               *valueLenPtr +=
                  ASAlignMac(valuePtr->u.filterItem.u.present.oidStructSize);
               return N_SUCCESS;

            default:
               /* Should never get here */
               CiSetLastErrorMac(NDPS_E_UNDEFINED_TYPE);
               return (N_FAILURE);
         }

      case NWDP_FILTER_AND:
      case NWDP_FILTER_OR:
         for (index1 = valuePtr->u.filterAnd.itemCount,
                  filterItemPtr = valuePtr->u.filterAnd.itemPtr;
              index1;
              index1--, filterItemPtr++)
         {
            if (PsmPackFilterLen(filterItemPtr, valueLenPtr))
               return N_FAILURE;
         }

      case NWDP_FILTER_NOT:
         return (PsmPackFilterLen(valuePtr->u.filterNotPtr, valueLenPtr));
      default:
         /* Should never get here */
         CiSetLastErrorMac(NDPS_E_UNDEFINED_TYPE);
         return (N_FAILURE);
   }
}

/*
=============================================================================
// Function Name: PsmPackAttribute
=============================================================================
//
// Description: Pack a Attribute struct
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
int PsmPackAttribute(
   pPackAttribute       newAttrPtr,
   pNWDPAttribute       srcAttrPtr,
   pnuint8             *extendedValuePtr,
   pnuint8              base)
{
   nuint                index1;
   pPackAttributeValue  newValuePtr;
   pNWDPAttributeValue  srcValuePtr;

   /* copy the attribute OID into the extended value area */
   index1 = srcAttrPtr->attributeId.oidStructSize;
   memcpy((nptr)*extendedValuePtr,
          (nptr)srcAttrPtr->attributeId.oidStructPtr,
          index1);

   newAttrPtr->attributeId.oidStructOffset = (*extendedValuePtr - base);

   newAttrPtr->attributeId.oidStructSize = index1;

   /* advance the pointer to the extended value area */
   extendedValuePtr += ASAlignMac(index1);

   /* pack each value item */
   index1 = srcAttrPtr->valueSet.itemCount;
   newValuePtr = (pPackAttributeValue)*extendedValuePtr;
   *extendedValuePtr += index1 * sizeof(PackAttributeValue);

   newAttrPtr->valueSet.itemCount = index1;
   newAttrPtr->valueSet.itemOffset = (*extendedValuePtr - base);
   srcValuePtr = srcAttrPtr->valueSet.itemPtr;
   newValuePtr = (pPackAttributeValue)*extendedValuePtr;

   if (index1 == 0 || srcValuePtr == NULL)
      return N_SUCCESS;

   newAttrPtr->valueSet.itemOffset = ((pnuint8)newValuePtr - base);

   *extendedValuePtr += index1 * sizeof(PackAttributeValue);

   for (;
        index1;
        index1--, srcValuePtr++, newValuePtr++)
   {
      /* copy the value */
      if (ASPackFillBufferValue(newValuePtr,
                                srcValuePtr,
                                extendedValuePtr,
                                base))
      {
         return (N_FAILURE);
      }
   }

   return N_SUCCESS;
}

/*
=============================================================================
// Function Name: PsmPackFilter
=============================================================================
//
// Description: Pack a List Filter
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: This function is reentrant.
//
=============================================================================
*/
int PsmPackFilter(
   pPackFilter          newFilterPtr,
   pNWDPFilter          srcFilterPtr,
   ppnuint8             extendedValuePtr,
   pnuint8              base)
{
   nuint                index1;
   pPackAttributeValue  newValuePtr;
   pNWDPAttributeValue  srcValuePtr;

   pPackFilter          newFilterItemPtr;
   pNWDPFilter          srcFilterItemPtr;

   newFilterPtr->designator = srcFilterPtr->designator;
   newValuePtr = NULL;

   switch(srcFilterPtr->designator)
   {
      case NWDP_FILTER_ITEM:
         switch (srcFilterPtr->u.filterItem.designator)
         {
            case NWDP_FILTER_EQUALITY:
            case NWDP_FILTER_GREATER_OR_EQUAL:
            case NWDP_FILTER_LESS_OR_EQUAL:
            case NWDP_FILTER_SUBSET_OF:
            case NWDP_FILTER_SUPERSET_OF:
            case NWDP_FILTER_NON_NULL_SET_INTERS:
               return (PsmPackAttribute(&newFilterPtr->u.filterItem.u.equality,
                                        &srcFilterPtr->u.filterItem.u.equality,
                                        extendedValuePtr,
                                        base));

            case NWDP_FILTER_SUBSTRINGS:
               if (_ASPackOctetString((pPackOctetString)&newFilterPtr->u.
                                          filterItem.u.substrings.attributeId,
                                      (pNWDPOctetString)&srcFilterPtr->u.
                                          filterItem.u.substrings.attributeId,
                                      extendedValuePtr,
                                      base))
               {
                  return N_FAILURE;
               }

               newFilterPtr->u.filterItem.u.substrings.matchCriteria =
                  srcFilterPtr->u.filterItem.u.substrings.matchCriteria;

               if (ASPackFillBufferValue(&newFilterPtr->u.filterItem.u.
                                             substrings.initialValueOption,
                                         &srcFilterPtr->u.filterItem.u.
                                             substrings.initialValueOption,
                                         extendedValuePtr,
                                         base))
               {
                  return N_FAILURE;
               }

               /* add the length of the extended value buffers */
               index1 = srcFilterPtr->u.filterItem.u.substrings.
                           anyValueSetOption.itemCount;
               srcValuePtr = srcFilterPtr->u.filterItem.u.substrings.
                                 anyValueSetOption.itemPtr;
               newValuePtr = (pPackAttributeValue)*extendedValuePtr;
               newFilterPtr->u.filterItem.u.substrings.anyValueSetOption.
                  itemOffset = ((pnuint8)newValuePtr - base);
               newFilterPtr->u.filterItem.u.substrings.anyValueSetOption.
                  itemCount = index1;

               *extendedValuePtr += index1 * sizeof(PackAttributeValue);

               for (;
                    index1;
                    index1--, srcValuePtr++, newValuePtr++)
               {
                  if (ASPackFillBufferValue(newValuePtr,
                                            srcValuePtr,
                                            extendedValuePtr,
                                            base))
                  {
                     return N_FAILURE;
                  }
               }

               return (ASPackFillBufferValue(&newFilterPtr->u.filterItem.u.
                                                substrings.finalValueOption,
                                             &srcFilterPtr->u.filterItem.u.
                                                substrings.finalValueOption,
                                             extendedValuePtr,
                                             base));

            case NWDP_FILTER_PRESENT:
               return (_ASPackOctetString((pPackOctetString)&newFilterPtr->u.
                                             filterItem.u.present,
                                          (pNWDPOctetString)&srcFilterPtr->u.
                                             filterItem.u.present,
                                          extendedValuePtr,
                                          base));

            default:
               /* Should never get here */
               CiSetLastErrorMac(NDPS_E_UNDEFINED_TYPE);
               return (N_FAILURE);
         }

      case NWDP_FILTER_AND:
      case NWDP_FILTER_OR:
         /* add the length of the extended value buffers */
         index1 = srcFilterPtr->u.filterAnd.itemCount;

         srcFilterItemPtr = srcFilterPtr->u.filterAnd.itemPtr;
         newFilterItemPtr = (pPackFilter)*extendedValuePtr;
         newFilterPtr->u.filterAnd.itemCount = index1;
         newFilterPtr->u.filterAnd.itemOffset =
            ((pnuint8)newFilterItemPtr - base);

         *extendedValuePtr += index1 * sizeof(PackFilter);

         for (;
              index1;
              index1--, srcFilterItemPtr++)
         {
            if (PsmPackFilter(newFilterItemPtr,
                              srcFilterItemPtr,
                              extendedValuePtr,
                              base))
            {
               return N_FAILURE;
            }
         }

      case NWDP_FILTER_NOT:
         newFilterItemPtr = (pPackFilter)*extendedValuePtr;
         newFilterPtr->u.filterNotOffset = ((pnuint8)newFilterItemPtr - base);
         return (PsmPackFilter(newFilterItemPtr,
                               srcFilterPtr->u.filterNotPtr,
                               extendedValuePtr,
                               base));
      default:
         /* Should never get here */
         CiSetLastErrorMac(NDPS_E_UNDEFINED_TYPE);
         return (N_FAILURE);
   }
}

/*
=============================================================================
// Function Name: PsmUnpackBindPsmRes
=============================================================================
//
// Description: Unpack a Bind Psm result.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackBindPsmRes(
   pPackBindPSMResult   srcValuePtr)
{
   return(PsmUnpackBindRes(srcValuePtr, NWDP_BindPSM));
}

/*
=============================================================================
// Function Name: PsmUnpackBindPaRes
=============================================================================
//
// Description: Unpack a Bind PA result.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackBindPaRes(
   pPackBindPAResult    srcValuePtr)
{
   return(PsmUnpackBindRes((pPackBindPSMResult)srcValuePtr, NWDP_BindPA));
}

/*
=============================================================================
// Function Name: PsmUnpackBindRes
=============================================================================
//
// Description: Unpack a Bind result
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackBindRes(
   pPackBindPSMResult   srcValuePtr,
   nint                 bindOpCode)
{
   uint                 valueLen;
   pnuint8              base;
   pnuint8              newItemPtr;
   pNWDPBindPSMResult   newValuePtr;

   base = (pnuint8)srcValuePtr;

   valueLen = sizeof(NWDPBindPSMResult);
   if (_ASPackedQualifiedNameLength(&srcValuePtr->psmName, &valueLen))
      return NULL;

   newValuePtr = CiCallocMac(1, valueLen);
   if (newValuePtr == NULL)
      return NULL;

   newItemPtr = (pnuint8)newValuePtr + sizeof(NWDPBindPSMResult);

   newValuePtr->errorCode = srcValuePtr->errorCode;
   newValuePtr->sessionHandle = srcValuePtr->sessionHandle;
   newValuePtr->security = srcValuePtr->security;
   if (_ASUnpackCpQualifiedName(&newValuePtr->psmName,
                                &srcValuePtr->psmName,
                                &newItemPtr,
                                base))
      goto PsmUnpackBindResError;

   return (pnuint8)newValuePtr;

PsmUnpackBindResError:
   return NULL;
}

/*
=============================================================================
// Function Name: PsmUnpackSimpleRes
=============================================================================
//
// Description: Unpack a Simple result.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackSimpleRes(
   pPackSimpleResult     srcValuePtr)
{
   pNWDPSimpleResult     newValuePtr;

   newValuePtr = CiCallocMac(1, sizeof(NWDPSimpleResult));
   if (newValuePtr == NULL)
      return NULL;

   newValuePtr->errorCode = srcValuePtr->errorCode;
   return (pnuint8)newValuePtr;
}

/*
=============================================================================
// Function Name: PsmUnpackAccountingBindPA
=============================================================================
//
// Description: Unpack a Accounting Bind PA Request.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackAccountingBindPA(
   pAcctgBindPAArg      srcValuePtr)
{
   pAcctgBindPAArg      newValuePtr;

   newValuePtr = CiCallocMac(1, sizeof(AcctgBindPAArg));
   if (newValuePtr == NULL)
      return NULL;

   *newValuePtr = *srcValuePtr;
   return (pnuint8)newValuePtr;
}

/*
=============================================================================
// Function Name: PsmUnpackAccountingInfo
=============================================================================
//
// Description: Unpack a Accounting Info request.
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackAcctgInfo(
   pAcctgInfoArg        srcValuePtr)
{
   pAcctgInfoArg        newValuePtr;

   newValuePtr = CiCallocMac(1, sizeof(AcctgInfoArg));
   if (newValuePtr == NULL)
      return NULL;

   *newValuePtr = *srcValuePtr;
   return (pnuint8)newValuePtr;
}

/*
=============================================================================
// Function Name: PsmUnpackSimpleAttrRes
=============================================================================
//
// Description: Unpack a Simple result with an attribute set
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackSimpleAttrRes(
   pPackSimpleAttrResult   srcValuePtr)
{
   uint                    valueLen;
   pnuint8                 base;
   pnuint8                 newItemPtr;
   pNWDPSimpleAttrResult   newValuePtr;

   base = (pnuint8)srcValuePtr;

   valueLen = sizeof(NWDPSimpleAttrResult);
   if (ASPackedAttrSeqLen(&srcValuePtr->attrSet, &valueLen, base))
      return NULL;

   newValuePtr = CiCallocMac(1, valueLen);
   if (newValuePtr == NULL)
      return NULL;

   newItemPtr = (pnuint8)newValuePtr + sizeof(NWDPSimpleAttrResult);
   newValuePtr->errorCode = srcValuePtr->errorCode;
   if (srcValuePtr->attrSet.itemCount)
   {
      if (ASUnpackAttrSeq(&newValuePtr->attrSet,
                          &srcValuePtr->attrSet,
                          &newItemPtr,
                          base))
         goto PsmUnpackSimpleAttrResError;
   }

   return (pnuint8)newValuePtr;

PsmUnpackSimpleAttrResError:
   CiFreeMac(newValuePtr);
   return NULL;
}
/*
=============================================================================
// Function Name: PsmUnpackPrintRes
=============================================================================
//
// Description: Unpack a Print result
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackPrintRes(
   pPackPrintResult     srcValuePtr)
{
   uint                 valueLen;
   pnuint8              base;
   pnuint8              newItemPtr;
   pNWDPPrintResult     newValuePtr;

   base = (pnuint8)srcValuePtr;

   valueLen = sizeof(NWDPPrintResult);

   valueLen += ASAlignMac(srcValuePtr->jobIdentification.printerName.itemCount);
   valueLen += ASAlignMac(srcValuePtr->serverStateOption.oidStructSize);
   if (srcValuePtr->serverMessageOptionOffset != 0)
   {
      valueLen += sizeof(PackNameOrOid);
      if (_ASPackedNameOrOidLength((pPackNameOrOid)(srcValuePtr->
                                      serverMessageOptionOffset + base),
                                   &valueLen))
         return NULL;
   }
   if (ASPackedAttrSeqLen(&srcValuePtr->documentStatusOption, &valueLen, base))
      return NULL;
   if (ASPackedAttrSeqLen(&srcValuePtr->jobStatus, &valueLen, base))
      return NULL;

   newValuePtr = CiCallocMac(1, valueLen);
   if (newValuePtr == NULL)
      return NULL;

   newItemPtr = (pnuint8)newValuePtr + sizeof(NWDPPrintResult);
   newValuePtr->errorCode = srcValuePtr->errorCode;
   newValuePtr->jobIdentification.localIdentifier =
      srcValuePtr->jobIdentification.localIdentifier;
   if (_ASUnpackCpOctetString((pNWDPOctetString)&newValuePtr->jobIdentification.
                                 printerName,
                              (pPackOctetString)&srcValuePtr->jobIdentification.
                                 printerName,
                              &newItemPtr,
                              base))
   {
      goto PsmUnpackPrintResError;
   }

   if (_ASUnpackCpOctetString((pNWDPOctetString)&newValuePtr->serverStateOption,
                              (pPackOctetString)&srcValuePtr->serverStateOption,
                              &newItemPtr,
                              base))
   {
      goto PsmUnpackPrintResError;
   }

   if (srcValuePtr->serverMessageOptionOffset != 0)
   {
      newValuePtr->serverMessageOptionPtr = (pNWDPNameOrOid)newItemPtr;
      newItemPtr += sizeof(NWDPNameOrOid);
      if (_ASUnpackCpNameOrOid(newValuePtr->serverMessageOptionPtr,
                               (pPackNameOrOid)(srcValuePtr->
                                    serverMessageOptionOffset + base),
                               &newItemPtr,
                               base))
         goto PsmUnpackPrintResError;
   }

   if (srcValuePtr->documentStatusOption.itemCount)
   {
      if (ASUnpackAttrSeq(&newValuePtr->documentStatusOption,
                          &srcValuePtr->documentStatusOption,
                          &newItemPtr,
                          base))
         goto PsmUnpackPrintResError;
   }

   if (srcValuePtr->jobStatus.itemCount)
   {
      if (ASUnpackAttrSeq(&newValuePtr->jobStatus,
                          &srcValuePtr->jobStatus,
                          &newItemPtr,
                          base))
         goto PsmUnpackPrintResError;
   }

   return (pnuint8)newValuePtr;

PsmUnpackPrintResError:
   CiFreeMac(newValuePtr);
   return NULL;
}

/*
=============================================================================
// Function Name: PsmUnpackListAttrsRes
=============================================================================
//
// Description: Unpack a ListAttrs result
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackListAttrsRes(
   pPackListObjectAttrsResult srcValuePtr)
{
   uint                       index1;
   uint                       valueLen;
   pnuint8                    base;
   pnuint8                    newItemPtr;
   pPackObjectResult          srcObjectResultPtr;
   pNWDPObjectResult          newObjectResultPtr;
   pNWDPListObjectAttrsResult newValuePtr;

   base = (pnuint8)srcValuePtr;

   valueLen = sizeof(NWDPListObjectAttrsResult);
   valueLen += ASAlignMac(srcValuePtr->continuationOption.itemCount);
   index1 = srcValuePtr->resultSet.itemCount;
   if (index1 != 0)
   {
      valueLen += srcValuePtr->resultSet.itemCount * sizeof(NWDPObjectResult);
      for (srcObjectResultPtr =
               (pPackObjectResult)(srcValuePtr->resultSet.itemOffset + base);
           index1;
           index1--, srcObjectResultPtr++)
      {
         if (_ASPackedObjectIdentificationLength(&srcObjectResultPtr->
                                                   objectIdentification,
                                                 &valueLen))
         {
            return NULL;
         }

         if (ASPackedAttrSeqLen(&srcObjectResultPtr->attributes, &valueLen, base))
            return NULL;
         valueLen += ASAlignMac(srcObjectResultPtr->objectClass.oidStructSize);
      }
   }

   newValuePtr = CiUnlimitedCallocMac(1, valueLen);
   if (newValuePtr == NULL)
      return NULL;

   newItemPtr = (pnuint8)newValuePtr + sizeof(NWDPListObjectAttrsResult);
   newValuePtr->errorCode = srcValuePtr->errorCode;
   newValuePtr->answerTime = srcValuePtr->answerTime;

   if (_ASUnpackCpOctetString(&newValuePtr->continuationOption,
                              &srcValuePtr->continuationOption,
                              &newItemPtr,
                              base))
   {
      goto PsmUnpackListAttrsResError;
   }

   index1 = srcValuePtr->resultSet.itemCount;
   if (index1 != 0)
   {
      newObjectResultPtr = (pNWDPObjectResult)newItemPtr;
      newValuePtr->resultSet.itemPtr = newObjectResultPtr;
      newValuePtr->resultSet.itemCount = index1;
      newItemPtr += index1 * sizeof(NWDPObjectResult);

      for (srcObjectResultPtr =
               (pPackObjectResult)(srcValuePtr->resultSet.itemOffset + base);
           index1;
           index1--, srcObjectResultPtr++, newObjectResultPtr++)
      {
         if (_ASUnpackCpObjectIdentification(&newObjectResultPtr->
                                                objectIdentification,
                                             &srcObjectResultPtr->
                                                objectIdentification,
                                             &newItemPtr,
                                             base))
         {
            goto PsmUnpackListAttrsResError;
         }

         if (ASUnpackAttrSeq(&newObjectResultPtr->attributes,
                             &srcObjectResultPtr->attributes,
                             &newItemPtr,
                             base))
            goto PsmUnpackListAttrsResError;

         if (_ASUnpackCpOctetString((pNWDPOctetString)&newObjectResultPtr->
                                       objectClass,
                                    (pPackOctetString)&srcObjectResultPtr->
                                       objectClass,
                                    &newItemPtr,
                                    base))
            goto PsmUnpackListAttrsResError;
      }
   }

   return (pnuint8)newValuePtr;

PsmUnpackListAttrsResError:
   CiFreeMac(newValuePtr);
   return NULL;
}

/*
=============================================================================
// Function Name: PsmUnpackCreateRes
=============================================================================
//
// Description: Unpack a Create result
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackCreateRes(
   pPackCreateResult    srcValuePtr)
{
  return(PsmUnpackSimpleAttrRes((pPackSimpleAttrResult)srcValuePtr));
}

/*
=============================================================================
// Function Name: PsmUnpackDeleteRes
=============================================================================
//
// Description: Unpack a Delete result
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackDeleteRes(
   pPackDeleteResult    srcValuePtr)
{
  return(PsmUnpackSimpleAttrRes((pPackSimpleAttrResult)srcValuePtr));
}

/*
=============================================================================
// Function Name: PsmUnpackSetRes
=============================================================================
//
// Description: Unpack a Set result
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackSetRes(
   pPackSetResult       srcValuePtr)
{
   return (PsmUnpackSimpleRes((pPackSimpleResult)srcValuePtr));
}

/*
=============================================================================
// Function Name: PsmUnpackTransferDataRes
=============================================================================
//
// Description: Unpack a TransferData result
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
pnuint8 PsmUnpackTransferDataRes(
   pPackTransferDataResult srcValuePtr)
{
   return (PsmUnpackSimpleRes((pPackSimpleResult)srcValuePtr));
}

/*
=============================================================================
// Function Name: PsmUnpackAttribute
=============================================================================
//
// Description: Unpack a attribute structure
//
=============================================================================
//
// Returns: N_SUCCESS
//          N_FAILURE
//
=============================================================================
//
// Assumptions: None.
//
=============================================================================
*/
// int PsmUnpackAttribute(
//    pNWDPAttribute       srcAttrPtr,
//    pnuint8              base)
// {
//    AttrSetAVPStruct     tmpAvp;
//    nuint                index1;
//    pNWDPAttributeValue  srcValuePtr;
//
//    srcAttrPtr->attributeId.oidStructPtr =
//       (pNWDPOid)((pnuint8)srcAttrPtr->attributeId.oidStructPtr + base);
//
//    /* pack each value item */
//    index1 = srcAttrPtr->valueSet.itemCount;
//    if (index1 == 0)
//    {
//       srcAttrPtr->valueSet.itemPtr = NULL;
//       return N_SUCCESS;
//    }
//
//    srcAttrPtr->valueSet.itemPtr =
//       (pNWDPAttributeValue)((pnuint8)srcAttrPtr->valueSet.itemPtr + base);
//    srcValuePtr = srcAttrPtr->valueSet.itemPtr;
//
//    for (;
//         index1;
//         index1--, srcValuePtr++)
//    {
//       /* copy the value */
//       if (ASUnpackValue(srcValuePtr, base))
//          return (N_FAILURE);
//    }
//
//    return N_SUCCESS;
// }
/* ************************** end of psmpackc.c ************************** */
