/*
//+==========================================================================+
//| Copyright (c) 1994 - 2017 Unpublished Work of Novell, Inc.               |
//| All rights reserved.                                                     |
//|                                                                          |
//| THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL, PROPRIETARY  |
//| AND TRADE SECRET INFORMATION OF NOVELL, INC.                             |
//|                                                                          |
//| ACCESS TO THIS WORK IS RESTRICTED TO (I) NOVELL EMPLOYEES WHO HAVE A     |
//| NEED TO KNOW HOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS  |
//| AND (II) ENTITIES OTHER THAN NOVELL, INC. WHO HAVE ENTERED INTO          |
//| APPROPRIATE LICENSE AGREEMENTS.                                          |
//|                                                                          |
//| NO PART OF THIS WORK MAY BE USED, PRACTICED, PERFORMED, COPIED,          |
//| DISTRIBUTED, REVISED, MODIFIED, TRANSLATED, ABRIDGED, CONDENSED,         |
//| EXPANDED, COLLECTED, COMPILED, LINKED, RECAST, TRANSFORMED OR ADAPTED    |
//| WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC.                        |
//|                                                                          |
//| ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT |
//| THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.                         |
//+==========================================================================+
//| Source module name: cirstclnt.h                                          |
//+==========================================================================+
//  Created on: Feb 10, 2017
//  Author: SPritamPal
*/

#ifndef CI_REST_CLIENT_H_
#define CI_REST_CLIENT_H_

#include <stdio.h>
#include <time.h>

#define N_TRUE 1
#define N_FALSE 0

typedef struct {
    unsigned int curlErrorCode;
    unsigned int curlHttpErrorCode;
}RestCallStatus, *pRestCallStatus;

enum RequestMethod {
    GET=0,
    POST,
    PUT,
    DELETE,
    PATCH
};
                
typedef struct {
    enum RequestMethod requestMethod;
    char *contentType;
    short secure;
    char *restUrl;
    char *data;
    size_t (*WriteDataFunc)(void *, size_t, size_t, void *);
}RestCallInfo, *pRestCallInfo;

typedef struct{
    const char *dataptr;
    long bytesleft;
}DataToSend, *pDataToSend;

void NotifyMobileServer(enum RequestMethod, char *);
RestCallStatus MakeRestCall(pRestCallInfo rci);
void NotifyMobileServerPSMStartedOrStopped(char*, char*);

#endif /* CI_REST_CLIENT_H_ */

